/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         smiparse
#define yylex           smilex
#define yyerror         smierror
#define yydebug         smidebug
#define yynerrs         sminerrs

/* First part of user prologue.  */
#line 17 "parser-smi.y"


#include <config.h>
    
#ifdef BACKEND_SMI

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <limits.h>

#if defined(_MSC_VER)
#include <malloc.h>
#endif

#include "smi.h"
#include "error.h"
#include "parser-smi.h"
#include "scanner-smi.h"
#include "smi-data.h"
#include "smi-check.h"
#include "util.h"
    
#ifdef HAVE_DMALLOC_H
#include <dmalloc.h>
#endif


#define thisParserPtr      ((Parser *)parserPtr)
#define thisModulePtr     (((Parser *)parserPtr)->modulePtr)


    
/*
 * NOTE: The argument lvalp is not really a void pointer. Unfortunately,
 * we don't know it better at this point. bison generated C code declares
 * YYSTYPE just a few lines below based on the `%union' declaration.
 */
extern int yylex(void *lvalp, Parser *parserPtr);



static int	   impliedFlag;
static SmiNodekind variationkind;
static SmiBasetype defaultBasetype;
static int	   indexFlag;

/*
 * Values for the indexFlag variable
 */
#define INDEXFLAG_NONE     0
#define INDEXFLAG_PIBINDEX 1
#define INDEXFLAG_AUGMENTS 2
#define INDEXFLAG_EXTENDS  3
 

#define SMI_EPOCH	631152000	/* 01 Jan 1990 00:00:00 */ 

 

static char *convertImportv2[] = {
    "RFC1155-SMI", "internet",	    "SNMPv2-SMI", "internet",
    "RFC1155-SMI", "directory",	    "SNMPv2-SMI", "directory",
    "RFC1155-SMI", "mgmt",	    "SNMPv2-SMI", "mgmt",
    "RFC1155-SMI", "experimental",  "SNMPv2-SMI", "experimental",
    "RFC1155-SMI", "private",	    "SNMPv2-SMI", "private",
    "RFC1155-SMI", "enterprises",   "SNMPv2-SMI", "enterprises",
    "RFC1155-SMI", "IpAddress",     "SNMPv2-SMI", "IpAddress",
    "RFC1155-SMI", "Counter",       "SNMPv2-SMI", "Counter32",
    "RFC1155-SMI", "Gauge",         "SNMPv2-SMI", "Gauge32",
    "RFC1155-SMI", "TimeTicks",     "SNMPv2-SMI", "TimeTicks",
    "RFC1155-SMI", "Opaque",        "SNMPv2-SMI", "Opaque",
    "RFC1065-SMI", "internet",	    "SNMPv2-SMI", "internet",
    "RFC1065-SMI", "directory",	    "SNMPv2-SMI", "directory",
    "RFC1065-SMI", "mgmt",	    "SNMPv2-SMI", "mgmt",
    "RFC1065-SMI", "experimental",  "SNMPv2-SMI", "experimental",
    "RFC1065-SMI", "private",	    "SNMPv2-SMI", "private",
    "RFC1065-SMI", "enterprises",   "SNMPv2-SMI", "enterprises",
    "RFC1065-SMI", "IpAddress",     "SNMPv2-SMI", "IpAddress",
    "RFC1065-SMI", "Counter",       "SNMPv2-SMI", "Counter32",
    "RFC1065-SMI", "Gauge",         "SNMPv2-SMI", "Gauge32",
    "RFC1065-SMI", "TimeTicks",     "SNMPv2-SMI", "TimeTicks",
    "RFC1065-SMI", "Opaque",        "SNMPv2-SMI", "Opaque",
    "RFC1213-MIB", "mib-2",         "SNMPv2-SMI", "mib-2",    
    "RFC1213-MIB", "DisplayString", "SNMPv2-TC",  "DisplayString",    
    NULL, NULL, NULL, NULL
};



static void
checkDescr(Parser *parser, char *descr)
{
    if (descr) {
	if (descr[0] == 0) {
	    smiPrintError(parser, ERR_EMPTY_DESCRIPTION);
	}
	/* we might want to add more checks since I have recently
	   seen things like DESCRIPTION "." to cirumvent warnings */
    }
}
 

 
static void
checkNameLen(Parser *parser, char *name, int error_32, int error_64)
{
    int len = strlen(name);
    
    if (len > 64) {
	smiPrintError(parser, error_64, name);
    } else if (len > 32) {
	smiPrintError(parser, error_32, name);
    }
}


 
static void
checkModuleName(Parser *parserPtr, Module *modulePtr)
{
     static char *mib_ignore[] = {
	 "SNMPv2-SMI", "SNMPv2-TC", "SNMPv2-CONF", NULL
     };
     
     static char *pib_ignore[] = {
	 "COPS-PR-SPPI", "COPS-PR-SPPI-TC",
	 "SNMPv2-SMI", "SNMPv2-TC", "SNMPv2-CONF", NULL
     };

     const char *name = thisModulePtr->export.name;
     const int len = strlen(name);
     int i;

     switch (modulePtr->export.language) {
     case SMI_LANGUAGE_SMIV1:
     case SMI_LANGUAGE_SMIV2:
     case SMI_LANGUAGE_SMING:
	 for (i = 0; mib_ignore[i]; i++) {
	     if (strcmp(mib_ignore[i], name) == 0) {
		 return;
	     }
	 }
	 if (len > 3 && (strcmp(name + len - 4, "-MIB") != 0)) {
	     smiPrintError(parserPtr, ERR_MIB_MODULENAME_SUFFIX, name);
	     return;
	 }
	 break;
     case SMI_LANGUAGE_SPPI:
	 for (i = 0; pib_ignore[i]; i++) {
	     if (strcmp(pib_ignore[i], name) == 0) {
		 return;
	     }
	 }
	 if (len > 3 && (strcmp(name + len - 4, "-PIB") != 0)) {
	     smiPrintError(parserPtr, ERR_PIB_MODULENAME_SUFFIX, name);
	 }
	 break;
     case SMI_LANGUAGE_YANG:
     case SMI_LANGUAGE_UNKNOWN:
	 break;
     }
}



static void
checkModuleIdentity(Parser *parserPtr, Module *modulePtr)
{
    if ((modulePtr->export.language == SMI_LANGUAGE_SMIV2)
	&& (modulePtr->numModuleIdentities < 1)
	&& strcmp(modulePtr->export.name, "SNMPv2-SMI")
	&& strcmp(modulePtr->export.name, "SNMPv2-CONF")
	&& strcmp(modulePtr->export.name, "SNMPv2-TC")
        && strcmp(modulePtr->export.name, "COPS-PR-SPPI")) {
	smiPrintError(parserPtr, ERR_NO_MODULE_IDENTITY);
    }
}



static void
checkObjects(Parser *parserPtr, Module *modulePtr)
{
    Object *objectPtr;
    Node *nodePtr;
    int i;
    Type *counterTypePtr, *counter32TypePtr, *counter64TypePtr;
    
    counterTypePtr = findTypeByName("Counter");
    counter32TypePtr = findTypeByModulenameAndName("SNMPv2-SMI", "Counter32");
    counter64TypePtr = findTypeByModulenameAndName("SNMPv2-SMI", "Counter64");
    
    for (objectPtr = modulePtr->firstObjectPtr;
	 objectPtr; objectPtr = objectPtr->nextPtr) {

	Object *parentPtr;
	
	if ((objectPtr->export.decl != SMI_DECL_UNKNOWN) &&
	    objectPtr->nodePtr->parentPtr &&
	    objectPtr->nodePtr->parentPtr->lastObjectPtr) {
	    parentPtr = objectPtr->nodePtr->parentPtr->lastObjectPtr;
	} else {
	    parentPtr = NULL;
	}

	/*
	 * Set nodekinds of all newly defined objects.
	 */
	
	if (objectPtr->export.decl == SMI_DECL_MODULEIDENTITY) {
	    objectPtr->export.nodekind = SMI_NODEKIND_NODE;
	} else if ((objectPtr->export.decl == SMI_DECL_VALUEASSIGNMENT) ||
		   (objectPtr->export.decl == SMI_DECL_OBJECTIDENTITY)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_NODE;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
		   (objectPtr->typePtr) &&
		   (objectPtr->typePtr->export.decl == SMI_DECL_IMPL_SEQUENCEOF)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_TABLE;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
		   ((objectPtr->export.indexkind != SMI_INDEX_UNKNOWN)
		    || (parentPtr
			&& parentPtr->export.nodekind == SMI_NODEKIND_TABLE))) {
	    objectPtr->export.nodekind = SMI_NODEKIND_ROW;
	} else if ((objectPtr->export.decl == SMI_DECL_NOTIFICATIONTYPE) ||
		   (objectPtr->export.decl == SMI_DECL_TRAPTYPE)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_NOTIFICATION;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTGROUP) ||
		   (objectPtr->export.decl == SMI_DECL_NOTIFICATIONGROUP)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_GROUP;
	} else if (objectPtr->export.decl == SMI_DECL_MODULECOMPLIANCE) {
	    objectPtr->export.nodekind = SMI_NODEKIND_COMPLIANCE;
	} else if (objectPtr->export.decl == SMI_DECL_AGENTCAPABILITIES) {
	    objectPtr->export.nodekind = SMI_NODEKIND_CAPABILITIES;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
		   (parentPtr) &&
		   ((parentPtr->export.indexkind != SMI_INDEX_UNKNOWN)
		    || (parentPtr
			&& parentPtr->export.nodekind == SMI_NODEKIND_ROW))) {
	    objectPtr->export.nodekind = SMI_NODEKIND_COLUMN;
	} else if ((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
		   (parentPtr) &&
		   (parentPtr->export.indexkind == SMI_INDEX_UNKNOWN)) {
	    objectPtr->export.nodekind = SMI_NODEKIND_SCALAR;
	}
    }

    for (objectPtr = modulePtr->firstObjectPtr;
	 objectPtr; objectPtr = objectPtr->nextPtr) {

	Object *parentPtr;
	
	if (objectPtr->nodePtr->parentPtr &&
	    objectPtr->nodePtr->parentPtr->lastObjectPtr) {
	    parentPtr = objectPtr->nodePtr->parentPtr->lastObjectPtr;
	} else {
	    parentPtr = NULL;
	}

	/*
	 * Check whether the associated type resolves to a known base type.
	 */
	
	if (objectPtr->typePtr
	    && (objectPtr->export.nodekind == SMI_NODEKIND_COLUMN
		|| objectPtr->export.nodekind == SMI_NODEKIND_SCALAR)
	    && objectPtr->typePtr->export.basetype == SMI_BASETYPE_UNKNOWN) {
	    smiPrintErrorAtLine(parserPtr, ERR_BASETYPE_UNKNOWN,
				objectPtr->line,
				objectPtr->typePtr->export.name ?
				objectPtr->typePtr->export.name : "[unknown]",
				objectPtr->export.name);
	}

	/*
	 * Mark types that are referenced in this module.
	 */

	if (objectPtr->typePtr
	    && (objectPtr->export.nodekind == SMI_NODEKIND_COLUMN
		|| objectPtr->export.nodekind == SMI_NODEKIND_SCALAR)
	    && (objectPtr->typePtr->export.decl == SMI_DECL_TYPEDEF
		|| objectPtr->typePtr->export.decl == SMI_DECL_TEXTUALCONVENTION
		|| objectPtr->typePtr->export.decl == SMI_DECL_IMPLICIT_TYPE)) {
	    addTypeFlags(objectPtr->typePtr, FLAG_INSYNTAX);
	    if (objectPtr->typePtr->export.decl == SMI_DECL_IMPLICIT_TYPE) {
		addTypeFlags(objectPtr->typePtr->parentPtr, FLAG_INSYNTAX);
	    }
	}
	
	/*
	 * Check whether the status of the associated type matches the
	 * status of the object.
	 */

	if (objectPtr->typePtr
	    && (objectPtr->export.nodekind == SMI_NODEKIND_COLUMN
		|| objectPtr->export.nodekind == SMI_NODEKIND_SCALAR)
	    && (objectPtr->export.status < objectPtr->typePtr->export.status)) {
	    if (objectPtr->typePtr->export.status == SMI_STATUS_DEPRECATED) {
		smiPrintErrorAtLine(parserPtr, ERR_TYPE_STATUS_DEPRECATED,
				    objectPtr->line,
				    objectPtr->typePtr->export.name,
				    objectPtr->export.name);
	    }
	    if (objectPtr->typePtr->export.status == SMI_STATUS_OBSOLETE) {
		smiPrintErrorAtLine(parserPtr, ERR_TYPE_STATUS_OBSOLETE,
				    objectPtr->line,
				    objectPtr->typePtr->export.name,
				    objectPtr->export.name);
	    }
	}

	/*
	 * Check the nodekind of the parent node.
	 */

	if (parentPtr) {
	    switch (objectPtr->export.nodekind) {
	    case SMI_NODEKIND_COLUMN:
		if (parentPtr->export.nodekind != SMI_NODEKIND_ROW) {
		    smiPrintErrorAtLine(parserPtr, ERR_COLUMN_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_ROW:
		if (parentPtr->export.nodekind != SMI_NODEKIND_TABLE) {
		    smiPrintErrorAtLine(parserPtr, ERR_ROW_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		if (parentPtr->typePtr && parentPtr->typePtr->parentPtr &&
		    strcmp(parentPtr->typePtr->parentPtr->export.name,
			   objectPtr->typePtr->export.name)) {
		    smiPrintErrorAtLine(parserPtr, ERR_TABLE_ROW_TYPE_MISMATCH,
					objectPtr->line,
					objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_TABLE:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_TABLE_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_SCALAR:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_SCALAR_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_NOTIFICATION:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_NODE) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN)) {
		    smiPrintErrorAtLine(parserPtr, ERR_NOTIFICATION_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		if (parserPtr && parentPtr->nodePtr->parentPtr &&
		    parentPtr->nodePtr->parentPtr->lastObjectPtr) {
		    Object *parent2Ptr = parentPtr->nodePtr->parentPtr->lastObjectPtr;
		    if ((parent2Ptr->export.nodekind != SMI_NODEKIND_NODE) &&
			(parent2Ptr->export.nodekind != SMI_NODEKIND_UNKNOWN)) {
			smiPrintErrorAtLine(parserPtr,
					    ERR_NOTIFICATION_PARENT_TYPE,
					    objectPtr->line,
					    objectPtr->export.name);
		    }
		}
		break;
	    case SMI_NODEKIND_NODE:
		/* Node defined by OBJECT IDENTIFIER assignments can have
		   arbitrary parent node. */
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE) &&
		    (objectPtr->export.decl != SMI_DECL_VALUEASSIGNMENT)) {
		    smiPrintErrorAtLine(parserPtr, ERR_NODE_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_GROUP:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_GROUP_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_COMPLIANCE:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_COMPLIANCE_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    case SMI_NODEKIND_CAPABILITIES:
		if ((parentPtr->export.nodekind != SMI_NODEKIND_UNKNOWN) &&
		    (parentPtr->export.nodekind != SMI_NODEKIND_NODE)) {
		    smiPrintErrorAtLine(parserPtr, ERR_CAPABILITIES_PARENT_TYPE,
					objectPtr->line, objectPtr->export.name);
		}
		break;
	    }
	}

	/*
	 * Check whether a row has only object-type children and
	 * that their types are consistent with the type of the
	 * row.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_ROW) {
	    smiCheckRowMembers(parserPtr, objectPtr);
	}
	
	/*
	 * Check whether groups only contain scalars, columns and
	 * notifications.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_GROUP) {
	    smiCheckGroupMembers(parserPtr, objectPtr);
	}

	/*
	 * Check whether compliance statements contain out of date
	 * groups or objects.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_COMPLIANCE) {
	    smiCheckComplianceStatus(parserPtr, objectPtr);
	}

	/*
	 * Check whether notification statements contain useful
	 * objects.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_NOTIFICATION) {
	    smiCheckNotificationOid(parserPtr, modulePtr, objectPtr);
	    smiCheckNotificationMembers(parserPtr, objectPtr);
	}

        if (modulePtr->export.language != SMI_LANGUAGE_SPPI) {
	    /*
	     * Check whether tables and rows are not accessible
	     * (RFC 2578 7.1.12).
	     */

	    if (objectPtr->export.nodekind == SMI_NODEKIND_TABLE
	        && objectPtr->export.access != SMI_ACCESS_NOT_ACCESSIBLE) {
	        smiPrintErrorAtLine(parserPtr, ERR_TABLE_ACCESS,
				    objectPtr->line, objectPtr->export.name);
	    }

	    if (objectPtr->export.nodekind == SMI_NODEKIND_ROW
	        && objectPtr->export.access != SMI_ACCESS_NOT_ACCESSIBLE) {
	        smiPrintErrorAtLine(parserPtr, ERR_ROW_ACCESS,
				    objectPtr->line, objectPtr->export.name);
	    }

	    /*
	     * Check whether counter objects are read-only or
	     * accessible-for-notify (RFC 2578, 7.1.6).
	     */
	    if (((objectPtr->export.nodekind == SMI_NODEKIND_SCALAR) ||
		 (objectPtr->export.nodekind == SMI_NODEKIND_COLUMN)) &&
	        (objectPtr->export.access != SMI_ACCESS_NOTIFY) &&
		(objectPtr->export.access != SMI_ACCESS_READ_ONLY) &&
		(smiTypeDerivedFrom(objectPtr->typePtr, counterTypePtr) ||
		 smiTypeDerivedFrom(objectPtr->typePtr, counter32TypePtr) ||
		 smiTypeDerivedFrom(objectPtr->typePtr, counter64TypePtr))) {
	        smiPrintErrorAtLine(parserPtr, ERR_COUNTER_ACCESS,
				    objectPtr->line, objectPtr->export.name);
	    }
        }
	
	/*
	 * Check whether a row's subid is 1, see RFC 2578 7.10 (1).
	 */
	
	if (objectPtr->export.nodekind == SMI_NODEKIND_ROW) {
	    int len;
	    
	    if (objectPtr->nodePtr->subid != 1) {
		smiPrintErrorAtLine(parserPtr, ERR_ROW_SUBID_ONE,
				    objectPtr->line, objectPtr->export.name);
	    }

	    len = strlen(objectPtr->export.name);
	    if (len < 6 || strcmp(objectPtr->export.name+len-5, "Entry")) {
		smiPrintErrorAtLine(parserPtr, ERR_ROWNAME_ENTRY,
				    objectPtr->line, objectPtr->export.name);
	    } else {

		/*
		 * This misreports some cases where the table name
		 * does not have the "*Table" suffix.  This is trying
		 * to allow Entry names of either fooTableEntry or
		 * fooEntry.
		 */
		if (parentPtr &&
		    !(((int)strlen(parentPtr->export.name) == len ||
		       (int)strlen(parentPtr->export.name) == len - 5) &&
		      !strncmp(objectPtr->export.name, parentPtr->export.name,
			len - 5))) {
		    smiPrintErrorAtLine(parserPtr, ERR_ROWNAME_TABLENAME,
					objectPtr->line,
					objectPtr->export.name,
					parentPtr->export.name);
		}
	    }
	}

	/*
	 * Check whether a row's SEQUENCE contains exactly the list
	 * of child nodes (columns).  An unknown SEQUENCE type
	 * is handled later.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_ROW &&
	    ((objectPtr->typePtr->flags & FLAG_INCOMPLETE) == 0)) {
	    List *p;
	    Node *seqNodePtr, *childNodePtr;
	    Object *colPtr;
	    int i;
	    
	    /*
	     * Walk through the SEQUENCE elements and find those
	     * that are misordered or have no matching columnar object.
	     */
	    for (p = objectPtr->typePtr->listPtr, i = 1,
		     childNodePtr = objectPtr->nodePtr->firstChildPtr;
		 p && childNodePtr;
		 p = p->nextPtr, childNodePtr = childNodePtr->nextPtr, i++) {
		seqNodePtr = ((Object *)p->ptr)->nodePtr;

		if (seqNodePtr->parentPtr != childNodePtr->parentPtr) {
		    smiPrintErrorAtLine(parserPtr, ERR_SEQUENCE_NO_COLUMN,
					objectPtr->typePtr->line,
					i,
					((Object *)p->ptr)->export.name,
					objectPtr->export.name);
		    continue;
		}

		if (seqNodePtr != childNodePtr) {
		    smiPrintErrorAtLine(parserPtr, ERR_SEQUENCE_ORDER,
					objectPtr->typePtr->line,
					i,
					((Object *)p->ptr)->export.name,
					objectPtr->export.name);
		    break;
		}
	    }
	    if ((p != NULL) && (childNodePtr == NULL)) {
		smiPrintErrorAtLine(parserPtr, ERR_SEQUENCE_NO_COLUMN,
				    objectPtr->typePtr->line,
				    i, 
				    ((Object *)p->ptr)->export.name,
				    objectPtr->export.name);
	    }

	    /*
	     * Walk through all child objects and find those
	     * that were missing in the SEQUENCE.
	     */
	    for (childNodePtr = objectPtr->nodePtr->firstChildPtr;
		 childNodePtr; childNodePtr = childNodePtr->nextPtr) {
		colPtr = findObjectByModuleAndNode(modulePtr, childNodePtr);
		if (!colPtr) continue;
		for (p = objectPtr->typePtr->listPtr; p; p = p->nextPtr) {
		    if (((Object *)p->ptr)->nodePtr == colPtr->nodePtr)
			break;
		}
		if (!p) {
		    if (colPtr->export.name) {
			/*
			 * Don't complain, if it's an implcitly defined
			 * unnamed node (could happen for parent node of
			 * TRAP-TYPE definitions).
			 */
			smiPrintErrorAtLine(parserPtr,
					    ERR_SEQUENCE_MISSING_COLUMN,
					    objectPtr->typePtr->line,
					    objectPtr->typePtr->export.name,
					    colPtr->export.name);
		    }
		}
	    }
	    
	}
	
	if (objectPtr->export.nodekind == SMI_NODEKIND_TABLE) {
	    int len;

	    len = strlen(objectPtr->export.name);
	    if (len < 6 || strcmp(objectPtr->export.name+len-5, "Table")) {
		smiPrintErrorAtLine(parserPtr, ERR_TABLENAME_TABLE,
				    objectPtr->line, objectPtr->export.name);
	    }
	}

	/*
	 * TODO: check whether the row is the only node below the
         * table node
	 */

	/*
	 * Check references to unknown identifiers.
	 */

	if ((objectPtr->flags & FLAG_INCOMPLETE) &&
	    (objectPtr->export.decl != SMI_DECL_IMPL_OBJECT)) {
	    if (objectPtr->export.name) {
		smiPrintErrorAtLine(parserPtr, ERR_UNKNOWN_OIDLABEL,
				    objectPtr->line, objectPtr->export.name);
	    } else {
		smiPrintErrorAtLine(parserPtr, ERR_IMPLICIT_NODE,
				    objectPtr->line);
	    }
	}

	/*
	 * Adjust the status of implicit type definitions.
	 */
	
	if (objectPtr->typePtr
	    && (objectPtr->typePtr->export.decl == SMI_DECL_IMPLICIT_TYPE)
	    && (objectPtr->typePtr->export.status == SMI_STATUS_UNKNOWN)) {
	    objectPtr->typePtr->export.status = objectPtr->export.status;
	}

	/*
	 * Link implicit type definition from refinements into
	 * the type derivation tree. Adjust the status of implicit
	 * type definitions in refinements. 
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_COMPLIANCE) {

	    List *listPtr;

	    for (listPtr = objectPtr->refinementlistPtr;
		 listPtr;
		 listPtr = listPtr->nextPtr) {

		Refinement *refinementPtr;
		Type *typePtr;
		
		refinementPtr = ((Refinement *)(listPtr->ptr));
		typePtr = refinementPtr->typePtr;
		if (typePtr) {
		    if (typePtr->export.status == SMI_STATUS_UNKNOWN) {
			typePtr->export.status = objectPtr->export.status;
		    }
		}

		typePtr = refinementPtr->writetypePtr;
		if (typePtr) {
		    if (typePtr->export.status == SMI_STATUS_UNKNOWN) {
			typePtr->export.status = objectPtr->export.status;
		    }
		}
		
	    }
	    /* relocate the refinement type into the type tree */
	    /* relocate the write refinement type into the type tree */
	}

	/*
	 * Set the oidlen/oid values that are not yet correct.
	 */

	if (objectPtr->export.oidlen == 0) {
	    if (objectPtr->nodePtr->oidlen == 0) {
		for (nodePtr = objectPtr->nodePtr, i = 1;
		     nodePtr->parentPtr != thisParserPtr->pendingNodePtr &&
			 nodePtr->parentPtr != smiHandle->rootNodePtr &&
			 nodePtr != nodePtr->parentPtr &&
			 nodePtr->parentPtr != NULL &&
			 i <= 128;
		     nodePtr = nodePtr->parentPtr, i++);
		if ((objectPtr->export.name) &&
		    ((i > 128) || (nodePtr == nodePtr->parentPtr))) {
		    smiPrintErrorAtLine(parserPtr, ERR_OID_RECURSIVE,
					objectPtr->line,
					objectPtr->export.name);
		}
		objectPtr->nodePtr->oid = smiMalloc(i * sizeof(SmiSubid));
		objectPtr->nodePtr->oidlen = i;
		for (nodePtr = objectPtr->nodePtr; i > 0; i--) {
		    objectPtr->nodePtr->oid[i-1] = nodePtr->subid;
		    nodePtr = nodePtr->parentPtr;
		}
	    }
	    objectPtr->export.oidlen = objectPtr->nodePtr->oidlen;
	    objectPtr->export.oid = objectPtr->nodePtr->oid;
	}

	if ((objectPtr->export.decl != SMI_DECL_UNKNOWN)
	    && (objectPtr->export.nodekind != SMI_NODEKIND_NODE)
	    && (objectPtr->export.nodekind != SMI_NODEKIND_UNKNOWN)
	    && objectPtr->export.name
	    && objectPtr->export.oid[objectPtr->export.oidlen-1] == 0
	    && objectPtr->export.oidlen != 2 && objectPtr->export.oid[0] != 0) {
	    smiPrintErrorAtLine(parserPtr, ERR_OID_ADMIN_ZERO,
				objectPtr->line,
				objectPtr->export.name);
	}

	/*
	 * Check whether the module identity is registered in a well
	 * known controlled location. 
	 */

	if (objectPtr->export.decl == SMI_DECL_MODULEIDENTITY) {
	    smiCheckModuleIdentityRegistration(parserPtr, objectPtr);
	}

	/*
	 * Check table linkage constraints for row objects.
	 */

	if (objectPtr->export.nodekind == SMI_NODEKIND_ROW) {
	    switch (objectPtr->export.indexkind) {
	    case SMI_INDEX_INDEX:
		smiCheckIndex(parserPtr, objectPtr);
		break;
	    case SMI_INDEX_AUGMENT:
            case SMI_INDEX_SPARSE:
		smiCheckAugment(parserPtr, objectPtr);
		break;
	    case SMI_INDEX_UNKNOWN:
		smiPrintErrorAtLine(parserPtr, ERR_INDEX_MISSING,
				    objectPtr->line,
				    objectPtr->export.name);
		break;
	    default:
		break;
	    }
	}
	
	/*
	 * Determine the longest common OID prefix of all nodes.
	 */

	if (!modulePtr->prefixNodePtr) {
	    modulePtr->prefixNodePtr = objectPtr->nodePtr;
	} else {
	    if (objectPtr->nodePtr->oidlen < modulePtr->prefixNodePtr->oidlen) {
		Node *nodePtr = findNodeByOid(objectPtr->nodePtr->oidlen,
					      modulePtr->prefixNodePtr->oid);
		if (nodePtr)
		    modulePtr->prefixNodePtr = nodePtr;
		else
		    smiPrintError(parserPtr, ERR_OTHER_ERROR,
				  "Failed to create complete object tree - "
				  "expect incorrect output");
	    }
	    for (i = 0; i < modulePtr->prefixNodePtr->oidlen; i++) {
		if (modulePtr->prefixNodePtr->oid[i] !=
		    objectPtr->nodePtr->oid[i]) {
		    modulePtr->prefixNodePtr =
			findNodeByOid(i, modulePtr->prefixNodePtr->oid);
		    break;
		}
	    }
	}
    }

    if (modulePtr->export.language == SMI_LANGUAGE_SMIV2) {
	for (objectPtr = modulePtr->firstObjectPtr;
	     objectPtr; objectPtr = objectPtr->nextPtr) {
	    
	    /*
	     * Check whether all objects and notifications are contained in at
	     * least one conformance group (RFC 2580 3.3 and 4.1).
	     */
	    
	    smiCheckGroupMembership(parserPtr, objectPtr);
	}
    }

    if (modulePtr->export.language == SMI_LANGUAGE_SPPI) {
        Object *parentPtr;
        
        for (objectPtr = modulePtr->firstObjectPtr;
             objectPtr; objectPtr = objectPtr->nextPtr) {
            /*
             * All checks for SPPI constructs
             */
            if (objectPtr->nodePtr->parentPtr)
                parentPtr = objectPtr->nodePtr->parentPtr->lastObjectPtr;
            else
                parentPtr = NULL;
            
            /*
             * Do all rows contain a PIB-INDEX/AUGMENTS/EXTENDS ?
             * See RFC 3159 7.5, 7.7, 7.8
             */
            if (parentPtr  &&
                (parentPtr->export.nodekind == SMI_NODEKIND_TABLE) &&
                (objectPtr->export.indexkind != SMI_INDEX_INDEX) &&
                (objectPtr->export.indexkind != SMI_INDEX_AUGMENT) &&
                (objectPtr->export.indexkind != SMI_INDEX_SPARSE))
                smiPrintErrorAtLine(parserPtr, ERR_ROW_LACKS_PIB_INDEX,
                                    objectPtr->line);

            /*
             * Does any non row contain a PIB-INDEX/AUGMENTS/EXTENDS ?
             * See RFC 3159 7.5, 7.7, 7.8
             */
            if ((objectPtr->export.nodekind != SMI_NODEKIND_ROW) &&
                (objectPtr->export.indexkind != SMI_INDEX_UNKNOWN))
                smiPrintErrorAtLine(parserPtr, ERR_PIB_INDEX_FOR_NON_ROW_TYPE,
                                    objectPtr->line);

            /*
             * Check the PIB-INDEX and other indices
             */
            if ((objectPtr->export.nodekind == SMI_NODEKIND_ROW) &&
                (objectPtr->export.indexkind == SMI_INDEX_INDEX)) {

                /*
                 * Only the first element (PIB-INDEX) has to be an InstanceId.
                 * See RFC 3159 7.5
                 */
                if (objectPtr->listPtr && objectPtr->listPtr->ptr) {
                    Object *pibindex = (Object *)objectPtr->listPtr->ptr;
                    if (pibindex->typePtr && pibindex->typePtr->export.name &&
                        strcmp(pibindex->typePtr->export.name, "InstanceId"))
                        smiPrintErrorAtLine(thisParserPtr, ERR_PIB_INDEX_NOT_INSTANCEID,
                                            pibindex->line, pibindex->export.name);
                }
            }
            
            /*
             * Do all tables contain a PIB-ACCESS clause?
             * See RFC 3159 7.3
             */
            if ((objectPtr->export.nodekind == SMI_NODEKIND_TABLE) &&
                (objectPtr->export.access == SMI_ACCESS_UNKNOWN))
                smiPrintErrorAtLine(parserPtr, ERR_TABLE_LACKS_PIB_ACCESS,
                                    objectPtr->line);

            /*
             * Does any non table types contain a PIB-ACCESS clause?
             * See RFC 3159 7.3
             */
            if (((objectPtr->export.nodekind == SMI_NODEKIND_NODE) ||
                 (objectPtr->export.nodekind == SMI_NODEKIND_ROW) ||
                 (objectPtr->export.nodekind == SMI_NODEKIND_SCALAR)) &&
                (objectPtr->export.access != SMI_ACCESS_UNKNOWN))
                smiPrintErrorAtLine(parserPtr, ERR_PIB_ACCESS_FOR_NON_TABLE,
                                    objectPtr->line);

            /*
             * Check the UNIQUENESS clause and its entries
             * See RFC 3159 7.9
             */
            if (objectPtr->uniquenessPtr) {
                if (objectPtr->export.nodekind != SMI_NODEKIND_ROW)
                    smiPrintErrorAtLine(parserPtr, ERR_UNIQUENESS_FOR_NON_ROW,
                                        objectPtr->line);
                else
                    smiCheckUniqueness(parserPtr, objectPtr);
            }
            
            /*
             * Does the PIB-REFERENCES object point to a PRC (table)?
             * See RFC 3159 7.10
             */
            if (objectPtr->typePtr && objectPtr->typePtr->export.name &&
                !strcmp(objectPtr->typePtr->export.name, "ReferenceId") &&
                objectPtr->relatedPtr &&
                (objectPtr->relatedPtr->export.nodekind != SMI_NODEKIND_ROW))
                smiPrintErrorAtLine(parserPtr, ERR_PIB_REFERENCES_NOT_ROW,
                                    objectPtr->line);

            /*
             * Do all PIB-TAGs point to objects with a SYNTAX of TagId?
             * See RFC 3159 7.12
             */
            if (objectPtr->typePtr && objectPtr->typePtr->export.name &&
                !strcmp(objectPtr->typePtr->export.name, "TagReferenceId") &&
                objectPtr->relatedPtr && objectPtr->relatedPtr->typePtr &&
                objectPtr->relatedPtr->typePtr->export.name &&
                strcmp(objectPtr->relatedPtr->typePtr->export.name, "TagId"))
                smiPrintErrorAtLine(parserPtr, ERR_PIB_TAG_TYPE, objectPtr->line);
            
            /*
             * Is the attribute member of at least one compliance group?
             * See RFC 3159 9.1
             */
            if (objectPtr->export.nodekind & SMI_NODEKIND_COLUMN) {
                Object *group;
                int found = 0;
                
                for (group = modulePtr->firstObjectPtr; group;
                     group = group->nextPtr) {
                    if ((group->export.nodekind == SMI_NODEKIND_GROUP) &&
                        group->listPtr) {
                        List *l;
                        
                        for (l = group->listPtr; l; l = l->nextPtr)
                            if (((Object *)l->ptr)->export.name &&
                                !strcmp(((Object *)l->ptr)->export.name,
                                        objectPtr->export.name)) {
                                found = 1;
                                break;
                            }
                    }
                    if (found)
                        break;
                }
                if (!found)
                    smiPrintErrorAtLine(parserPtr, ERR_ATTRIBUTE_NOT_IN_GROUP,
                                        objectPtr->line, objectPtr->export.name);
            }
        }
    }
}



static void
checkTypes(Parser *parserPtr, Module *modulePtr)
{
    Type *typePtr;
    
    for (typePtr = modulePtr->firstTypePtr;
	typePtr; typePtr = typePtr->nextPtr) {

	/*
	 * Check references to unknown types.
	 */
	
	if ((typePtr->flags & FLAG_INCOMPLETE)
	    && typePtr->export.name
	    && (typePtr->export.decl == SMI_DECL_UNKNOWN)) {
	    smiPrintErrorAtLine(parserPtr, ERR_UNKNOWN_TYPE,
				typePtr->line, typePtr->export.name);
	}

	/*
	 * Use TCs instead of type assignments in SMIv2.
	 */

	if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2
	    && typePtr->export.decl == SMI_DECL_TYPEASSIGNMENT
	    && typePtr->export.basetype != SMI_BASETYPE_UNKNOWN
	    && strcmp(thisModulePtr->export.name, "SNMPv2-SMI")) {
	    smiPrintErrorAtLine(parserPtr, ERR_SMIV2_TYPE_ASSIGNEMENT,
				typePtr->line, typePtr->export.name);
	}

	/*
	 * Check whether we have types that are not used in this
	 * module.
	 */

	if ((typePtr->export.decl == SMI_DECL_TYPEDEF
	     || typePtr->export.decl == SMI_DECL_TEXTUALCONVENTION)
	    && ! (typePtr->flags & FLAG_INSYNTAX)) {
	    static char *status[] = { "Unknown", "current", "deprecated",
				      "mandatory", "optional", "obsolete" };
	    smiPrintErrorAtLine(parserPtr, ERR_TYPE_UNREF,
				typePtr->line,
				status[typePtr->export.status],
				typePtr->export.name);
	}

	/*
	 * Complain about TCs derived from other TCs (RFC 2579 3.5).
	 */
	
	if (typePtr->parentPtr
	    && typePtr->export.decl == SMI_DECL_TEXTUALCONVENTION
	    && typePtr->export.decl == typePtr->parentPtr->export.decl) {
	    smiPrintErrorAtLine(parserPtr, ERR_SMIV2_NESTED_TEXTUAL_CONVENTION,
				typePtr->line,
				typePtr->export.name,
				typePtr->parentPtr->export.name);

	    if (typePtr->export.status < typePtr->parentPtr->export.status) {
		if (typePtr->parentPtr->export.status == SMI_STATUS_DEPRECATED) {
		    smiPrintErrorAtLine(parserPtr, ERR_TYPE_STATUS_DEPRECATED,
					typePtr->line,
					typePtr->parentPtr->export.name,
					typePtr->export.name);
		}
		if (typePtr->parentPtr->export.status == SMI_STATUS_OBSOLETE) {
		    smiPrintErrorAtLine(parserPtr, ERR_TYPE_STATUS_OBSOLETE,
					typePtr->line,
					typePtr->parentPtr->export.name,
					typePtr->export.name);
		}
	    }
	}

	smiCheckTypeFormat(parserPtr, typePtr);
	smiCheckNamedNumberRedefinition(parserPtr, typePtr);
	smiCheckNamedNumberSubtyping(parserPtr, typePtr);
    }
}


				
static void
adjustDefval(Parser *parserPtr, SmiValue *valuePtr, Type *typePtr, int line)
{
    Object *object2Ptr;
    List *bitsListPtr, *valueListPtr, *p, *pp, *nextPtr, *listPtr;
    Import *importPtr;
    int nBits, bit;
    
    if (valuePtr->basetype == SMI_BASETYPE_UNKNOWN)
	return;
	
    if (valuePtr->basetype == SMI_BASETYPE_OBJECTIDENTIFIER) {
	/* a len of -1 indicates an unresolved label in ptr */
	if (valuePtr->len == -1) {
	    object2Ptr = findObjectByModuleAndName(parserPtr->modulePtr,
						  (char *)valuePtr->value.ptr);
	    if (!object2Ptr) {
		importPtr = findImportByName(
		    (char *)valuePtr->value.ptr, parserPtr->modulePtr);
		if (importPtr) {		/* imported object */
		    importPtr->use++;
		    object2Ptr = findObjectByModulenameAndName(
			importPtr->export.module,
			importPtr->export.name);
		}
	    }
	    if (!object2Ptr) {
		smiPrintErrorAtLine(parserPtr, ERR_UNKNOWN_OIDLABEL,
				    line,
				    (char *)valuePtr->value.ptr);
		smiFree(valuePtr->value.ptr);
		valuePtr->value.ptr = NULL;
		valuePtr->basetype = SMI_BASETYPE_UNKNOWN;
	    } else {
		smiFree(valuePtr->value.ptr);
		valuePtr->len = object2Ptr->export.oidlen;
		valuePtr->value.ptr = smiMalloc(object2Ptr->export.oidlen *
						sizeof(SmiSubid));
		memcpy(valuePtr->value.ptr,
		       object2Ptr->export.oid,
		       object2Ptr->export.oidlen * sizeof(SmiSubid));
	    }
	}
    } else if (valuePtr->basetype == SMI_BASETYPE_BITS) {
	bitsListPtr = typePtr->listPtr;
	valueListPtr = (void *)valuePtr->value.ptr;
	for (nBits = 0, p = bitsListPtr; p; p = p->nextPtr) {
	    if (nBits < 1+((NamedNumber *)(p->ptr))->export.value.value.integer32) {
		nBits = 1+((NamedNumber *)(p->ptr))->export.value.value.integer32;
	    }
	}
	valuePtr->value.ptr = smiMalloc((nBits+7)/8);
	memset(valuePtr->value.ptr, 0, (nBits+7)/8);
	valuePtr->len = (nBits+7)/8;
	for (p = valueListPtr; p;) {
	    for (pp = bitsListPtr; pp; pp = pp->nextPtr) {
		if (!strcmp(p->ptr,
			    ((NamedNumber *)(pp->ptr))->export.name)) {
		    bit = ((NamedNumber *)(pp->ptr))->export.value.value.integer32;
		    valuePtr->value.ptr[bit/8] |=
			1 << (7-(bit%8));
		}
	    }
	    smiFree(p->ptr);
	    nextPtr = p->nextPtr;
	    smiFree(p);
	    p = nextPtr;
	}
    } else if (valuePtr->basetype == SMI_BASETYPE_ENUM) {
	/* a len of -1 indicates an unresolved enum label in ptr */
	if (valuePtr->len == -1) {
	    for (listPtr = typePtr->listPtr; listPtr;
		 listPtr = listPtr->nextPtr) {
		if (!strcmp(((NamedNumber *)(listPtr->ptr))->export.name,
			    (char *)valuePtr->value.ptr)) {
		    smiFree(valuePtr->value.ptr);
		    valuePtr->value.integer32 =
			((NamedNumber *)(listPtr->ptr))->
			export.value.value.integer32;
		    valuePtr->len = 1;
		    break;
		}
	    }
	}
    }
}



static void
checkDefvals(Parser *parserPtr, Module *modulePtr)
{
    Object *objectPtr;
    
    /*
     * Check unknown identifiers in OID DEFVALs.
     */

    for(objectPtr = modulePtr->firstObjectPtr;
	objectPtr; objectPtr = objectPtr->nextPtr) {

	adjustDefval(parserPtr, &objectPtr->export.value,
		     objectPtr->typePtr, objectPtr->line);
	
	if (objectPtr->export.value.len == -1) {
	    smiPrintErrorAtLine(parserPtr,
				ERR_DEFVAL_SYNTAX, objectPtr->line);
	}
	
	smiCheckDefault(parserPtr, objectPtr);
    }
}



static void
checkImportsUsage(Parser *parserPtr, Module *modulePtr)
{
    Import *importPtr;
    
    /*
     * Check usage of all imported identifiers.
     */

    if (strcmp(modulePtr->export.name, "SNMPv2-TC") &&
	strcmp(modulePtr->export.name, "SNMPv2-CONF") &&
	strcmp(modulePtr->export.name, "RFC-1212") &&
	strcmp(modulePtr->export.name, "RFC-1215")) {
	for(importPtr = modulePtr->firstImportPtr;
	    importPtr; importPtr = importPtr->nextPtr) {
	    if (! strcmp(importPtr->export.module, "SNMPv2-SMI")) {
		if (! strcmp(importPtr->export.name, "ExtUTCTime")
		    || !strcmp(importPtr->export.name, "ObjectName")
		    || !strcmp(importPtr->export.name, "NotificationName")) {
		    smiPrintErrorAtLine(parserPtr, ERR_ILLEGAL_IMPORT,
					importPtr->line,
					importPtr->export.name,
					importPtr->export.module);
		}
	    }
	    /* checkImports() handles KIND_NOTFOUND */
	    if (importPtr->use == 0 && importPtr->kind != KIND_NOTFOUND) {
		smiPrintErrorAtLine(parserPtr, ERR_UNUSED_IMPORT,
				    importPtr->line,
				    importPtr->export.name,
				    importPtr->export.module);
	    }

	    if (modulePtr->export.language == SMI_LANGUAGE_SMIV2) {
		int j;
		for (j = 0; convertImportv2[j]; j += 4) {
		    if ((strcmp(convertImportv2[j],
				importPtr->export.module) == 0)
			&& (strcmp(convertImportv2[j+1],
				   importPtr->export.name) == 0)) {
			smiPrintErrorAtLine(parserPtr,
					    ERR_OBSOLETE_IMPORT,
					    importPtr->line,
					    importPtr->export.name,
					    convertImportv2[j+2],
					    importPtr->export.module);
		    }
		}
	    }
	}
    }
}



static time_t
checkDate(Parser *parserPtr, char *date)
{
    struct tm	tm;
    time_t	anytime;
    int		i, len;
    char	*p;
    
    memset(&tm, 0, sizeof(tm));
    anytime = 0;
    
    len = strlen(date);
    if (len == 11 || len == 13) {
	for (i = 0; i < len; i++) {
	    if ( (i < len-1 && ! isdigit((int) date[i]))
		 || (i == len-1 && date[len-1] != 'Z')) {
		smiPrintError(parserPtr, ERR_DATE_CHARACTER, date);
		anytime = (time_t) -1;
		break;
	    }
	}
    } else {
	smiPrintError(parserPtr, ERR_DATE_LENGTH, date);
	anytime = (time_t) -1;
    }

    if (anytime == 0) {
	for (i = 0, p = date, tm.tm_year = 0;
	     i < ((len == 11) ? 2 : 4); i++, p++) {
	    tm.tm_year = tm.tm_year * 10 + (*p - '0');
	}
	if (len == 11) {
	    tm.tm_year += 1900;
	    if (tm.tm_year < 1990)
		smiPrintError(parserPtr, ERR_DATE_YEAR_2DIGITS,
			      date, tm.tm_year);
	}
	tm.tm_mon  = (p[0]-'0') * 10 + (p[1]-'0');
	p += 2;
	tm.tm_mday = (p[0]-'0') * 10 + (p[1]-'0');
	p += 2;
	tm.tm_hour = (p[0]-'0') * 10 + (p[1]-'0');
	p += 2;
	tm.tm_min  = (p[0]-'0') * 10 + (p[1]-'0');
	
	if (tm.tm_mon < 1 || tm.tm_mon > 12) {
	    smiPrintError(parserPtr, ERR_DATE_MONTH, date);
	}
	if (tm.tm_mday < 1 || tm.tm_mday > 31) {
	    smiPrintError(parserPtr, ERR_DATE_DAY, date);
	}
	if (tm.tm_hour < 0 || tm.tm_hour > 23) {
	    smiPrintError(parserPtr, ERR_DATE_HOUR, date);
	}
	if (tm.tm_min < 0 || tm.tm_min > 59) {
	    smiPrintError(parserPtr, ERR_DATE_MINUTES, date);
	}
	
	tm.tm_year -= 1900;
	tm.tm_mon -= 1;
	tm.tm_isdst = 0;

	anytime = timegm(&tm);
	
	if (anytime == (time_t) -1) {
	    smiPrintError(parserPtr, ERR_DATE_VALUE, date);
	} else {
	    if (anytime < SMI_EPOCH) {
		smiPrintError(parserPtr, ERR_DATE_IN_PAST, date);
	    }
	    if (anytime > time(NULL)) {
		smiPrintError(parserPtr, ERR_DATE_IN_FUTURE, date);
	    }
	}
    }

    return (anytime == (time_t) -1) ? 0 : anytime;
}


#line 1338 "parser-smi.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser-smi.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DOT_DOT = 3,                    /* DOT_DOT  */
  YYSYMBOL_COLON_COLON_EQUAL = 4,          /* COLON_COLON_EQUAL  */
  YYSYMBOL_UPPERCASE_IDENTIFIER = 5,       /* UPPERCASE_IDENTIFIER  */
  YYSYMBOL_LOWERCASE_IDENTIFIER = 6,       /* LOWERCASE_IDENTIFIER  */
  YYSYMBOL_NUMBER = 7,                     /* NUMBER  */
  YYSYMBOL_NEGATIVENUMBER = 8,             /* NEGATIVENUMBER  */
  YYSYMBOL_NUMBER64 = 9,                   /* NUMBER64  */
  YYSYMBOL_NEGATIVENUMBER64 = 10,          /* NEGATIVENUMBER64  */
  YYSYMBOL_BIN_STRING = 11,                /* BIN_STRING  */
  YYSYMBOL_HEX_STRING = 12,                /* HEX_STRING  */
  YYSYMBOL_QUOTED_STRING = 13,             /* QUOTED_STRING  */
  YYSYMBOL_ACCESS = 14,                    /* ACCESS  */
  YYSYMBOL_AGENT_CAPABILITIES = 15,        /* AGENT_CAPABILITIES  */
  YYSYMBOL_APPLICATION = 16,               /* APPLICATION  */
  YYSYMBOL_AUGMENTS = 17,                  /* AUGMENTS  */
  YYSYMBOL_BEGIN_ = 18,                    /* BEGIN_  */
  YYSYMBOL_BITS = 19,                      /* BITS  */
  YYSYMBOL_CHOICE = 20,                    /* CHOICE  */
  YYSYMBOL_CONTACT_INFO = 21,              /* CONTACT_INFO  */
  YYSYMBOL_CREATION_REQUIRES = 22,         /* CREATION_REQUIRES  */
  YYSYMBOL_COUNTER32 = 23,                 /* COUNTER32  */
  YYSYMBOL_COUNTER64 = 24,                 /* COUNTER64  */
  YYSYMBOL_DEFINITIONS = 25,               /* DEFINITIONS  */
  YYSYMBOL_DEFVAL = 26,                    /* DEFVAL  */
  YYSYMBOL_DESCRIPTION = 27,               /* DESCRIPTION  */
  YYSYMBOL_DISPLAY_HINT = 28,              /* DISPLAY_HINT  */
  YYSYMBOL_END = 29,                       /* END  */
  YYSYMBOL_ENTERPRISE = 30,                /* ENTERPRISE  */
  YYSYMBOL_EXPORTS = 31,                   /* EXPORTS  */
  YYSYMBOL_EXTENDS = 32,                   /* EXTENDS  */
  YYSYMBOL_FROM = 33,                      /* FROM  */
  YYSYMBOL_GROUP = 34,                     /* GROUP  */
  YYSYMBOL_GAUGE32 = 35,                   /* GAUGE32  */
  YYSYMBOL_IDENTIFIER = 36,                /* IDENTIFIER  */
  YYSYMBOL_IMPLICIT = 37,                  /* IMPLICIT  */
  YYSYMBOL_IMPLIED = 38,                   /* IMPLIED  */
  YYSYMBOL_IMPORTS = 39,                   /* IMPORTS  */
  YYSYMBOL_INCLUDES = 40,                  /* INCLUDES  */
  YYSYMBOL_INDEX = 41,                     /* INDEX  */
  YYSYMBOL_INSTALL_ERRORS = 42,            /* INSTALL_ERRORS  */
  YYSYMBOL_INTEGER = 43,                   /* INTEGER  */
  YYSYMBOL_INTEGER32 = 44,                 /* INTEGER32  */
  YYSYMBOL_INTEGER64 = 45,                 /* INTEGER64  */
  YYSYMBOL_IPADDRESS = 46,                 /* IPADDRESS  */
  YYSYMBOL_LAST_UPDATED = 47,              /* LAST_UPDATED  */
  YYSYMBOL_MACRO = 48,                     /* MACRO  */
  YYSYMBOL_MANDATORY_GROUPS = 49,          /* MANDATORY_GROUPS  */
  YYSYMBOL_MAX_ACCESS = 50,                /* MAX_ACCESS  */
  YYSYMBOL_MIN_ACCESS = 51,                /* MIN_ACCESS  */
  YYSYMBOL_MODULE = 52,                    /* MODULE  */
  YYSYMBOL_MODULE_COMPLIANCE = 53,         /* MODULE_COMPLIANCE  */
  YYSYMBOL_MODULE_IDENTITY = 54,           /* MODULE_IDENTITY  */
  YYSYMBOL_NOT_ACCESSIBLE = 55,            /* NOT_ACCESSIBLE  */
  YYSYMBOL_NOTIFICATIONS = 56,             /* NOTIFICATIONS  */
  YYSYMBOL_NOTIFICATION_GROUP = 57,        /* NOTIFICATION_GROUP  */
  YYSYMBOL_NOTIFICATION_TYPE = 58,         /* NOTIFICATION_TYPE  */
  YYSYMBOL_OBJECT = 59,                    /* OBJECT  */
  YYSYMBOL_OBJECT_GROUP = 60,              /* OBJECT_GROUP  */
  YYSYMBOL_OBJECT_IDENTITY = 61,           /* OBJECT_IDENTITY  */
  YYSYMBOL_OBJECT_TYPE = 62,               /* OBJECT_TYPE  */
  YYSYMBOL_OBJECTS = 63,                   /* OBJECTS  */
  YYSYMBOL_OCTET = 64,                     /* OCTET  */
  YYSYMBOL_OF = 65,                        /* OF  */
  YYSYMBOL_ORGANIZATION = 66,              /* ORGANIZATION  */
  YYSYMBOL_OPAQUE = 67,                    /* OPAQUE  */
  YYSYMBOL_PIB_ACCESS = 68,                /* PIB_ACCESS  */
  YYSYMBOL_PIB_DEFINITIONS = 69,           /* PIB_DEFINITIONS  */
  YYSYMBOL_PIB_INDEX = 70,                 /* PIB_INDEX  */
  YYSYMBOL_PIB_MIN_ACCESS = 71,            /* PIB_MIN_ACCESS  */
  YYSYMBOL_PIB_REFERENCES = 72,            /* PIB_REFERENCES  */
  YYSYMBOL_PIB_TAG = 73,                   /* PIB_TAG  */
  YYSYMBOL_POLICY_ACCESS = 74,             /* POLICY_ACCESS  */
  YYSYMBOL_PRODUCT_RELEASE = 75,           /* PRODUCT_RELEASE  */
  YYSYMBOL_REFERENCE = 76,                 /* REFERENCE  */
  YYSYMBOL_REVISION = 77,                  /* REVISION  */
  YYSYMBOL_SEQUENCE = 78,                  /* SEQUENCE  */
  YYSYMBOL_SIZE = 79,                      /* SIZE  */
  YYSYMBOL_STATUS = 80,                    /* STATUS  */
  YYSYMBOL_STRING = 81,                    /* STRING  */
  YYSYMBOL_SUBJECT_CATEGORIES = 82,        /* SUBJECT_CATEGORIES  */
  YYSYMBOL_SUPPORTS = 83,                  /* SUPPORTS  */
  YYSYMBOL_SYNTAX = 84,                    /* SYNTAX  */
  YYSYMBOL_TEXTUAL_CONVENTION = 85,        /* TEXTUAL_CONVENTION  */
  YYSYMBOL_TIMETICKS = 86,                 /* TIMETICKS  */
  YYSYMBOL_TRAP_TYPE = 87,                 /* TRAP_TYPE  */
  YYSYMBOL_UNIQUENESS = 88,                /* UNIQUENESS  */
  YYSYMBOL_UNITS = 89,                     /* UNITS  */
  YYSYMBOL_UNIVERSAL = 90,                 /* UNIVERSAL  */
  YYSYMBOL_UNSIGNED32 = 91,                /* UNSIGNED32  */
  YYSYMBOL_UNSIGNED64 = 92,                /* UNSIGNED64  */
  YYSYMBOL_VALUE = 93,                     /* VALUE  */
  YYSYMBOL_VARIABLES = 94,                 /* VARIABLES  */
  YYSYMBOL_VARIATION = 95,                 /* VARIATION  */
  YYSYMBOL_WRITE_SYNTAX = 96,              /* WRITE_SYNTAX  */
  YYSYMBOL_97_ = 97,                       /* '{'  */
  YYSYMBOL_98_ = 98,                       /* '}'  */
  YYSYMBOL_99_ = 99,                       /* ';'  */
  YYSYMBOL_100_ = 100,                     /* ','  */
  YYSYMBOL_101_ = 101,                     /* '('  */
  YYSYMBOL_102_ = 102,                     /* ')'  */
  YYSYMBOL_103_ = 103,                     /* '['  */
  YYSYMBOL_104_ = 104,                     /* ']'  */
  YYSYMBOL_105_ = 105,                     /* '.'  */
  YYSYMBOL_106_ = 106,                     /* '|'  */
  YYSYMBOL_YYACCEPT = 107,                 /* $accept  */
  YYSYMBOL_mibFile = 108,                  /* mibFile  */
  YYSYMBOL_modules = 109,                  /* modules  */
  YYSYMBOL_module = 110,                   /* module  */
  YYSYMBOL_111_1 = 111,                    /* $@1  */
  YYSYMBOL_moduleOid = 112,                /* moduleOid  */
  YYSYMBOL_definitions = 113,              /* definitions  */
  YYSYMBOL_linkagePart = 114,              /* linkagePart  */
  YYSYMBOL_linkageClause = 115,            /* linkageClause  */
  YYSYMBOL_exportsClause = 116,            /* exportsClause  */
  YYSYMBOL_117_2 = 117,                    /* $@2  */
  YYSYMBOL_importPart = 118,               /* importPart  */
  YYSYMBOL_imports = 119,                  /* imports  */
  YYSYMBOL_import = 120,                   /* import  */
  YYSYMBOL_importIdentifiers = 121,        /* importIdentifiers  */
  YYSYMBOL_importIdentifier = 122,         /* importIdentifier  */
  YYSYMBOL_importedKeyword = 123,          /* importedKeyword  */
  YYSYMBOL_importedSMIKeyword = 124,       /* importedSMIKeyword  */
  YYSYMBOL_importedSPPIKeyword = 125,      /* importedSPPIKeyword  */
  YYSYMBOL_moduleName = 126,               /* moduleName  */
  YYSYMBOL_declarationPart = 127,          /* declarationPart  */
  YYSYMBOL_declarations = 128,             /* declarations  */
  YYSYMBOL_declaration = 129,              /* declaration  */
  YYSYMBOL_macroClause = 130,              /* macroClause  */
  YYSYMBOL_131_3 = 131,                    /* $@3  */
  YYSYMBOL_132_4 = 132,                    /* $@4  */
  YYSYMBOL_macroName = 133,                /* macroName  */
  YYSYMBOL_choiceClause = 134,             /* choiceClause  */
  YYSYMBOL_135_5 = 135,                    /* $@5  */
  YYSYMBOL_fuzzy_lowercase_identifier = 136, /* fuzzy_lowercase_identifier  */
  YYSYMBOL_valueDeclaration = 137,         /* valueDeclaration  */
  YYSYMBOL_138_6 = 138,                    /* $@6  */
  YYSYMBOL_typeDeclaration = 139,          /* typeDeclaration  */
  YYSYMBOL_140_7 = 140,                    /* $@7  */
  YYSYMBOL_typeName = 141,                 /* typeName  */
  YYSYMBOL_typeSMI = 142,                  /* typeSMI  */
  YYSYMBOL_typeSMIandSPPI = 143,           /* typeSMIandSPPI  */
  YYSYMBOL_typeSMIonly = 144,              /* typeSMIonly  */
  YYSYMBOL_typeSPPIonly = 145,             /* typeSPPIonly  */
  YYSYMBOL_typeDeclarationRHS = 146,       /* typeDeclarationRHS  */
  YYSYMBOL_147_8 = 147,                    /* $@8  */
  YYSYMBOL_148_9 = 148,                    /* $@9  */
  YYSYMBOL_conceptualTable = 149,          /* conceptualTable  */
  YYSYMBOL_row = 150,                      /* row  */
  YYSYMBOL_entryType = 151,                /* entryType  */
  YYSYMBOL_sequenceItems = 152,            /* sequenceItems  */
  YYSYMBOL_sequenceItem = 153,             /* sequenceItem  */
  YYSYMBOL_Syntax = 154,                   /* Syntax  */
  YYSYMBOL_sequenceSyntax = 155,           /* sequenceSyntax  */
  YYSYMBOL_NamedBits = 156,                /* NamedBits  */
  YYSYMBOL_NamedBit = 157,                 /* NamedBit  */
  YYSYMBOL_158_10 = 158,                   /* $@10  */
  YYSYMBOL_objectIdentityClause = 159,     /* objectIdentityClause  */
  YYSYMBOL_160_11 = 160,                   /* $@11  */
  YYSYMBOL_161_12 = 161,                   /* $@12  */
  YYSYMBOL_162_13 = 162,                   /* $@13  */
  YYSYMBOL_objectTypeClause = 163,         /* objectTypeClause  */
  YYSYMBOL_164_14 = 164,                   /* $@14  */
  YYSYMBOL_165_15 = 165,                   /* $@15  */
  YYSYMBOL_descriptionClause = 166,        /* descriptionClause  */
  YYSYMBOL_trapTypeClause = 167,           /* trapTypeClause  */
  YYSYMBOL_168_16 = 168,                   /* $@16  */
  YYSYMBOL_169_17 = 169,                   /* $@17  */
  YYSYMBOL_VarPart = 170,                  /* VarPart  */
  YYSYMBOL_VarTypes = 171,                 /* VarTypes  */
  YYSYMBOL_VarType = 172,                  /* VarType  */
  YYSYMBOL_DescrPart = 173,                /* DescrPart  */
  YYSYMBOL_MaxOrPIBAccessPart = 174,       /* MaxOrPIBAccessPart  */
  YYSYMBOL_PibAccessPart = 175,            /* PibAccessPart  */
  YYSYMBOL_PibAccess = 176,                /* PibAccess  */
  YYSYMBOL_SPPIPibReferencesPart = 177,    /* SPPIPibReferencesPart  */
  YYSYMBOL_178_18 = 178,                   /* $@18  */
  YYSYMBOL_SPPIPibTagPart = 179,           /* SPPIPibTagPart  */
  YYSYMBOL_180_19 = 180,                   /* $@19  */
  YYSYMBOL_SPPIUniquePart = 181,           /* SPPIUniquePart  */
  YYSYMBOL_182_20 = 182,                   /* $@20  */
  YYSYMBOL_UniqueTypesPart = 183,          /* UniqueTypesPart  */
  YYSYMBOL_UniqueTypes = 184,              /* UniqueTypes  */
  YYSYMBOL_UniqueType = 185,               /* UniqueType  */
  YYSYMBOL_SPPIErrorsPart = 186,           /* SPPIErrorsPart  */
  YYSYMBOL_187_21 = 187,                   /* $@21  */
  YYSYMBOL_Errors = 188,                   /* Errors  */
  YYSYMBOL_Error = 189,                    /* Error  */
  YYSYMBOL_MaxAccessPart = 190,            /* MaxAccessPart  */
  YYSYMBOL_191_22 = 191,                   /* $@22  */
  YYSYMBOL_192_23 = 192,                   /* $@23  */
  YYSYMBOL_notificationTypeClause = 193,   /* notificationTypeClause  */
  YYSYMBOL_194_24 = 194,                   /* $@24  */
  YYSYMBOL_195_25 = 195,                   /* $@25  */
  YYSYMBOL_196_26 = 196,                   /* $@26  */
  YYSYMBOL_moduleIdentityClause = 197,     /* moduleIdentityClause  */
  YYSYMBOL_198_27 = 198,                   /* $@27  */
  YYSYMBOL_199_28 = 199,                   /* $@28  */
  YYSYMBOL_200_29 = 200,                   /* $@29  */
  YYSYMBOL_201_30 = 201,                   /* $@30  */
  YYSYMBOL_202_31 = 202,                   /* $@31  */
  YYSYMBOL_203_32 = 203,                   /* $@32  */
  YYSYMBOL_204_33 = 204,                   /* $@33  */
  YYSYMBOL_205_34 = 205,                   /* $@34  */
  YYSYMBOL_SubjectCategoriesPart = 206,    /* SubjectCategoriesPart  */
  YYSYMBOL_SubjectCategories = 207,        /* SubjectCategories  */
  YYSYMBOL_CategoryIDs = 208,              /* CategoryIDs  */
  YYSYMBOL_CategoryID = 209,               /* CategoryID  */
  YYSYMBOL_ObjectSyntax = 210,             /* ObjectSyntax  */
  YYSYMBOL_typeTag = 211,                  /* typeTag  */
  YYSYMBOL_sequenceObjectSyntax = 212,     /* sequenceObjectSyntax  */
  YYSYMBOL_valueofObjectSyntax = 213,      /* valueofObjectSyntax  */
  YYSYMBOL_SimpleSyntax = 214,             /* SimpleSyntax  */
  YYSYMBOL_215_35 = 215,                   /* $@35  */
  YYSYMBOL_216_36 = 216,                   /* $@36  */
  YYSYMBOL_217_37 = 217,                   /* $@37  */
  YYSYMBOL_218_38 = 218,                   /* $@38  */
  YYSYMBOL_219_39 = 219,                   /* $@39  */
  YYSYMBOL_valueofSimpleSyntax = 220,      /* valueofSimpleSyntax  */
  YYSYMBOL_sequenceSimpleSyntax = 221,     /* sequenceSimpleSyntax  */
  YYSYMBOL_ApplicationSyntax = 222,        /* ApplicationSyntax  */
  YYSYMBOL_223_40 = 223,                   /* $@40  */
  YYSYMBOL_sequenceApplicationSyntax = 224, /* sequenceApplicationSyntax  */
  YYSYMBOL_anySubType = 225,               /* anySubType  */
  YYSYMBOL_integerSubType = 226,           /* integerSubType  */
  YYSYMBOL_octetStringSubType = 227,       /* octetStringSubType  */
  YYSYMBOL_ranges = 228,                   /* ranges  */
  YYSYMBOL_range = 229,                    /* range  */
  YYSYMBOL_value = 230,                    /* value  */
  YYSYMBOL_enumSpec = 231,                 /* enumSpec  */
  YYSYMBOL_enumItems = 232,                /* enumItems  */
  YYSYMBOL_enumItem = 233,                 /* enumItem  */
  YYSYMBOL_234_41 = 234,                   /* $@41  */
  YYSYMBOL_enumNumber = 235,               /* enumNumber  */
  YYSYMBOL_Status = 236,                   /* Status  */
  YYSYMBOL_Status_Capabilities = 237,      /* Status_Capabilities  */
  YYSYMBOL_DisplayPart = 238,              /* DisplayPart  */
  YYSYMBOL_UnitsPart = 239,                /* UnitsPart  */
  YYSYMBOL_Access = 240,                   /* Access  */
  YYSYMBOL_IndexPart = 241,                /* IndexPart  */
  YYSYMBOL_242_42 = 242,                   /* $@42  */
  YYSYMBOL_243_43 = 243,                   /* $@43  */
  YYSYMBOL_MibIndex = 244,                 /* MibIndex  */
  YYSYMBOL_245_44 = 245,                   /* $@44  */
  YYSYMBOL_IndexTypes = 246,               /* IndexTypes  */
  YYSYMBOL_IndexType = 247,                /* IndexType  */
  YYSYMBOL_Index = 248,                    /* Index  */
  YYSYMBOL_Entry = 249,                    /* Entry  */
  YYSYMBOL_DefValPart = 250,               /* DefValPart  */
  YYSYMBOL_Value = 251,                    /* Value  */
  YYSYMBOL_BitsValue = 252,                /* BitsValue  */
  YYSYMBOL_BitNames = 253,                 /* BitNames  */
  YYSYMBOL_ObjectName = 254,               /* ObjectName  */
  YYSYMBOL_NotificationName = 255,         /* NotificationName  */
  YYSYMBOL_ReferPart = 256,                /* ReferPart  */
  YYSYMBOL_RevisionPart = 257,             /* RevisionPart  */
  YYSYMBOL_Revisions = 258,                /* Revisions  */
  YYSYMBOL_Revision = 259,                 /* Revision  */
  YYSYMBOL_260_45 = 260,                   /* $@45  */
  YYSYMBOL_NotificationObjectsPart = 261,  /* NotificationObjectsPart  */
  YYSYMBOL_ObjectGroupObjectsPart = 262,   /* ObjectGroupObjectsPart  */
  YYSYMBOL_Objects = 263,                  /* Objects  */
  YYSYMBOL_Object = 264,                   /* Object  */
  YYSYMBOL_NotificationsPart = 265,        /* NotificationsPart  */
  YYSYMBOL_Notifications = 266,            /* Notifications  */
  YYSYMBOL_Notification = 267,             /* Notification  */
  YYSYMBOL_Text = 268,                     /* Text  */
  YYSYMBOL_ExtUTCTime = 269,               /* ExtUTCTime  */
  YYSYMBOL_objectIdentifier = 270,         /* objectIdentifier  */
  YYSYMBOL_271_46 = 271,                   /* $@46  */
  YYSYMBOL_subidentifiers = 272,           /* subidentifiers  */
  YYSYMBOL_subidentifier = 273,            /* subidentifier  */
  YYSYMBOL_objectIdentifier_defval = 274,  /* objectIdentifier_defval  */
  YYSYMBOL_subidentifiers_defval = 275,    /* subidentifiers_defval  */
  YYSYMBOL_subidentifier_defval = 276,     /* subidentifier_defval  */
  YYSYMBOL_objectGroupClause = 277,        /* objectGroupClause  */
  YYSYMBOL_278_47 = 278,                   /* $@47  */
  YYSYMBOL_279_48 = 279,                   /* $@48  */
  YYSYMBOL_280_49 = 280,                   /* $@49  */
  YYSYMBOL_notificationGroupClause = 281,  /* notificationGroupClause  */
  YYSYMBOL_282_50 = 282,                   /* $@50  */
  YYSYMBOL_283_51 = 283,                   /* $@51  */
  YYSYMBOL_284_52 = 284,                   /* $@52  */
  YYSYMBOL_moduleComplianceClause = 285,   /* moduleComplianceClause  */
  YYSYMBOL_286_53 = 286,                   /* $@53  */
  YYSYMBOL_287_54 = 287,                   /* $@54  */
  YYSYMBOL_288_55 = 288,                   /* $@55  */
  YYSYMBOL_ComplianceModulePart = 289,     /* ComplianceModulePart  */
  YYSYMBOL_ComplianceModules = 290,        /* ComplianceModules  */
  YYSYMBOL_ComplianceModule = 291,         /* ComplianceModule  */
  YYSYMBOL_292_56 = 292,                   /* $@56  */
  YYSYMBOL_ComplianceModuleName = 293,     /* ComplianceModuleName  */
  YYSYMBOL_MandatoryPart = 294,            /* MandatoryPart  */
  YYSYMBOL_MandatoryGroups = 295,          /* MandatoryGroups  */
  YYSYMBOL_MandatoryGroup = 296,           /* MandatoryGroup  */
  YYSYMBOL_CompliancePart = 297,           /* CompliancePart  */
  YYSYMBOL_Compliances = 298,              /* Compliances  */
  YYSYMBOL_Compliance = 299,               /* Compliance  */
  YYSYMBOL_ComplianceGroup = 300,          /* ComplianceGroup  */
  YYSYMBOL_301_57 = 301,                   /* $@57  */
  YYSYMBOL_ComplianceObject = 302,         /* ComplianceObject  */
  YYSYMBOL_303_58 = 303,                   /* $@58  */
  YYSYMBOL_SyntaxPart = 304,               /* SyntaxPart  */
  YYSYMBOL_WriteSyntaxPart = 305,          /* WriteSyntaxPart  */
  YYSYMBOL_WriteSyntax = 306,              /* WriteSyntax  */
  YYSYMBOL_AccessPart = 307,               /* AccessPart  */
  YYSYMBOL_agentCapabilitiesClause = 308,  /* agentCapabilitiesClause  */
  YYSYMBOL_309_59 = 309,                   /* $@59  */
  YYSYMBOL_310_60 = 310,                   /* $@60  */
  YYSYMBOL_311_61 = 311,                   /* $@61  */
  YYSYMBOL_ModulePart_Capabilities = 312,  /* ModulePart_Capabilities  */
  YYSYMBOL_Modules_Capabilities = 313,     /* Modules_Capabilities  */
  YYSYMBOL_Module_Capabilities = 314,      /* Module_Capabilities  */
  YYSYMBOL_315_62 = 315,                   /* $@62  */
  YYSYMBOL_CapabilitiesGroups = 316,       /* CapabilitiesGroups  */
  YYSYMBOL_CapabilitiesGroup = 317,        /* CapabilitiesGroup  */
  YYSYMBOL_ModuleName_Capabilities = 318,  /* ModuleName_Capabilities  */
  YYSYMBOL_VariationPart = 319,            /* VariationPart  */
  YYSYMBOL_Variations = 320,               /* Variations  */
  YYSYMBOL_Variation = 321,                /* Variation  */
  YYSYMBOL_322_63 = 322,                   /* $@63  */
  YYSYMBOL_323_64 = 323,                   /* $@64  */
  YYSYMBOL_VariationAccessPart = 324,      /* VariationAccessPart  */
  YYSYMBOL_VariationAccess = 325,          /* VariationAccess  */
  YYSYMBOL_CreationPart = 326,             /* CreationPart  */
  YYSYMBOL_Cells = 327,                    /* Cells  */
  YYSYMBOL_Cell = 328                      /* Cell  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   665

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  107
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  222
/* YYNRULES -- Number of rules.  */
#define YYNRULES  425
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  710

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   351


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     101,   102,     2,     2,   100,     2,   105,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    99,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   103,     2,   104,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    97,   106,    98,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1595,  1595,  1600,  1605,  1607,  1616,  1615,  1677,  1680,
    1683,  1685,  1694,  1697,  1700,  1715,  1717,  1716,  1737,  1740,
    1744,  1746,  1750,  1795,  1797,  1805,  1811,  1817,  1833,  1843,
    1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,
    1859,  1860,  1861,  1864,  1865,  1866,  1867,  1868,  1869,  1870,
    1873,  1874,  1877,  1889,  1892,  1896,  1898,  1902,  1907,  1912,
    1917,  1922,  1927,  1932,  1937,  1942,  1947,  1952,  1957,  1962,
    1977,  1989,  1976,  2022,  2023,  2024,  2025,  2026,  2027,  2028,
    2029,  2030,  2031,  2035,  2034,  2064,  2069,  2085,  2084,  2125,
    2124,  2290,  2294,  2318,  2332,  2333,  2342,  2343,  2344,  2345,
    2346,  2349,  2350,  2351,  2354,  2355,  2358,  2375,  2406,  2374,
    2442,  2450,  2464,  2509,  2517,  2523,  2543,  2626,  2632,  2654,
    2658,  2663,  2696,  2702,  2716,  2715,  2751,  2761,  2786,  2750,
    2814,  2824,  2813,  3121,  3130,  3138,  3148,  3137,  3220,  3225,
    3230,  3240,  3262,  3268,  3274,  3277,  3281,  3290,  3293,  3297,
    3301,  3306,  3305,  3313,  3317,  3316,  3324,  3329,  3328,  3336,
    3339,  3342,  3345,  3351,  3365,  3370,  3369,  3377,  3380,  3386,
    3400,  3422,  3421,  3433,  3432,  3446,  3456,  3476,  3445,  3507,
    3517,  3542,  3546,  3550,  3557,  3564,  3568,  3506,  3614,  3621,
    3628,  3635,  3641,  3656,  3677,  3700,  3704,  3724,  3729,  3734,
    3739,  3756,  3758,  3766,  3771,  3788,  3797,  3811,  3810,  3830,
    3829,  3844,  3871,  3870,  3902,  3901,  3955,  4002,  4057,  4107,
    4113,  4112,  4124,  4170,  4211,  4218,  4225,  4231,  4238,  4245,
    4271,  4294,  4314,  4331,  4364,  4368,  4393,  4397,  4403,  4431,
    4457,  4494,  4520,  4553,  4578,  4577,  4608,  4636,  4674,  4720,
    4746,  4783,  4809,  4846,  4872,  4915,  4943,  4969,  4995,  5019,
    5047,  5087,  5113,  5138,  5165,  5182,  5199,  5218,  5225,  5235,
    5247,  5253,  5267,  5274,  5284,  5290,  5296,  5302,  5308,  5331,
    5358,  5364,  5370,  5384,  5383,  5405,  5420,  5429,  5488,  5504,
    5514,  5519,  5529,  5534,  5601,  5600,  5618,  5629,  5628,  5642,
    5648,  5647,  5681,  5686,  5692,  5706,  5711,  5717,  5727,  5733,
    5753,  5757,  5759,  5767,  5770,  5773,  5779,  5792,  5798,  5804,
    5814,  5817,  5820,  5823,  5825,  5830,  5829,  5860,  5865,  5870,
    5876,  5882,  5895,  5907,  5913,  5919,  5932,  5943,  5954,  5960,
    5960,  5975,  5979,  5988,  6082,  6186,  6210,  6270,  6339,  6343,
    6345,  6349,  6351,  6356,  6366,  6385,  6355,  6416,  6426,  6448,
    6415,  6480,  6490,  6508,  6479,  6572,  6578,  6582,  6618,  6617,
    6646,  6655,  6665,  6670,  6675,  6680,  6686,  6699,  6722,  6729,
    6736,  6740,  6807,  6813,  6822,  6821,  6855,  6854,  6902,  6916,
    6921,  6939,  6944,  6950,  6956,  6965,  6971,  6981,  7003,  6970,
    7038,  7041,  7044,  7046,  7051,  7050,  7077,  7087,  7104,  7110,
    7119,  7129,  7132,  7135,  7137,  7142,  7154,  7141,  7174,  7177,
    7180,  7245,  7255,  7258,  7260,  7264
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DOT_DOT",
  "COLON_COLON_EQUAL", "UPPERCASE_IDENTIFIER", "LOWERCASE_IDENTIFIER",
  "NUMBER", "NEGATIVENUMBER", "NUMBER64", "NEGATIVENUMBER64", "BIN_STRING",
  "HEX_STRING", "QUOTED_STRING", "ACCESS", "AGENT_CAPABILITIES",
  "APPLICATION", "AUGMENTS", "BEGIN_", "BITS", "CHOICE", "CONTACT_INFO",
  "CREATION_REQUIRES", "COUNTER32", "COUNTER64", "DEFINITIONS", "DEFVAL",
  "DESCRIPTION", "DISPLAY_HINT", "END", "ENTERPRISE", "EXPORTS", "EXTENDS",
  "FROM", "GROUP", "GAUGE32", "IDENTIFIER", "IMPLICIT", "IMPLIED",
  "IMPORTS", "INCLUDES", "INDEX", "INSTALL_ERRORS", "INTEGER", "INTEGER32",
  "INTEGER64", "IPADDRESS", "LAST_UPDATED", "MACRO", "MANDATORY_GROUPS",
  "MAX_ACCESS", "MIN_ACCESS", "MODULE", "MODULE_COMPLIANCE",
  "MODULE_IDENTITY", "NOT_ACCESSIBLE", "NOTIFICATIONS",
  "NOTIFICATION_GROUP", "NOTIFICATION_TYPE", "OBJECT", "OBJECT_GROUP",
  "OBJECT_IDENTITY", "OBJECT_TYPE", "OBJECTS", "OCTET", "OF",
  "ORGANIZATION", "OPAQUE", "PIB_ACCESS", "PIB_DEFINITIONS", "PIB_INDEX",
  "PIB_MIN_ACCESS", "PIB_REFERENCES", "PIB_TAG", "POLICY_ACCESS",
  "PRODUCT_RELEASE", "REFERENCE", "REVISION", "SEQUENCE", "SIZE", "STATUS",
  "STRING", "SUBJECT_CATEGORIES", "SUPPORTS", "SYNTAX",
  "TEXTUAL_CONVENTION", "TIMETICKS", "TRAP_TYPE", "UNIQUENESS", "UNITS",
  "UNIVERSAL", "UNSIGNED32", "UNSIGNED64", "VALUE", "VARIABLES",
  "VARIATION", "WRITE_SYNTAX", "'{'", "'}'", "';'", "','", "'('", "')'",
  "'['", "']'", "'.'", "'|'", "$accept", "mibFile", "modules", "module",
  "$@1", "moduleOid", "definitions", "linkagePart", "linkageClause",
  "exportsClause", "$@2", "importPart", "imports", "import",
  "importIdentifiers", "importIdentifier", "importedKeyword",
  "importedSMIKeyword", "importedSPPIKeyword", "moduleName",
  "declarationPart", "declarations", "declaration", "macroClause", "$@3",
  "$@4", "macroName", "choiceClause", "$@5", "fuzzy_lowercase_identifier",
  "valueDeclaration", "$@6", "typeDeclaration", "$@7", "typeName",
  "typeSMI", "typeSMIandSPPI", "typeSMIonly", "typeSPPIonly",
  "typeDeclarationRHS", "$@8", "$@9", "conceptualTable", "row",
  "entryType", "sequenceItems", "sequenceItem", "Syntax", "sequenceSyntax",
  "NamedBits", "NamedBit", "$@10", "objectIdentityClause", "$@11", "$@12",
  "$@13", "objectTypeClause", "$@14", "$@15", "descriptionClause",
  "trapTypeClause", "$@16", "$@17", "VarPart", "VarTypes", "VarType",
  "DescrPart", "MaxOrPIBAccessPart", "PibAccessPart", "PibAccess",
  "SPPIPibReferencesPart", "$@18", "SPPIPibTagPart", "$@19",
  "SPPIUniquePart", "$@20", "UniqueTypesPart", "UniqueTypes", "UniqueType",
  "SPPIErrorsPart", "$@21", "Errors", "Error", "MaxAccessPart", "$@22",
  "$@23", "notificationTypeClause", "$@24", "$@25", "$@26",
  "moduleIdentityClause", "$@27", "$@28", "$@29", "$@30", "$@31", "$@32",
  "$@33", "$@34", "SubjectCategoriesPart", "SubjectCategories",
  "CategoryIDs", "CategoryID", "ObjectSyntax", "typeTag",
  "sequenceObjectSyntax", "valueofObjectSyntax", "SimpleSyntax", "$@35",
  "$@36", "$@37", "$@38", "$@39", "valueofSimpleSyntax",
  "sequenceSimpleSyntax", "ApplicationSyntax", "$@40",
  "sequenceApplicationSyntax", "anySubType", "integerSubType",
  "octetStringSubType", "ranges", "range", "value", "enumSpec",
  "enumItems", "enumItem", "$@41", "enumNumber", "Status",
  "Status_Capabilities", "DisplayPart", "UnitsPart", "Access", "IndexPart",
  "$@42", "$@43", "MibIndex", "$@44", "IndexTypes", "IndexType", "Index",
  "Entry", "DefValPart", "Value", "BitsValue", "BitNames", "ObjectName",
  "NotificationName", "ReferPart", "RevisionPart", "Revisions", "Revision",
  "$@45", "NotificationObjectsPart", "ObjectGroupObjectsPart", "Objects",
  "Object", "NotificationsPart", "Notifications", "Notification", "Text",
  "ExtUTCTime", "objectIdentifier", "$@46", "subidentifiers",
  "subidentifier", "objectIdentifier_defval", "subidentifiers_defval",
  "subidentifier_defval", "objectGroupClause", "$@47", "$@48", "$@49",
  "notificationGroupClause", "$@50", "$@51", "$@52",
  "moduleComplianceClause", "$@53", "$@54", "$@55", "ComplianceModulePart",
  "ComplianceModules", "ComplianceModule", "$@56", "ComplianceModuleName",
  "MandatoryPart", "MandatoryGroups", "MandatoryGroup", "CompliancePart",
  "Compliances", "Compliance", "ComplianceGroup", "$@57",
  "ComplianceObject", "$@58", "SyntaxPart", "WriteSyntaxPart",
  "WriteSyntax", "AccessPart", "agentCapabilitiesClause", "$@59", "$@60",
  "$@61", "ModulePart_Capabilities", "Modules_Capabilities",
  "Module_Capabilities", "$@62", "CapabilitiesGroups", "CapabilitiesGroup",
  "ModuleName_Capabilities", "VariationPart", "Variations", "Variation",
  "$@63", "$@64", "VariationAccessPart", "VariationAccess", "CreationPart",
  "Cells", "Cell", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-509)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-411)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      23,  -509,    50,    23,  -509,  -509,  -509,  -509,   -57,  -509,
       9,   -39,    32,  -509,  -509,    70,  -509,    27,   -15,  -509,
      57,  -509,    32,  -509,    95,   130,   134,  -509,   139,    65,
      89,  -509,   153,  -509,   187,   102,   535,   351,  -509,   100,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,   108,   535,  -509,    -3,  -509,
    -509,  -509,  -509,   110,   206,    64,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,   183,   461,  -509,  -509,
    -509,   126,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,    23,   535,  -509,   154,   155,   158,   166,   161,   168,
     173,   214,  -509,  -509,   180,   171,   144,   229,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,   198,
    -509,   160,   159,   156,   184,   172,   192,   194,   163,   178,
     231,   257,   232,    15,   167,  -509,   -45,   -45,   169,   -28,
     170,   169,   -45,   233,   186,   174,   -32,  -509,   -45,   175,
     169,    -2,   176,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
      55,  -509,  -509,   262,   213,   177,   199,   181,  -509,   185,
     203,   188,   204,   262,   260,  -509,   189,  -509,    36,   191,
    -509,  -509,   281,   195,   283,  -509,  -509,  -509,  -509,  -509,
    -509,   140,  -509,   169,   191,   169,  -509,  -509,  -509,   -45,
     196,   211,  -509,   287,   288,   267,  -509,   169,  -509,   289,
     291,   296,   -17,  -509,  -509,   275,   218,  -509,   262,   297,
     261,  -509,   262,  -509,   262,   284,  -509,   230,  -509,   219,
    -509,  -509,  -509,  -509,  -509,  -509,   217,   -19,  -509,   309,
    -509,  -509,   -36,  -509,  -509,  -509,    35,  -509,  -509,  -509,
    -509,  -509,   174,  -509,  -509,   301,    38,  -509,   260,   234,
    -509,   215,   222,   -45,   260,   260,     8,  -509,    56,  -509,
    -509,   294,   221,   225,   227,  -509,   302,    59,   303,  -509,
      60,  -509,  -509,   304,   260,   322,   235,   237,   305,   140,
    -509,   140,   140,   228,  -509,   281,   236,  -509,   283,  -509,
     -45,  -509,   -45,   -45,   -45,   -45,   -45,  -509,   -45,   299,
     258,  -509,   -45,   -45,  -509,  -509,  -509,  -509,  -509,  -509,
     288,  -509,   262,   306,   311,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,   266,  -509,   334,  -509,  -509,  -509,
     260,   335,  -509,   297,  -509,  -509,  -509,   260,  -509,  -509,
     260,  -509,  -509,   314,  -509,  -509,   260,   273,    -6,  -509,
    -509,   344,  -509,   136,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,   -45,   -45,  -509,  -509,  -509,   326,  -509,  -509,
     273,   334,   334,  -509,   282,  -509,  -509,  -509,  -509,   252,
    -509,   292,  -509,  -509,  -509,   273,   260,    63,  -509,  -509,
    -509,   260,   355,   259,   269,  -509,  -509,   274,  -509,  -509,
     260,   358,  -509,  -509,   272,  -509,   298,   273,  -509,   260,
     273,   273,   312,  -509,  -509,  -509,  -509,   356,  -509,  -509,
    -509,  -509,   280,  -509,   285,   262,   375,  -509,   377,   380,
     384,   381,   312,  -509,   273,  -509,  -509,   273,  -509,   293,
    -509,  -509,   371,   313,   378,   318,   319,   122,  -509,   323,
    -509,   317,   337,   308,  -509,   321,   260,   359,  -509,   260,
    -509,  -509,  -509,   353,  -509,   398,   419,   317,  -509,   213,
    -509,  -509,  -509,  -509,   273,   327,  -509,   328,   329,   331,
       2,   332,   389,  -509,   336,  -509,  -509,   338,    40,  -509,
     397,  -509,  -509,  -509,  -509,  -509,  -509,     2,  -509,  -509,
    -509,  -509,  -509,   391,  -509,   426,   342,  -509,  -509,   393,
     260,  -509,    68,  -509,  -509,  -509,  -509,   343,   346,   340,
      78,  -509,  -509,   348,   349,  -509,   360,  -509,  -509,  -509,
     420,   365,  -509,  -509,   443,  -509,   426,   354,  -509,  -509,
     357,  -509,   425,   379,  -509,   260,   213,   361,  -509,    87,
    -509,   362,  -509,  -509,   363,   367,   417,   366,   373,   454,
     302,  -509,   379,  -509,  -509,  -509,   213,   -20,   364,  -509,
    -509,  -509,  -509,  -509,    88,  -509,  -509,  -509,   370,    96,
     374,  -509,   468,  -509,  -509,  -509,   334,   334,   446,  -509,
    -509,   364,  -509,  -509,  -509,  -509,   417,   376,   382,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,   190,
    -509,  -509,   383,  -509,   448,   386,  -509,  -509,   260,  -509,
    -509,  -509,  -509,  -509,   385,  -509,   390,   387,   395,   193,
    -509,  -509,   396,   260,  -509,  -509,   365,  -509,   470,  -509,
     473,  -509,   385,  -509,  -509,  -509,   399,   361,   400,  -509,
    -509,   466,  -509,   492,   477,  -509,  -509,   403,   425,  -509,
    -509,  -509,    91,  -509,   474,  -509,  -509,   260,  -509,  -509
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       3,    52,     0,     2,     4,     6,     1,     5,     9,   339,
       0,     0,     0,    10,    11,     0,     8,    86,    85,   345,
       0,   343,   340,   341,     0,     0,     0,   342,    15,     0,
     344,    16,    13,   346,     0,     0,    19,     0,    12,     0,
      17,    26,    25,    43,    30,    44,    45,    46,    31,    50,
      32,    33,    34,    35,    47,    48,    36,    37,    38,    39,
      40,    41,    49,    42,    51,     0,    18,    20,     0,    23,
      27,    28,    29,     0,    86,    85,    82,   101,   103,   102,
      99,   104,    96,    81,    73,    80,    76,    79,    77,    74,
      98,    78,    97,    75,   100,   105,     0,     0,    55,    68,
      70,    87,    58,    57,    89,    92,    94,    95,    93,    59,
      60,    61,    62,    63,    65,    66,    64,    67,   347,    14,
      21,     0,     0,    69,     0,     0,     0,     0,     0,     0,
       0,     0,     7,    56,     0,     0,     0,     0,    22,    24,
     127,   131,   176,   180,   354,   358,   362,   397,    71,     0,
     136,     0,     0,     0,   328,   189,     0,     0,     0,     0,
       0,     0,     0,   112,     0,    83,   267,   267,   241,   206,
     211,   251,   267,     0,     0,   247,     0,   107,   267,   243,
     253,     0,     0,   110,    90,   197,   198,   199,   106,   117,
       0,   195,   200,     0,     0,     0,     0,     0,   181,     0,
       0,     0,     0,     0,     0,    72,     0,   339,     0,     0,
     217,   222,     0,     0,     0,   239,   240,   265,   266,   249,
     250,     0,   242,     0,     0,     0,   252,   238,   264,   267,
     219,     0,   248,     0,     0,   290,   246,     0,   254,     0,
       0,     0,    52,   196,   287,     0,   292,   339,     0,     0,
       0,   339,     0,   339,     0,     0,   337,     0,   339,   139,
     275,   274,   277,   276,   279,   278,     0,     0,   270,   272,
     215,   124,     0,   122,    84,   283,     0,   281,   208,   210,
     213,   224,     0,   112,   111,     0,     0,   114,     0,     0,
     245,     0,     0,     0,     0,     0,   147,   332,     0,   330,
     317,     0,   193,     0,   190,   191,     0,     0,     0,   336,
       0,   334,   318,     0,     0,     0,     0,     0,   144,     0,
     268,     0,     0,     0,   118,     0,     0,   280,     0,   221,
     267,   120,   267,   267,   267,   267,   267,   262,   267,     0,
       0,   260,   267,   267,   263,   116,   119,   203,   204,   113,
       0,   289,     0,     0,     0,   218,   223,   216,   128,   291,
     173,   171,   150,   149,   153,   146,     0,   145,   327,   339,
       0,     0,   188,     0,   338,   182,   329,     0,   333,   339,
       0,   363,   288,     0,    88,   339,     0,   320,     0,   271,
     273,     0,   123,     0,   282,   121,   256,   261,   257,   234,
     235,   255,   267,   267,   259,   258,   115,     0,   201,   202,
     320,     0,     0,   151,   156,   293,   148,   331,   177,     0,
     192,     0,   355,   335,   359,   320,     0,     0,   140,   142,
     143,     0,     0,     0,     0,   285,   286,     0,   237,   236,
       0,     0,   174,   172,     0,   154,     0,   320,   194,     0,
     320,   320,     0,   398,   138,   339,   319,     0,   269,   125,
     284,   108,     0,   339,     0,     0,     0,   183,     0,     0,
     372,     0,   365,   366,   320,   141,   137,   320,   339,     0,
     308,   339,   133,     0,     0,     0,     0,   371,   368,     0,
     367,   401,     0,     0,   152,     0,     0,   167,   339,     0,
     339,   339,   370,   374,   339,     0,     0,   400,   402,     0,
     129,   155,   134,   165,   320,     0,   184,     0,     0,     0,
     379,     0,   339,   404,     0,   403,   109,     0,   299,   178,
       0,   356,   360,   339,   384,   386,   369,   378,   380,   382,
     383,   364,   409,     0,   339,     0,     0,   297,   294,   302,
       0,   377,     0,   375,   339,   339,   381,     0,     0,     0,
       0,   168,   339,     0,     0,   300,   159,   185,   373,   339,
       0,   389,   339,   399,     0,   166,     0,     0,   339,   339,
       0,   157,   310,   322,   376,     0,     0,   391,   408,     0,
     406,     0,   169,   296,     0,     0,   339,     0,     0,     0,
       0,   186,   321,   323,   385,   388,     0,   395,   412,   339,
     170,   298,   295,   339,     0,   303,   306,   307,   339,     0,
       0,   325,     0,   324,   392,   390,     0,     0,     0,   339,
     405,   411,   413,   407,   305,   301,   339,     0,   160,   162,
     164,   231,   225,   226,   227,   228,   229,   230,   232,   314,
     311,   205,     0,   339,     0,     0,   393,   394,     0,   415,
     414,   304,   158,   339,   315,   352,     0,   313,     0,   348,
     349,   309,     0,     0,   339,   387,   389,   163,     0,   312,
       0,   233,     0,   350,   132,   326,     0,   391,     0,   316,
     187,   419,   351,     0,   422,   420,   418,     0,   310,   339,
     416,   425,     0,   423,     0,   421,   339,     0,   424,   417
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -509,  -509,  -509,   500,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,   438,  -509,   388,  -509,  -509,  -509,    13,
    -509,  -509,   411,  -509,  -509,  -509,  -509,  -509,  -509,   -16,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,   276,  -509,  -509,   162,  -192,  -509,  -509,
     200,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,    61,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -152,  -509,
    -509,  -509,   -59,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,   147,  -509,  -509,  -509,  -509,   339,  -509,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -161,  -148,
    -151,   207,   209,   205,  -182,  -509,   208,  -509,  -509,  -199,
    -509,  -509,  -509,  -404,  -509,  -509,  -509,  -509,  -509,  -509,
    -105,   -81,  -508,  -165,  -509,  -509,  -509,  -246,    39,  -384,
    -509,  -509,   -68,  -509,  -509,  -509,   300,   197,  -509,  -509,
     164,  -285,   -62,    -9,  -509,  -509,   517,  -509,  -509,  -127,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,  -509,
    -509,  -509,  -509,  -509,    72,  -509,  -509,  -509,  -509,   -14,
    -509,  -509,    12,  -509,  -509,  -509,  -509,  -120,  -130,  -509,
    -509,  -509,  -509,  -509,  -509,  -509,  -509,    54,  -509,  -509,
     -47,  -509,  -509,  -509,   -67,  -509,  -509,  -509,  -509,  -509,
    -509,  -141
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     3,     4,     8,    10,    15,    37,    38,    32,
      35,    65,    66,    67,    68,    69,    70,    71,    72,   182,
      96,    97,    98,    99,   134,   160,   100,   183,   213,    21,
     102,   135,   103,   137,   104,   105,   106,   107,   108,   184,
     235,   477,   185,   186,   187,   286,   287,   188,   345,   272,
     273,   323,   109,   124,   152,   410,   110,   125,   153,   497,
     111,   136,   162,   318,   427,   428,   387,   364,   365,   366,
     414,   444,   446,   464,   582,   597,   637,   638,   639,   514,
     527,   560,   561,   367,   412,   411,   112,   126,   154,   447,
     113,   127,   155,   250,   421,   484,   530,   583,   622,   198,
     303,   304,   305,   189,   190,   346,   650,   191,   223,   224,
     225,   209,   282,   651,   347,   192,   237,   348,   215,   228,
     217,   267,   268,   269,   218,   276,   277,   326,   437,   245,
     383,   289,   296,   416,   549,   564,   563,   566,   580,   614,
     615,   616,   479,   599,   652,   666,   667,   480,   309,   432,
     601,   602,   603,   654,   196,   200,   298,   299,   202,   310,
     311,   257,   375,   300,    12,    22,    23,   668,   669,   670,
     114,   128,   156,   450,   115,   129,   157,   451,   116,   130,
     158,   425,   471,   472,   473,   503,   488,   520,   552,   553,
     536,   537,   538,   539,   554,   540,   555,   587,   607,   625,
     628,   117,   131,   159,   474,   506,   507,   508,   543,   589,
     590,   523,   630,   631,   632,   676,   704,   694,   696,   698,
     702,   703
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      11,   297,   246,   351,   255,   297,   219,   442,   443,   358,
     359,   227,   211,     5,   239,   210,     5,   236,   216,   220,
     222,   101,   360,   226,   232,    20,   441,   270,     1,   381,
     121,   626,   238,   233,    13,    20,   534,    17,    18,    19,
       9,   452,   279,   260,   261,   262,   263,   264,   265,   301,
       6,   627,   214,   308,   577,   313,   208,   546,   361,    16,
     242,   535,   324,   466,   325,   234,   468,   469,   281,  -209,
     594,   595,   547,  -207,    24,   278,   362,   280,    14,  -396,
    -214,   101,   363,   320,   208,   418,    25,   321,   240,   290,
     491,   211,   422,   492,   210,   424,   433,   122,   169,   170,
     321,   430,   641,   642,   643,   644,   645,   646,   647,   648,
     548,   357,  -214,    28,   173,   266,   208,  -361,  -179,   174,
     -52,  -357,  -175,   297,  -353,  -126,  -130,  -339,  -339,  -339,
     528,   329,   -52,   327,   138,   328,   349,    29,   350,   429,
      30,   453,   356,   435,   436,   355,   456,   260,   261,   262,
     263,   264,   265,   407,   368,   461,   369,   376,   378,   369,
     379,   454,    26,   455,   467,   163,   568,    33,   569,   395,
      31,   396,   397,   398,   399,   400,   575,   401,   576,   164,
     165,   404,   405,   166,   167,   608,   635,   609,   636,   705,
      34,   706,    36,   649,    39,   168,   664,   665,   259,   682,
     665,    40,   118,   169,   170,   171,   172,   119,   123,   429,
     -91,   512,   132,  -135,   516,   140,   142,   141,   163,   173,
     143,   144,   656,   657,   174,   145,   146,   175,   148,   147,
     149,   150,   164,   151,   161,   495,   166,   167,   176,   193,
     194,   438,   439,   203,   312,   177,   178,   195,   168,   316,
     201,   179,   180,   204,   197,   199,   169,   170,   171,   172,
     205,   206,   207,   181,   212,   567,   482,   230,   244,   229,
     221,  -212,   173,   256,   247,   231,  -244,   174,   249,   248,
     175,   241,   251,   252,   254,   253,   258,   271,   214,   275,
     266,   176,   283,   274,   285,   288,   291,  -220,   292,   178,
     604,   293,   294,   302,   179,   180,   330,   295,   306,   571,
     315,   314,   322,   317,   352,   374,   181,   526,   319,   353,
     331,   370,   371,   372,   332,   333,   354,   373,   382,   391,
     377,   380,   386,   384,   385,   402,   334,   393,   413,   403,
     415,   426,   419,   408,   335,   336,   337,   338,   409,   431,
     617,   434,    73,   440,   448,   445,    74,    75,   449,   457,
     339,   458,   462,   476,   470,   340,    76,   617,   341,   463,
     312,   459,   640,   675,    77,    78,   460,   478,   465,   483,
     -54,   485,   481,   659,   486,   489,    79,   342,   685,   487,
     617,   494,   343,   344,   605,    80,    81,    82,   496,   499,
     505,   513,   519,   522,    83,    84,   510,   672,    85,    86,
     498,    87,    88,    89,   624,   500,   501,   640,    90,   511,
     504,   509,   709,   524,   550,   529,   531,   532,   533,  -410,
     541,   557,   559,   544,   565,   545,    91,    92,    93,   562,
     572,   574,    94,    95,   573,   578,   579,   585,   581,   586,
     591,   598,   593,   701,   596,   613,   600,   606,   620,   629,
     701,   611,    73,   618,   610,   612,    74,    75,  -161,   493,
     619,   653,   655,   658,   662,   673,    76,   688,   502,   689,
     693,   671,   663,   674,    77,    78,   678,   680,   679,   312,
     -53,   517,   518,   681,   684,   521,    79,   690,   695,   697,
     699,   707,   692,     7,   120,    80,    81,    82,   133,   284,
     139,   677,   406,   542,    83,    84,   475,   592,    85,    86,
     420,    87,    88,    89,   551,   392,   388,   390,    90,   243,
     389,   661,   634,   700,   623,   558,   394,   515,   621,    27,
      41,    42,   683,   423,   490,   570,    91,    92,    93,   556,
      43,   307,    94,    95,    44,   584,   687,   691,    45,    46,
     551,   525,   633,   588,   660,   708,   417,     0,     0,     0,
      47,     0,     0,     0,     0,     0,     0,     0,     0,    48,
      49,    50,     0,     0,    51,     0,     0,     0,    52,    53,
       0,     0,    54,    55,     0,    56,    57,    58,     0,     0,
     588,     0,    59,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      60,    61,    62,     0,     0,     0,    63,    64,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   686
};

static const yytype_int16 yycheck[] =
{
       9,   247,   194,   288,   203,   251,   167,   411,   412,   294,
     295,   172,   163,     0,    16,   163,     3,   178,   166,   167,
     168,    37,    14,   171,   175,    12,   410,   209,     5,   314,
      33,    51,   180,    65,    25,    22,    34,     5,     6,     7,
      97,   425,   224,     7,     8,     9,    10,    11,    12,   248,
       0,    71,    97,   252,   562,   254,   101,    17,    50,    98,
       5,    59,    98,   447,   100,    97,   450,   451,   229,    97,
     578,   579,    32,   101,     4,   223,    68,   225,    69,    15,
      97,    97,    74,   102,   101,   370,   101,   106,    90,   237,
     474,   242,   377,   477,   242,   380,   102,   100,    43,    44,
     106,   386,     6,     7,     8,     9,    10,    11,    12,    13,
      70,   293,    97,    18,    59,    79,   101,    53,    54,    64,
     105,    57,    58,   369,    60,    61,    62,     5,     6,     7,
     514,   282,   105,    98,   121,   100,    98,     7,   100,   385,
       6,   426,   293,     7,     8,   293,   431,     7,     8,     9,
      10,    11,    12,   352,    98,   440,   100,    98,    98,   100,
     100,    98,   105,   100,   449,     5,    98,   102,   100,   330,
      31,   332,   333,   334,   335,   336,    98,   338,   100,    19,
      20,   342,   343,    23,    24,    98,    98,   100,   100,    98,
     101,   100,    39,    97,     7,    35,     6,     7,   207,     6,
       7,    99,   102,    43,    44,    45,    46,    99,    98,   455,
       4,   496,    29,    87,   499,    61,    58,    62,     5,    59,
      54,    60,   626,   627,    64,    57,    53,    67,    48,    15,
      59,    87,    19,     4,    36,   481,    23,    24,    78,    80,
      84,   402,   403,    80,   253,    85,    86,    63,    35,   258,
      56,    91,    92,    75,    82,    63,    43,    44,    45,    46,
      29,     4,    30,   103,    97,   550,   465,    81,     6,    36,
     101,   101,    59,    13,    97,   101,   101,    64,    97,    80,
      67,   105,    97,    80,    80,    97,    97,     6,    97,     6,
      79,    78,     5,    98,     6,    28,     7,   101,     7,    86,
     585,     5,    27,     6,    91,    92,     5,    89,    47,   555,
      80,    27,     3,    94,    80,    13,   103,   509,   101,   104,
      19,    27,   101,    98,    23,    24,   104,   100,     6,   101,
      27,    27,    27,    98,    97,    36,    35,   101,    72,    81,
       6,    27,     7,    37,    43,    44,    45,    46,    37,    76,
     596,     7,     1,    27,   102,    73,     5,     6,    66,     4,
      59,   102,     4,     7,    52,    64,    15,   613,    67,    97,
     379,   102,   618,   658,    23,    24,   102,    97,    80,     4,
      29,     4,    97,   629,     4,     4,    35,    86,   673,     5,
     636,    98,    91,    92,   586,    44,    45,    46,    27,    21,
      83,    42,    49,     5,    53,    54,    98,   653,    57,    58,
      97,    60,    61,    62,   606,    97,    97,   663,    67,    98,
      97,    84,   707,     4,    27,    98,    98,    98,    97,    40,
      98,    40,     6,    97,    41,    97,    85,    86,    87,    97,
      97,   101,    91,    92,    98,    97,    97,    27,    88,    84,
       7,    26,    98,   699,    97,    38,    77,    96,     4,    95,
     706,    98,     1,    97,   102,    98,     5,     6,    98,   478,
      97,    97,     4,    27,    98,    27,    15,     7,   487,     6,
      14,    98,   100,    97,    23,    24,   101,   100,    98,   498,
      29,   500,   501,    98,    98,   504,    35,    98,     6,    22,
      97,    27,   102,     3,    66,    44,    45,    46,    97,   233,
     122,   663,   350,   522,    53,    54,   455,   576,    57,    58,
     373,    60,    61,    62,   533,   325,   319,   322,    67,   190,
     321,   636,   613,   698,   602,   544,   328,   498,   600,    22,
       5,     6,   669,   379,   472,   554,    85,    86,    87,   537,
      15,   251,    91,    92,    19,   569,   676,   687,    23,    24,
     569,   507,   609,   572,   631,   706,   369,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      45,    46,    -1,    -1,    49,    -1,    -1,    -1,    53,    54,
      -1,    -1,    57,    58,    -1,    60,    61,    62,    -1,    -1,
     609,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   674
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     5,   108,   109,   110,   126,     0,   110,   111,    97,
     112,   270,   271,    25,    69,   113,    98,     5,     6,     7,
     126,   136,   272,   273,     4,   101,   105,   273,    18,     7,
       6,    31,   116,   102,   101,   117,    39,   114,   115,     7,
      99,     5,     6,    15,    19,    23,    24,    35,    44,    45,
      46,    49,    53,    54,    57,    58,    60,    61,    62,    67,
      85,    86,    87,    91,    92,   118,   119,   120,   121,   122,
     123,   124,   125,     1,     5,     6,    15,    23,    24,    35,
      44,    45,    46,    53,    54,    57,    58,    60,    61,    62,
      67,    85,    86,    87,    91,    92,   127,   128,   129,   130,
     133,   136,   137,   139,   141,   142,   143,   144,   145,   159,
     163,   167,   193,   197,   277,   281,   285,   308,   102,    99,
     120,    33,   100,    98,   160,   164,   194,   198,   278,   282,
     286,   309,    29,   129,   131,   138,   168,   140,   126,   122,
      61,    62,    58,    54,    60,    57,    53,    15,    48,    59,
      87,     4,   161,   165,   195,   199,   279,   283,   287,   310,
     132,    36,   169,     5,    19,    20,    23,    24,    35,    43,
      44,    45,    46,    59,    64,    67,    78,    85,    86,    91,
      92,   103,   126,   134,   146,   149,   150,   151,   154,   210,
     211,   214,   222,    80,    84,    63,   261,    82,   206,    63,
     262,    56,   265,    80,    75,    29,     4,    30,   101,   218,
     226,   227,    97,   135,    97,   225,   226,   227,   231,   225,
     226,   101,   226,   215,   216,   217,   226,   225,   226,    36,
      81,   101,   227,    65,    97,   147,   225,   223,   226,    16,
      90,   105,     5,   214,     6,   236,   154,    97,    80,    97,
     200,    97,    80,    97,    80,   236,    13,   268,    97,   270,
       7,     8,     9,    10,    11,    12,    79,   228,   229,   230,
     231,     6,   156,   157,    98,     6,   232,   233,   226,   231,
     226,   225,   219,     5,   150,     6,   152,   153,    28,   238,
     226,     7,     7,     5,    27,    89,   239,   254,   263,   264,
     270,   236,     6,   207,   208,   209,    47,   263,   236,   255,
     266,   267,   270,   236,    27,    80,   270,    94,   170,   101,
     102,   106,     3,   158,    98,   100,   234,    98,   100,   227,
       5,    19,    23,    24,    35,    43,    44,    45,    46,    59,
      64,    67,    86,    91,    92,   155,   212,   221,   224,    98,
     100,   268,    80,   104,   104,   226,   227,   231,   268,   268,
      14,    50,    68,    74,   174,   175,   176,   190,    98,   100,
      27,   101,    98,   100,    13,   269,    98,    27,    98,   100,
      27,   268,     6,   237,    98,    97,    27,   173,   228,   229,
     230,   101,   157,   101,   233,   225,   225,   225,   225,   225,
     225,   225,    36,    81,   225,   225,   153,   236,    37,    37,
     162,   192,   191,    72,   177,     6,   240,   264,   268,     7,
     209,   201,   268,   267,   268,   288,    27,   171,   172,   254,
     268,    76,   256,   102,     7,     7,     8,   235,   225,   225,
      27,   256,   240,   240,   178,    73,   179,   196,   102,    66,
     280,   284,   256,   268,    98,   100,   268,     4,   102,   102,
     102,   268,     4,    97,   180,    80,   256,   268,   256,   256,
      52,   289,   290,   291,   311,   172,     7,   148,    97,   249,
     254,    97,   236,     4,   202,     4,     4,     5,   293,     4,
     291,   256,   256,   270,    98,   254,    27,   166,    97,    21,
      97,    97,   270,   292,    97,    83,   312,   313,   314,    84,
      98,    98,   268,    42,   186,   255,   268,   270,   270,    49,
     294,   270,     5,   318,     4,   314,   154,   187,   256,    98,
     203,    98,    98,    97,    34,    59,   297,   298,   299,   300,
     302,    98,   270,   315,    97,    97,    17,    32,    70,   241,
      27,   270,   295,   296,   301,   303,   299,    40,   270,     6,
     188,   189,    97,   243,   242,    41,   244,   268,    98,   100,
     270,   254,    97,    98,   101,    98,   100,   249,    97,    97,
     245,    88,   181,   204,   296,    27,    84,   304,   270,   316,
     317,     7,   189,    98,   249,   249,    97,   182,    26,   250,
      77,   257,   258,   259,   268,   154,    96,   305,    98,   100,
     102,    98,    98,    38,   246,   247,   248,   254,    97,    97,
       4,   269,   205,   259,   154,   306,    51,    71,   307,    95,
     319,   320,   321,   317,   248,    98,   100,   183,   184,   185,
     254,     6,     7,     8,     9,    10,    11,    12,    13,    97,
     213,   220,   251,    97,   260,     4,   240,   240,    27,   254,
     321,   247,    98,   100,     6,     7,   252,   253,   274,   275,
     276,    98,   254,    27,    97,   268,   322,   185,   101,    98,
     100,    98,     6,   276,    98,   268,   270,   304,     7,     6,
      98,   305,   102,    14,   324,     6,   325,    22,   326,    97,
     250,   254,   327,   328,   323,    98,   100,    27,   328,   268
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   107,   108,   108,   109,   109,   111,   110,   112,   112,
     113,   113,   114,   114,   115,   116,   117,   116,   118,   118,
     119,   119,   120,   121,   121,   122,   122,   122,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   124,   124,   124,   124,   124,   124,   124,
     125,   125,   126,   127,   127,   128,   128,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     131,   132,   130,   133,   133,   133,   133,   133,   133,   133,
     133,   133,   133,   135,   134,   136,   136,   138,   137,   140,
     139,   141,   141,   141,   142,   142,   143,   143,   143,   143,
     143,   144,   144,   144,   145,   145,   146,   147,   148,   146,
     146,   149,   150,   151,   152,   152,   153,   154,   154,   155,
     155,   155,   156,   156,   158,   157,   160,   161,   162,   159,
     164,   165,   163,   166,   166,   168,   169,   167,   170,   170,
     171,   171,   172,   173,   173,   174,   174,   174,   175,   176,
     176,   178,   177,   177,   180,   179,   179,   182,   181,   181,
     183,   183,   184,   184,   185,   187,   186,   186,   188,   188,
     189,   191,   190,   192,   190,   194,   195,   196,   193,   198,
     199,   200,   201,   202,   203,   204,   205,   197,   206,   206,
     207,   208,   208,   209,   209,   210,   210,   210,   210,   210,
     210,   211,   211,   212,   212,   213,   214,   215,   214,   216,
     214,   214,   217,   214,   218,   214,   214,   214,   214,   214,
     219,   214,   214,   214,   214,   220,   220,   220,   220,   220,
     220,   220,   220,   220,   221,   221,   221,   221,   222,   222,
     222,   222,   222,   222,   223,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   224,   224,   224,   224,   224,
     224,   224,   224,   224,   225,   225,   225,   225,   226,   227,
     228,   228,   229,   229,   230,   230,   230,   230,   230,   230,
     231,   232,   232,   234,   233,   235,   235,   236,   237,   238,
     238,   239,   239,   240,   242,   241,   241,   243,   241,   241,
     245,   244,   244,   246,   246,   247,   247,   248,   249,   250,
     250,   251,   251,   252,   252,   253,   253,   254,   255,   256,
     256,   257,   257,   258,   258,   260,   259,   261,   261,   262,
     263,   263,   264,   265,   266,   266,   267,   268,   269,   271,
     270,   272,   272,   273,   273,   273,   273,   273,   274,   275,
     275,   276,   276,   278,   279,   280,   277,   282,   283,   284,
     281,   286,   287,   288,   285,   289,   290,   290,   292,   291,
     293,   293,   293,   294,   294,   295,   295,   296,   297,   297,
     298,   298,   299,   299,   301,   300,   303,   302,   304,   304,
     305,   305,   306,   307,   307,   307,   309,   310,   311,   308,
     312,   312,   313,   313,   315,   314,   316,   316,   317,   318,
     318,   319,   319,   320,   320,   322,   323,   321,   324,   324,
     325,   326,   326,   327,   327,   328
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     1,     2,     0,    10,     3,     0,
       1,     1,     1,     0,     3,     0,     0,     3,     1,     0,
       1,     2,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       0,     0,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     3,     1,     1,     0,     8,     0,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     0,    11,
       1,     3,     1,     4,     1,     3,     2,     1,     4,     1,
       1,     2,     1,     3,     0,     5,     0,     0,     0,    14,
       0,     0,    23,     0,     2,     0,     0,    11,     4,     0,
       1,     3,     1,     2,     0,     1,     1,     0,     2,     1,
       1,     0,     5,     0,     0,     5,     0,     0,     5,     0,
       1,     0,     1,     3,     1,     0,     5,     0,     1,     3,
       4,     0,     3,     0,     3,     0,     0,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,    24,     4,     0,
       1,     1,     3,     1,     4,     1,     2,     1,     1,     1,
       1,     5,     5,     1,     1,     1,     1,     0,     3,     0,
       3,     1,     0,     3,     0,     3,     4,     2,     4,     2,
       0,     4,     2,     4,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     2,     3,     3,     2,     2,
       2,     1,     2,     1,     0,     3,     2,     1,     2,     2,
       2,     1,     2,     1,     2,     2,     2,     2,     2,     2,
       1,     2,     1,     1,     1,     1,     1,     0,     3,     6,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     0,     5,     1,     1,     1,     1,     2,
       0,     2,     0,     1,     0,     5,     4,     0,     5,     0,
       0,     5,     0,     1,     3,     2,     1,     1,     1,     4,
       0,     1,     3,     1,     0,     1,     3,     1,     1,     2,
       0,     1,     0,     1,     2,     0,     5,     4,     0,     4,
       1,     3,     1,     4,     1,     3,     1,     1,     1,     0,
       2,     1,     2,     1,     3,     1,     4,     6,     1,     1,
       2,     4,     1,     0,     0,     0,    15,     0,     0,     0,
      15,     0,     0,     0,    15,     1,     1,     2,     0,     5,
       2,     1,     0,     4,     0,     1,     3,     1,     1,     0,
       1,     2,     1,     1,     0,     5,     0,     8,     2,     0,
       2,     0,     1,     2,     2,     0,     0,     0,     0,    17,
       1,     0,     1,     2,     0,     8,     1,     3,     1,     2,
       1,     1,     0,     1,     2,     0,     0,    11,     2,     0,
       1,     4,     0,     1,     3,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (parserPtr, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, parserPtr); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, struct Parser *parserPtr)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (parserPtr);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, struct Parser *parserPtr)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, parserPtr);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, struct Parser *parserPtr)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], parserPtr);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parserPtr); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, struct Parser *parserPtr)
{
  YY_USE (yyvaluep);
  YY_USE (parserPtr);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct Parser *parserPtr)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, parserPtr);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* mibFile: modules  */
#line 1596 "parser-smi.y"
    {
        (yyval.err) = 0;
    }
#line 3239 "parser-smi.c"
    break;

  case 3: /* mibFile: %empty  */
#line 1600 "parser-smi.y"
    {
	(yyval.err) = 0;
    }
#line 3247 "parser-smi.c"
    break;

  case 4: /* modules: module  */
#line 1606 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3253 "parser-smi.c"
    break;

  case 5: /* modules: modules module  */
#line 1608 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3259 "parser-smi.c"
    break;

  case 6: /* $@1: %empty  */
#line 1616 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULE;
			    
			    thisParserPtr->modulePtr = findModuleByName((yyvsp[0].id));
			    if (!thisParserPtr->modulePtr) {
				thisParserPtr->modulePtr =
				    addModule((yyvsp[0].id),
					      smiStrdup(thisParserPtr->path),
					      0,
					      thisParserPtr);
				thisParserPtr->modulePtr->
				    numImportedIdentifiers = 0;
				thisParserPtr->modulePtr->
				    numStatements = 0;
				thisParserPtr->modulePtr->
				    numModuleIdentities = 0;
				if (!strcmp((yyvsp[0].id), "SNMPv2-SMI")) {
			            /*
				     * SNMPv2-SMI is an SMIv2 module
				     * that cannot be identified by
				     * importing from SNMPv2-SMI.
				     */
				    thisModulePtr->export.language =
					SMI_LANGUAGE_SMIV2;
				}
			    } else {
			        smiPrintError(thisParserPtr,
					      ERR_MODULE_ALREADY_LOADED,
					      (yyvsp[0].id));
				/*
				 * this aborts parsing the whole file,
				 * not only the current module.
				 */
				YYABORT;
			    }
			}
#line 3301 "parser-smi.c"
    break;

  case 7: /* module: moduleName $@1 moduleOid definitions COLON_COLON_EQUAL BEGIN_ exportsClause linkagePart declarationPart END  */
#line 1660 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV1;
			    checkModuleName(thisParserPtr, thisModulePtr);
			    checkModuleIdentity(thisParserPtr, thisModulePtr);
			    checkObjects(thisParserPtr, thisModulePtr);
			    checkTypes(thisParserPtr, thisModulePtr);
			    checkDefvals(thisParserPtr, thisModulePtr);
			    checkImportsUsage(thisParserPtr, thisModulePtr);
			    smiCheckTypeUsage(thisParserPtr, thisModulePtr);
			    
			    thisParserPtr->capabilitiesModulePtr = NULL;

                            (yyval.err) = 0;
			}
#line 3321 "parser-smi.c"
    break;

  case 8: /* moduleOid: '{' objectIdentifier '}'  */
#line 1678 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3327 "parser-smi.c"
    break;

  case 9: /* moduleOid: %empty  */
#line 1680 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3333 "parser-smi.c"
    break;

  case 10: /* definitions: DEFINITIONS  */
#line 1684 "parser-smi.y"
                        { }
#line 3339 "parser-smi.c"
    break;

  case 11: /* definitions: PIB_DEFINITIONS  */
#line 1686 "parser-smi.y"
                        {
                            thisModulePtr->export.language = SMI_LANGUAGE_SPPI;
                        }
#line 3347 "parser-smi.c"
    break;

  case 12: /* linkagePart: linkageClause  */
#line 1695 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3353 "parser-smi.c"
    break;

  case 13: /* linkagePart: %empty  */
#line 1697 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3359 "parser-smi.c"
    break;

  case 14: /* linkageClause: IMPORTS importPart ';'  */
#line 1701 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULE;

			    if ((thisModulePtr->export.language != SMI_LANGUAGE_SMIV2) &&
                                (thisModulePtr->export.language != SMI_LANGUAGE_SPPI))
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV1;
			    
			    (yyval.err) = 0;
			}
#line 3374 "parser-smi.c"
    break;

  case 15: /* exportsClause: %empty  */
#line 1715 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3380 "parser-smi.c"
    break;

  case 16: /* $@2: %empty  */
#line 1717 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language ==
                                 SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "EXPORTS");
                            
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULE;

			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI")) {
			        smiPrintError(thisParserPtr, ERR_EXPORTS);
			    }
			}
#line 3400 "parser-smi.c"
    break;

  case 17: /* exportsClause: EXPORTS $@2 ';'  */
#line 1734 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3406 "parser-smi.c"
    break;

  case 18: /* importPart: imports  */
#line 1738 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3412 "parser-smi.c"
    break;

  case 19: /* importPart: %empty  */
#line 1740 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3418 "parser-smi.c"
    break;

  case 20: /* imports: import  */
#line 1745 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3424 "parser-smi.c"
    break;

  case 21: /* imports: imports import  */
#line 1747 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3430 "parser-smi.c"
    break;

  case 22: /* import: importIdentifiers FROM moduleName  */
#line 1753 "parser-smi.y"
                        {
			    Import      *importPtr;
			    Module      *modulePtr;
                            
			    /*
			     * Recursively call the parser to suffer
			     * the IMPORTS, if the module is not yet
			     * loaded.
			     */
			    modulePtr = findModuleByName((yyvsp[0].id));
			    if (!modulePtr) {
				modulePtr = loadModule((yyvsp[0].id), thisParserPtr);
			    }
			    checkImports(modulePtr, thisParserPtr);

			    if (modulePtr && !strcmp((yyvsp[0].id), "SNMPv2-SMI")) {
			        /*
				 * A module that imports a macro or
				 * type definition from SNMPv2-SMI
				 * seems to be SMIv2 style - but only if
                                 * it is not SPPI yet.
				 */
                                if (thisModulePtr->export.language != SMI_LANGUAGE_SPPI) {
				    for (importPtr =
					     thisModulePtr->firstImportPtr;
				         importPtr;
				         importPtr = importPtr->nextPtr) {
				        if ((!strcmp(importPtr->export.module,
						     (yyvsp[0].id))) &&
					    ((importPtr->kind == KIND_MACRO) ||
					     (importPtr->kind == KIND_TYPE))) {
					    thisModulePtr->export.language =
					        SMI_LANGUAGE_SMIV2;
				        }
				    }
                                }
			    }

			    smiFree((yyvsp[0].id));
			}
#line 3475 "parser-smi.c"
    break;

  case 23: /* importIdentifiers: importIdentifier  */
#line 1796 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3481 "parser-smi.c"
    break;

  case 24: /* importIdentifiers: importIdentifiers ',' importIdentifier  */
#line 1799 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3487 "parser-smi.c"
    break;

  case 25: /* importIdentifier: LOWERCASE_IDENTIFIER  */
#line 1806 "parser-smi.y"
                        {
			    addImport((yyvsp[0].id), thisParserPtr);
			    thisParserPtr->modulePtr->numImportedIdentifiers++;
			    (yyval.id) = 0;
			}
#line 3497 "parser-smi.c"
    break;

  case 26: /* importIdentifier: UPPERCASE_IDENTIFIER  */
#line 1812 "parser-smi.y"
                        {
			    addImport((yyvsp[0].id), thisParserPtr);
			    thisParserPtr->modulePtr->numImportedIdentifiers++;
			    (yyval.id) = 0;
			}
#line 3507 "parser-smi.c"
    break;

  case 27: /* importIdentifier: importedKeyword  */
#line 1818 "parser-smi.y"
                        {
			    addImport(smiStrdup((yyvsp[0].id)), thisParserPtr);
			    thisParserPtr->modulePtr->numImportedIdentifiers++;
			    (yyval.id) = 0;
			}
#line 3517 "parser-smi.c"
    break;

  case 28: /* importedKeyword: importedSMIKeyword  */
#line 1834 "parser-smi.y"
                        {
                            /*
                             * There are PIBs that import e.g. Counter64 - so
                             * don't complain here about SMI keywords.
                             */
                           /* if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                              smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, $1);*/
                            (yyval.id) = (yyvsp[0].id);
                        }
#line 3531 "parser-smi.c"
    break;

  case 29: /* importedKeyword: importedSPPIKeyword  */
#line 1844 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
				smiPrintError(thisParserPtr, ERR_SPPI_TYPE_IN_MIB, (yyvsp[0].id));
                            (yyval.id) = (yyvsp[0].id);
                        }
#line 3541 "parser-smi.c"
    break;

  case 52: /* moduleName: UPPERCASE_IDENTIFIER  */
#line 1878 "parser-smi.y"
                        {
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_MODULENAME_32, ERR_MODULENAME_64);
			    (yyval.id) = (yyvsp[0].id);
			}
#line 3551 "parser-smi.c"
    break;

  case 53: /* declarationPart: declarations  */
#line 1890 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3557 "parser-smi.c"
    break;

  case 54: /* declarationPart: %empty  */
#line 1892 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3563 "parser-smi.c"
    break;

  case 55: /* declarations: declaration  */
#line 1897 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3569 "parser-smi.c"
    break;

  case 56: /* declarations: declarations declaration  */
#line 1899 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 3575 "parser-smi.c"
    break;

  case 57: /* declaration: typeDeclaration  */
#line 1903 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3584 "parser-smi.c"
    break;

  case 58: /* declaration: valueDeclaration  */
#line 1908 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3593 "parser-smi.c"
    break;

  case 59: /* declaration: objectIdentityClause  */
#line 1913 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3602 "parser-smi.c"
    break;

  case 60: /* declaration: objectTypeClause  */
#line 1918 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3611 "parser-smi.c"
    break;

  case 61: /* declaration: trapTypeClause  */
#line 1923 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3620 "parser-smi.c"
    break;

  case 62: /* declaration: notificationTypeClause  */
#line 1928 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3629 "parser-smi.c"
    break;

  case 63: /* declaration: moduleIdentityClause  */
#line 1933 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3638 "parser-smi.c"
    break;

  case 64: /* declaration: moduleComplianceClause  */
#line 1938 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3647 "parser-smi.c"
    break;

  case 65: /* declaration: objectGroupClause  */
#line 1943 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3656 "parser-smi.c"
    break;

  case 66: /* declaration: notificationGroupClause  */
#line 1948 "parser-smi.y"
                        {
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3665 "parser-smi.c"
    break;

  case 67: /* declaration: agentCapabilitiesClause  */
#line 1953 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3674 "parser-smi.c"
    break;

  case 68: /* declaration: macroClause  */
#line 1958 "parser-smi.y"
                        { 
			    thisParserPtr->modulePtr->numStatements++;
			    (yyval.err) = 0;
			}
#line 3683 "parser-smi.c"
    break;

  case 69: /* declaration: error '}'  */
#line 1963 "parser-smi.y"
                        {
			    smiPrintError(thisParserPtr,
					  ERR_FLUSH_DECLARATION);
			    yyerrok;
			    (yyval.err) = 1;
			}
#line 3694 "parser-smi.c"
    break;

  case 70: /* $@3: %empty  */
#line 1977 "parser-smi.y"
                        {
			    Macro *macroPtr;

			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MACRO;

			    macroPtr = addMacro(smiStrdup((yyvsp[0].id)),
						0, thisParserPtr);
			    setMacroLine(macroPtr, thisParserPtr->firstStatementLine,
					 thisParserPtr);
			}
#line 3710 "parser-smi.c"
    break;

  case 71: /* $@4: %empty  */
#line 1989 "parser-smi.y"
                        {
			    /*
			     * ASN.1 macros are known to be in these
			     * modules.
			     */
			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-SMI") &&
			        strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-TC") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-CONF") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1212") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1215") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") &&
                                strcmp(thisParserPtr->modulePtr->export.name,
                                       "COPS-PR-SPPI") &&
                                strcmp(thisParserPtr->modulePtr->export.name,
                                       "COPS-PR-SPPI-TC")) {
			        smiPrintError(thisParserPtr, ERR_MACRO);
			    }
			}
#line 3741 "parser-smi.c"
    break;

  case 72: /* macroClause: macroName $@3 MACRO $@4 END  */
#line 2017 "parser-smi.y"
                        {
			    (yyval.err) = 0;
                        }
#line 3749 "parser-smi.c"
    break;

  case 73: /* macroName: MODULE_IDENTITY  */
#line 2022 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3755 "parser-smi.c"
    break;

  case 74: /* macroName: OBJECT_TYPE  */
#line 2023 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3761 "parser-smi.c"
    break;

  case 75: /* macroName: TRAP_TYPE  */
#line 2024 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3767 "parser-smi.c"
    break;

  case 76: /* macroName: NOTIFICATION_TYPE  */
#line 2025 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3773 "parser-smi.c"
    break;

  case 77: /* macroName: OBJECT_IDENTITY  */
#line 2026 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3779 "parser-smi.c"
    break;

  case 78: /* macroName: TEXTUAL_CONVENTION  */
#line 2027 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3785 "parser-smi.c"
    break;

  case 79: /* macroName: OBJECT_GROUP  */
#line 2028 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3791 "parser-smi.c"
    break;

  case 80: /* macroName: NOTIFICATION_GROUP  */
#line 2029 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3797 "parser-smi.c"
    break;

  case 81: /* macroName: MODULE_COMPLIANCE  */
#line 2030 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3803 "parser-smi.c"
    break;

  case 82: /* macroName: AGENT_CAPABILITIES  */
#line 2031 "parser-smi.y"
                                            { (yyval.id) = (yyvsp[0].id); }
#line 3809 "parser-smi.c"
    break;

  case 83: /* $@5: %empty  */
#line 2035 "parser-smi.y"
                        {
			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-SMI") &&
			        strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-TC") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-CONF") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1212") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") && 
                                strcmp(thisParserPtr->modulePtr->export.name,
                                       "COPS-PR-SPPI")) {
			        smiPrintError(thisParserPtr, ERR_CHOICE);
			    }
			}
#line 3832 "parser-smi.c"
    break;

  case 84: /* choiceClause: CHOICE $@5 '}'  */
#line 2055 "parser-smi.y"
                        {
			    (yyval.typePtr) = addType(NULL, SMI_BASETYPE_UNKNOWN, 0,
					 thisParserPtr);
			}
#line 3841 "parser-smi.c"
    break;

  case 85: /* fuzzy_lowercase_identifier: LOWERCASE_IDENTIFIER  */
#line 2065 "parser-smi.y"
                        {
			  (yyval.id) = (yyvsp[0].id);
			}
#line 3849 "parser-smi.c"
    break;

  case 86: /* fuzzy_lowercase_identifier: UPPERCASE_IDENTIFIER  */
#line 2070 "parser-smi.y"
                        {
			    smiPrintError (thisParserPtr,
					   ERR_BAD_LOWER_IDENTIFIER_CASE,
					   (yyvsp[0].id));
			    /* xxx
			    if ((thisParserPtr->flags & SMI_FLAG_BE_LAX) == 0) {
			        YYERROR;
			    }
			    */
			  (yyval.id) = (yyvsp[0].id);
			}
#line 3865 "parser-smi.c"
    break;

  case 87: /* $@6: %empty  */
#line 2085 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_VALUEASSIGNMENT;

			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
			        if (strchr((yyvsp[0].id), '-') &&
				    (strcmp((yyvsp[0].id), "mib-2") ||
				  strcmp(thisModulePtr->export.name, "SNMPv2-SMI"))) {
				    smiPrintError(thisParserPtr,
						  ERR_OIDNAME_INCLUDES_HYPHEN,
						  (yyvsp[0].id));
				}
			    }
			}
#line 3889 "parser-smi.c"
    break;

  case 88: /* valueDeclaration: fuzzy_lowercase_identifier $@6 OBJECT IDENTIFIER COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 2106 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-7].id), &objectPtr);
			    objectPtr = setObjectName(objectPtr, (yyvsp[-7].id), thisParserPtr);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_VALUEASSIGNMENT);
			    (yyval.err) = 0;
			}
#line 3907 "parser-smi.c"
    break;

  case 89: /* $@7: %empty  */
#line 2125 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_TYPEASSIGNMENT;

			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_TYPENAME_32, ERR_TYPENAME_64);
			}
#line 3919 "parser-smi.c"
    break;

  case 90: /* typeDeclaration: typeName $@7 COLON_COLON_EQUAL typeDeclarationRHS  */
#line 2133 "parser-smi.y"
                        {
			    Type *typePtr;
			    
			    if (strlen((yyvsp[-3].id))) {
				if ((yyvsp[0].typePtr)->export.basetype != SMI_BASETYPE_UNKNOWN) {
				    smiCheckTypeName(thisParserPtr,
						     thisModulePtr, (yyvsp[-3].id),
						     thisParserPtr->firstStatementLine);
				}
				setTypeLine((yyvsp[0].typePtr), thisParserPtr->firstStatementLine,
					    thisParserPtr);
				setTypeName((yyvsp[0].typePtr), (yyvsp[-3].id));
				(yyval.err) = 0;
			    } else {
				(yyval.err) = 0;
			    }

			    /*
			     * If we are in an SMI module, some type
			     * definitions derived from ASN.1 `INTEGER'
			     * must be modified to libsmi basetypes.
			     */
			    if (thisModulePtr &&
				(!strcmp(thisModulePtr->export.name, "SNMPv2-SMI"))) {
				if (!strcmp((yyvsp[-3].id), "Counter32")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Gauge32")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Unsigned32")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "TimeTicks")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Counter64")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED64;
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned64 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned64 = SMI_BASETYPE_UNSIGNED64_MAX;
				    }
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned64Ptr);
				}
			    }
			    if (thisModulePtr &&
				(!strcmp(thisModulePtr->export.name, "RFC1155-SMI") ||
				 !strcmp(thisModulePtr->export.name, "RFC1065-SMI"))) {
				if (!strcmp((yyvsp[-3].id), "Counter")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Gauge")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "TimeTicks")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "NetworkAddress")) {
				    setTypeName((yyvsp[0].typePtr), smiStrdup("NetworkAddress"));
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_OCTETSTRING;
				    setTypeParent((yyvsp[0].typePtr), findTypeByModuleAndName(
					                   thisModulePtr,
						           "IpAddress"));
				} else if (!strcmp((yyvsp[-3].id), "IpAddress")) {
				    typePtr = findTypeByModuleAndName(
					thisModulePtr, "NetworkAddress");
				    if (typePtr) 
					setTypeParent(typePtr, (yyvsp[0].typePtr));
				}
			    }
			    if (thisModulePtr &&
				(!strcmp(thisModulePtr->export.name, "COPS-PR-SPPI"))) {
				if (!strcmp((yyvsp[-3].id), "Unsigned32")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "TimeTicks")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED32;
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned32Ptr);
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned32 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED32;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned32 = 4294967295U;
				    }
				} else if (!strcmp((yyvsp[-3].id), "Unsigned64")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_UNSIGNED64;
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_UNSIGNED64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.unsigned64 = 0;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_UNSIGNED64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.unsigned64 = SMI_BASETYPE_UNSIGNED64_MAX;
				    }
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeUnsigned64Ptr);
				} else if (!strcmp((yyvsp[-3].id), "Integer64")) {
				    (yyvsp[0].typePtr)->export.basetype = SMI_BASETYPE_INTEGER64;
				    if ((yyvsp[0].typePtr)->listPtr) {
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.basetype = SMI_BASETYPE_INTEGER64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.minValue.value.integer64 = SMI_BASETYPE_INTEGER64_MIN;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.basetype = SMI_BASETYPE_INTEGER64;
					((Range *)(yyvsp[0].typePtr)->listPtr->ptr)->export.maxValue.value.integer64 = SMI_BASETYPE_INTEGER64_MAX;
				    }
				    setTypeParent((yyvsp[0].typePtr), smiHandle->typeInteger64Ptr);
				}
			    }
			}
#line 4079 "parser-smi.c"
    break;

  case 91: /* typeName: UPPERCASE_IDENTIFIER  */
#line 2291 "parser-smi.y"
                        {
			    (yyval.id) = (yyvsp[0].id);
			}
#line 4087 "parser-smi.c"
    break;

  case 92: /* typeName: typeSMI  */
#line 2295 "parser-smi.y"
                        {
			    (yyval.id) = smiStrdup((yyvsp[0].id));
			    /*
			     * well known types (keywords in this grammar)
			     * are known to be defined in these modules.
			     */
			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-SMI") &&
			        strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-TC") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-CONF") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1212") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "COPS-PR-SPPI")) {
			        smiPrintError(thisParserPtr, ERR_TYPE_SMI_OR_SPPI, (yyvsp[0].id));
			    }
			}
#line 4115 "parser-smi.c"
    break;

  case 93: /* typeName: typeSPPIonly  */
#line 2319 "parser-smi.y"
                        {
			    (yyval.id) = smiStrdup((yyvsp[0].id));
			    /*
			     * well known types (keywords in this grammar)
			     * are known to be defined in these modules.
			     */
			    if ((strcmp(thisParserPtr->modulePtr->export.name,
					"COPS-PR-SPPI")) &&
				(thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI))
			        smiPrintError(thisParserPtr, ERR_TYPE_SPPI, (yyvsp[0].id));
                        }
#line 4131 "parser-smi.c"
    break;

  case 95: /* typeSMI: typeSMIonly  */
#line 2334 "parser-smi.y"
                        {
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName((yyvsp[0].id), thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, (yyvsp[0].id));
                            (yyval.id) = (yyvsp[0].id);
                        }
#line 4142 "parser-smi.c"
    break;

  case 106: /* typeDeclarationRHS: Syntax  */
#line 2359 "parser-smi.y"
                        {
			    if ((yyvsp[0].typePtr)->export.name) {
				/*
				 * If we found an already defined type,
				 * we have to inherit a new type structure.
				 * (Otherwise the `Syntax' rule created
				 * a new type for us.)
				 */
				(yyval.typePtr) = duplicateType((yyvsp[0].typePtr), 0, thisParserPtr);
				setTypeDecl((yyval.typePtr), SMI_DECL_TYPEASSIGNMENT);
			    } else {
				(yyval.typePtr) = (yyvsp[0].typePtr);
				setTypeDecl((yyval.typePtr), SMI_DECL_TYPEASSIGNMENT);
			    }
			}
#line 4162 "parser-smi.c"
    break;

  case 107: /* $@8: %empty  */
#line 2375 "parser-smi.y"
                        {
			    Import *importPtr;

			    thisParserPtr->currentDecl = SMI_DECL_TEXTUALCONVENTION;

			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;

			    if (strcmp(thisModulePtr->export.name, "SNMPv2-TC")) {
				importPtr =
				    findImportByName("TEXTUAL-CONVENTION",
						     thisModulePtr);
				if (importPtr) {
				    importPtr->use++;
				} else {
                                    if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
				        smiPrintError(thisParserPtr,
						      ERR_MACRO_NOT_IMPORTED,
						      "TEXTUAL-CONVENTION",
						      "SNMPv2-TC");
                                    else
				        smiPrintError(thisParserPtr,
						      ERR_MACRO_NOT_IMPORTED,
						      "TEXTUAL-CONVENTION",
						      "COPS-PR-SPPI");
				}
			    }
			}
#line 4195 "parser-smi.c"
    break;

  case 108: /* $@9: %empty  */
#line 2406 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 4203 "parser-smi.c"
    break;

  case 109: /* typeDeclarationRHS: TEXTUAL_CONVENTION $@8 DisplayPart STATUS Status DESCRIPTION Text $@9 ReferPart SYNTAX Syntax  */
#line 2411 "parser-smi.y"
                        {
			    if (((yyvsp[0].typePtr)) && !((yyvsp[0].typePtr)->export.name)) {
				/*
				 * If the Type we found has just been
				 * defined, we don't have to allocate
				 * a new one.
				 */
				(yyval.typePtr) = (yyvsp[0].typePtr);
			    } else {
				if (!((yyvsp[0].typePtr)))
				    smiPrintError(thisParserPtr, ERR_INTERNAL);
				/*
				 * Otherwise, we have to allocate a
				 * new Type struct, inherited from $10.
				 */
				(yyval.typePtr) = duplicateType((yyvsp[0].typePtr), 0, thisParserPtr);
			    }
			    setTypeDescription((yyval.typePtr), (yyvsp[-4].text), thisParserPtr);
			    if ((yyvsp[-2].text)) {
				setTypeReference((yyval.typePtr), (yyvsp[-2].text), thisParserPtr);
			    }
			    setTypeStatus((yyval.typePtr), (yyvsp[-6].status));
			    if ((yyvsp[-8].text)) {
				if (smiCheckFormat(thisParserPtr,
						   (yyval.typePtr)->export.basetype, (yyvsp[-8].text),
						   thisParserPtr->firstStatementLine)) {
				    setTypeFormat((yyval.typePtr), (yyvsp[-8].text));
				}
			    }
			    setTypeDecl((yyval.typePtr), SMI_DECL_TEXTUALCONVENTION);
			}
#line 4239 "parser-smi.c"
    break;

  case 110: /* typeDeclarationRHS: choiceClause  */
#line 2443 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			    setTypeDecl((yyval.typePtr), SMI_DECL_TYPEASSIGNMENT);
			}
#line 4248 "parser-smi.c"
    break;

  case 111: /* conceptualTable: SEQUENCE OF row  */
#line 2451 "parser-smi.y"
                        {
			    if ((yyvsp[0].typePtr)) {
				(yyval.typePtr) = addType(NULL,
					     SMI_BASETYPE_UNKNOWN, 0,
					     thisParserPtr);
				setTypeDecl((yyval.typePtr), SMI_DECL_IMPL_SEQUENCEOF);
				setTypeParent((yyval.typePtr), (yyvsp[0].typePtr));
			    } else {
				(yyval.typePtr) = NULL;
			    }
			}
#line 4264 "parser-smi.c"
    break;

  case 112: /* row: UPPERCASE_IDENTIFIER  */
#line 2470 "parser-smi.y"
                        {
			    Type *typePtr;
			    Import *importPtr;

			    (yyval.typePtr) = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, (yyvsp[0].id));
			    if (! (yyval.typePtr)) {
				importPtr = findImportByName((yyvsp[0].id),
							     thisModulePtr);
				if (!importPtr ||
				    (importPtr->kind == KIND_NOTFOUND)) {
				    /* 
				     * forward referenced type. create it,
				     * marked with FLAG_INCOMPLETE.
				     */
				    typePtr = addType((yyvsp[0].id),
						      SMI_BASETYPE_UNKNOWN,
						      FLAG_INCOMPLETE,
						      thisParserPtr);
				    (yyval.typePtr) = typePtr;
				} else {
				    /*
				     * imported type.
				     * TODO: is this allowed in a SEQUENCE? 
				     */
				    importPtr->use++;
				    (yyval.typePtr) = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				    smiFree((yyvsp[0].id));
				}
			    } else {
				smiFree((yyvsp[0].id));
			    }
			}
#line 4304 "parser-smi.c"
    break;

  case 113: /* entryType: SEQUENCE '{' sequenceItems '}'  */
#line 2510 "parser-smi.y"
                        {
			    (yyval.typePtr) = addType(NULL, SMI_BASETYPE_UNKNOWN, 0,
					 thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[-1].listPtr));
			}
#line 4314 "parser-smi.c"
    break;

  case 114: /* sequenceItems: sequenceItem  */
#line 2518 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4324 "parser-smi.c"
    break;

  case 115: /* sequenceItems: sequenceItems ',' sequenceItem  */
#line 2525 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 4339 "parser-smi.c"
    break;

  case 116: /* sequenceItem: LOWERCASE_IDENTIFIER sequenceSyntax  */
#line 2544 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Import *importPtr;
			    Type *typePtr;
			    
			    objectPtr =
			        findObjectByModuleAndName(thisParserPtr->modulePtr,
							  (yyvsp[-1].id));

			    if (!objectPtr) {
				importPtr = findImportByName((yyvsp[-1].id),
							     thisModulePtr);
				if (!importPtr ||
				    (importPtr->kind == KIND_NOTFOUND)) {
				    objectPtr = addObject((yyvsp[-1].id), thisParserPtr->pendingNodePtr,
					                  0,
					                  FLAG_INCOMPLETE |
							  FLAG_SEQTYPE,
						          thisParserPtr);
				    setObjectType(objectPtr, (yyvsp[0].typePtr));
				} else {
				    /*
				     * imported object.
				     */
				    importPtr->use++;
				    objectPtr = findObjectByModulenameAndName(
					importPtr->export.module, (yyvsp[-1].id));
				    smiFree((yyvsp[-1].id));

				    if (objectPtr->typePtr->export.name) {
					typePtr = objectPtr->typePtr;
				    } else {
					typePtr = objectPtr->typePtr->parentPtr;
				    }
				    if (((yyvsp[0].typePtr) != typePtr) &&
					(((yyvsp[0].typePtr)->export.basetype !=
					  SMI_BASETYPE_INTEGER32) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_ENUM)) &&
					(((yyvsp[0].typePtr)->export.basetype !=
					  SMI_BASETYPE_OCTETSTRING) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_BITS))) {
					smiPrintError(thisParserPtr,
						      ERR_SEQUENCE_TYPE_MISMATCH,
						      objectPtr->export.name);
				    }
				}
			    } else {
				smiFree((yyvsp[-1].id));
				if (objectPtr->typePtr) {

				    if (objectPtr->typePtr->export.name) {
					typePtr = objectPtr->typePtr;
				    } else {
					typePtr = objectPtr->typePtr->parentPtr;
				    }
				    if (((yyvsp[0].typePtr) != typePtr) &&
					(((yyvsp[0].typePtr)->export.basetype !=
					  SMI_BASETYPE_INTEGER32) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_ENUM)) &&
					(((yyvsp[0].typePtr)->export.basetype !=
					  SMI_BASETYPE_OCTETSTRING) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_BITS))) {
					smiPrintError(thisParserPtr,
						      ERR_SEQUENCE_TYPE_MISMATCH,
						      objectPtr->export.name);
				    }

				} else {
				    setObjectType(objectPtr, (yyvsp[0].typePtr));
				    addObjectFlags(objectPtr,
						   FLAG_SEQTYPE);
				}
			    }

			    (yyval.objectPtr) = objectPtr;
			}
#line 4424 "parser-smi.c"
    break;

  case 117: /* Syntax: ObjectSyntax  */
#line 2627 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			    if ((yyval.typePtr))
				defaultBasetype = (yyval.typePtr)->export.basetype;
			}
#line 4434 "parser-smi.c"
    break;

  case 118: /* Syntax: BITS '{' NamedBits '}'  */
#line 2635 "parser-smi.y"
                        {
			    Type *typePtr;
			    List *p;
			    
			    defaultBasetype = SMI_BASETYPE_BITS;
			    typePtr = addType(NULL, SMI_BASETYPE_BITS,
					      FLAG_INCOMPLETE,
					      thisParserPtr);
			    setTypeDecl(typePtr, SMI_DECL_IMPLICIT_TYPE);
			    setTypeParent(typePtr, smiHandle->typeBitsPtr);
			    setTypeList(typePtr, (yyvsp[-1].listPtr));
			    for (p = (yyvsp[-1].listPtr); p; p = p->nextPtr)
				((NamedNumber *)p->ptr)->typePtr = typePtr;
			    smiCheckNamedNumbersOrder(parserPtr, typePtr);
			    (yyval.typePtr) = typePtr;
			}
#line 4455 "parser-smi.c"
    break;

  case 119: /* sequenceSyntax: sequenceObjectSyntax  */
#line 2655 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 4463 "parser-smi.c"
    break;

  case 120: /* sequenceSyntax: BITS  */
#line 2659 "parser-smi.y"
                        {
			    /* TODO: */
			    (yyval.typePtr) = smiHandle->typeOctetStringPtr;
			}
#line 4472 "parser-smi.c"
    break;

  case 121: /* sequenceSyntax: UPPERCASE_IDENTIFIER anySubType  */
#line 2664 "parser-smi.y"
                        {
			    Type *typePtr;
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, (yyvsp[-1].id));
			    if (! (yyval.typePtr)) {
				importPtr = findImportByName((yyvsp[-1].id),
							     thisModulePtr);
				if (!importPtr ||
				    (importPtr->kind == KIND_NOTFOUND)) {
				    /* 
				     * forward referenced type. create it,
				     * marked with FLAG_INCOMPLETE.
				     */
				    typePtr = addType((yyvsp[-1].id), SMI_BASETYPE_UNKNOWN,
						      FLAG_INCOMPLETE,
						      thisParserPtr);
				    (yyval.typePtr) = typePtr;
				} else {
				    importPtr->use++;
				    (yyval.typePtr) = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				    smiFree((yyvsp[-1].id));
				}
			    } else {
				smiFree((yyvsp[-1].id));
			    }
			}
#line 4507 "parser-smi.c"
    break;

  case 122: /* NamedBits: NamedBit  */
#line 2697 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].namedNumberPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4517 "parser-smi.c"
    break;

  case 123: /* NamedBits: NamedBits ',' NamedBit  */
#line 2703 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].namedNumberPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 4532 "parser-smi.c"
    break;

  case 124: /* $@10: %empty  */
#line 2716 "parser-smi.y"
                        {
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_BITNAME_32, ERR_BITNAME_64);
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
				if (strchr((yyvsp[0].id), '-')) {
				    smiPrintError(thisParserPtr,
						  ERR_NAMEDBIT_INCLUDES_HYPHEN,
						  (yyvsp[0].id));
				}
			    }
			}
#line 4549 "parser-smi.c"
    break;

  case 125: /* NamedBit: LOWERCASE_IDENTIFIER $@10 '(' NUMBER ')'  */
#line 2729 "parser-smi.y"
                        {
			    (yyval.namedNumberPtr) = smiMalloc(sizeof(NamedNumber));
			    (yyval.namedNumberPtr)->export.name = (yyvsp[-4].id);
			    (yyval.namedNumberPtr)->export.value.basetype =
				                       SMI_BASETYPE_UNSIGNED32;
			    (yyval.namedNumberPtr)->export.value.value.unsigned32 = (yyvsp[-1].unsigned32);
			    /* RFC 2578 7.1.4 */
			    if ((yyvsp[-1].unsigned32) >= 65535*8) {
				smiPrintError(thisParserPtr,
					      ERR_BITS_NUMBER_TOO_LARGE,
					      (yyvsp[-4].id), (yyvsp[-1].unsigned32));
			    } else {
				if ((yyvsp[-1].unsigned32) >= 128) {
				    smiPrintError(thisParserPtr,
						  ERR_BITS_NUMBER_LARGE,
						  (yyvsp[-4].id), (yyvsp[-1].unsigned32));
				}
			    }
			}
#line 4573 "parser-smi.c"
    break;

  case 126: /* $@11: %empty  */
#line 2751 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_OBJECTIDENTITY;

			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 4587 "parser-smi.c"
    break;

  case 127: /* $@12: %empty  */
#line 2761 "parser-smi.y"
                        {
			    Import *importPtr;

			    if (strcmp(thisModulePtr->export.name, "SNMPv2-SMI") &&
                                strcmp(thisModulePtr->export.name, "COPS-PR-SPPI")) {
				importPtr = findImportByName("OBJECT-IDENTITY",
							     thisModulePtr);
				if (importPtr) {
				    importPtr->use++;
				} else {
                                    if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
				        smiPrintError(thisParserPtr,
						      ERR_MACRO_NOT_IMPORTED,
						      "OBJECT-IDENTITY",
						      "SNMPv2-SMI");
                                    else
				        smiPrintError(thisParserPtr,
						      ERR_MACRO_NOT_IMPORTED,
						      "OBJECT-IDENTITY",
						      "COPS-PR-SPPI");
				}
			    }
			}
#line 4615 "parser-smi.c"
    break;

  case 128: /* $@13: %empty  */
#line 2786 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 4623 "parser-smi.c"
    break;

  case 129: /* objectIdentityClause: LOWERCASE_IDENTIFIER $@11 OBJECT_IDENTITY $@12 STATUS Status DESCRIPTION Text $@13 ReferPart COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 2792 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-13].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-13].id), thisParserPtr);
			    setObjectDecl(objectPtr, SMI_DECL_OBJECTIDENTITY);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    setObjectStatus(objectPtr, (yyvsp[-8].status));
			    setObjectDescription(objectPtr, (yyvsp[-6].text), thisParserPtr);
			    if ((yyvsp[-4].text)) {
				setObjectReference(objectPtr, (yyvsp[-4].text), thisParserPtr);
			    }
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    (yyval.err) = 0;
			}
#line 4647 "parser-smi.c"
    break;

  case 130: /* $@14: %empty  */
#line 2814 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_OBJECTTYPE;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 4661 "parser-smi.c"
    break;

  case 131: /* $@15: %empty  */
#line 2824 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    importPtr = findImportByName("OBJECT-TYPE",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_MACRO_NOT_IMPORTED,
						  "OBJECT-TYPE", "SNMPv2-SMI");
				} else if (thisModulePtr->export.language ==
                                    SMI_LANGUAGE_SPPI) {
                                    smiPrintError(thisParserPtr,
                                                  ERR_MACRO_NOT_IMPORTED,
                                                  "OBJECT-TYPE", "COPS-PR-SPPI");
                                } else {
				    smiPrintError(thisParserPtr,
						  ERR_MACRO_NOT_IMPORTED,
						  "OBJECT-TYPE", "RFC-1212");
				}
			    }
                            indexFlag = 0;
			    variationkind = SMI_NODEKIND_UNKNOWN;
			}
#line 4693 "parser-smi.c"
    break;

  case 132: /* objectTypeClause: LOWERCASE_IDENTIFIER $@14 OBJECT_TYPE $@15 SYNTAX Syntax UnitsPart MaxOrPIBAccessPart SPPIPibReferencesPart SPPIPibTagPart STATUS Status descriptionClause SPPIErrorsPart ReferPart IndexPart MibIndex SPPIUniquePart DefValPart COLON_COLON_EQUAL '{' ObjectName '}'  */
#line 2865 "parser-smi.y"
                        {
			    Object *objectPtr, *parentPtr;
			    Type *typePtr = NULL;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-22].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-22].id), thisParserPtr);
			    setObjectDecl(objectPtr, SMI_DECL_OBJECTTYPE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    if (checkObjectFlags(objectPtr, FLAG_SEQTYPE)) {
				deleteObjectFlags(objectPtr, FLAG_SEQTYPE);
				if ((yyvsp[-17].typePtr)) {
				    if ((yyvsp[-17].typePtr)->export.name) {
					typePtr = (yyvsp[-17].typePtr);
                                        /*
                                         * According to RFC 3159 7.1.3. Opaque must not be used
                                         * in a SYNTAX clause.
                                         */
                                        if ((thisModulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                            !strcmp(typePtr->export.name, "Opaque"))
                                            smiPrintError(thisParserPtr, ERR_OPAQUE_IN_SYNTAX);
                                        /*
                                         * According to RFC 3159 7.1.4. IpAddress must not be used
                                         * in a SYNTAX clause.
                                         */
                                        if ((thisModulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                            !strcmp(typePtr->export.name, "IpAddress"))
                                            smiPrintError(thisParserPtr, ERR_IPADDRESS_IN_SYNTAX);
				    } else {
					typePtr = (yyvsp[-17].typePtr)->parentPtr;
				    }
				    if ((objectPtr->typePtr != typePtr) &&
					((objectPtr->typePtr->export.basetype !=
					  SMI_BASETYPE_INTEGER32) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_ENUM)) &&
					((objectPtr->typePtr->export.basetype !=
					  SMI_BASETYPE_OCTETSTRING) ||
					 (typePtr->export.basetype !=
					  SMI_BASETYPE_BITS))) {
					smiPrintError(thisParserPtr,
						      ERR_SEQUENCE_TYPE_MISMATCH,
						      objectPtr->export.name);
				    }
				}
			    }
			    setObjectType(objectPtr, (yyvsp[-17].typePtr));
			    if (!((yyvsp[-17].typePtr)->export.name)) {
				/*
				 * An inlined type.
				 */
#if 0 /* export implicitly defined types by the node's lowercase name */
				setTypeName((yyvsp[-17].typePtr), (yyvsp[-22].id));
#endif
			    }
			    setObjectUnits(objectPtr, (yyvsp[-16].text));
			    setObjectAccess(objectPtr, (yyvsp[-15].access));
			    if (thisParserPtr->flags & FLAG_CREATABLE) {
				thisParserPtr->flags &= ~FLAG_CREATABLE;
				parentPtr =
				  objectPtr->nodePtr->parentPtr->lastObjectPtr;
				if (parentPtr &&
				    parentPtr->export.indexkind !=
				       SMI_INDEX_UNKNOWN) {
				    /*
				     * add objectPtr to the parent object's
				     * listPtr, which is the list of columns
				     * needed for row creation.
				     *
				     * Note, that this would clash, if the
				     * parent row object-type is not yet
				     * defined.
				     */
				    /*
				    newlistPtr = smiMalloc(sizeof(List));
				    newlistPtr->nextPtr = NULL;
				    newlistPtr->ptr = objectPtr;
				    */
				    /*
				     * Look up the parent object-type.
				     */
				    /*
				    if (parentPtr->listPtr) {
					for(listPtr = parentPtr->listPtr;
					    listPtr->nextPtr;
					    listPtr = listPtr->nextPtr);
					listPtr->nextPtr = newlistPtr;
				    } else {
					parentPtr->listPtr = newlistPtr;
				    }
				    */
				    addObjectFlags(parentPtr, FLAG_CREATABLE);
				    setObjectCreate(parentPtr, 1);
				} else {
				    smiPrintError(thisParserPtr,
						  ERR_SCALAR_READCREATE);
				}
			    }
			    setObjectStatus(objectPtr, (yyvsp[-11].status));
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    if ((yyvsp[-10].text)) {
				setObjectDescription(objectPtr, (yyvsp[-10].text), thisParserPtr);
			    }
			    if ((yyvsp[-8].text)) {
				setObjectReference(objectPtr, (yyvsp[-8].text), thisParserPtr);
			    }
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI) {
                                /*
                                 * For SMI documents either $16 (IndexPart) or $17 (MibIndex)
                                 * are used, but not both. This is signalled via the indexFlag
                                 * which is 1 if IndexPart has been used.
                                 */
                                if (indexFlag == INDEXFLAG_AUGMENTS) { /* IndexPart was used */
			            if ((yyvsp[-7].index).indexkind != SMI_INDEX_UNKNOWN) {
				        setObjectList(objectPtr, (yyvsp[-7].index).listPtr);
				        setObjectImplied(objectPtr, (yyvsp[-7].index).implied);
				        setObjectIndexkind(objectPtr, (yyvsp[-7].index).indexkind);
				        setObjectRelated(objectPtr, (yyvsp[-7].index).rowPtr);
			            }
                                } else {
			            if ((yyvsp[-6].index).indexkind != SMI_INDEX_UNKNOWN) {
				        setObjectList(objectPtr, (yyvsp[-6].index).listPtr);
				        setObjectImplied(objectPtr, (yyvsp[-6].index).implied);
				        setObjectIndexkind(objectPtr, (yyvsp[-6].index).indexkind);
				        setObjectRelated(objectPtr, (yyvsp[-6].index).rowPtr);
			            }
                                }
                            } else {
                                /*
                                 * PIBs contain either PIB-INDEX or AUGMENTS or EXTENDS - 
                                 * but only with one Index entry. A PIB-INDEX may be
                                 * followed by a full INDEX. We get the indexkind
                                 * from the first.
                                 * Note that PIB-INDEX/AUGMENTS/EXTENS is always
                                 * the first element in objectPtr->listPtr.
                                 * If an optional INDEX exists then it is
                                 * appended to this list.
                                 */
			        if ((yyvsp[-7].index).indexkind != SMI_INDEX_UNKNOWN) {
                                    setObjectList(objectPtr, (yyvsp[-7].index).listPtr);
				    setObjectIndexkind(objectPtr, (yyvsp[-7].index).indexkind);
				    setObjectRelated(objectPtr, (yyvsp[-7].index).rowPtr);
			        }
			        if ((yyvsp[-6].index).indexkind != SMI_INDEX_UNKNOWN) {
                                    if (objectPtr->listPtr) {
                                        List *p;
                                        for (p = objectPtr->listPtr; p->nextPtr;
                                             p = p->nextPtr);
                                        p->nextPtr = (yyvsp[-6].index).listPtr;
                                    }
				    setObjectImplied(objectPtr, (yyvsp[-6].index).implied);
			        }
                            }
                            if ((yyvsp[-5].listPtr)) {
                                setObjectUniqueness(objectPtr, (yyvsp[-5].listPtr));
                            }
			    if ((yyvsp[-4].valuePtr)) {
				if (objectPtr->typePtr
				    && (((objectPtr->typePtr->export.basetype == SMI_BASETYPE_OCTETSTRING) &&
					 ((yyvsp[-4].valuePtr)->basetype != SMI_BASETYPE_OCTETSTRING))
					|| ((objectPtr->typePtr->export.basetype == SMI_BASETYPE_OBJECTIDENTIFIER) &&
					    ((yyvsp[-4].valuePtr)->basetype != SMI_BASETYPE_OBJECTIDENTIFIER)))) {
				    smiPrintError(thisParserPtr,
						  ERR_DEFVAL_SYNTAX);
				    if ((yyvsp[-4].valuePtr)->basetype == SMI_BASETYPE_OBJECTIDENTIFIER) {
					smiFree((yyvsp[-4].valuePtr)->value.oid);
				    }
				    if (((yyvsp[-4].valuePtr)->basetype == SMI_BASETYPE_BITS) ||
					((yyvsp[-4].valuePtr)->basetype == SMI_BASETYPE_OCTETSTRING)) {
					smiFree((yyvsp[-4].valuePtr)->value.ptr);
				    }
				    smiFree((yyvsp[-4].valuePtr));
				} else {
				    setObjectValue(objectPtr, (yyvsp[-4].valuePtr));
				}
			    }
                            if ((yyvsp[-14].objectPtr)) {
                                if (objectPtr->relatedPtr)
                                    smiPrintError(thisParserPtr, ERR_OBJECTPTR_ELEMENT_IN_USE,
                                                  "relatedPtr", "PIB-REFERENCES");
                                /*
                                 * PIB-REFERENCES clauses are only allowed for
                                 * objects with a SYNTAX of 'ReferenceId'.
                                 * See RFC 3159 7.10
                                 */
                                if (objectPtr->typePtr && objectPtr->typePtr->export.name &&
                                    strcmp(objectPtr->typePtr->export.name, "ReferenceId"))
                                    smiPrintErrorAtLine(parserPtr, ERR_PIB_REFERENCES_WRONG_TYPE,
                                                        objectPtr->line);
                                else
                                    setObjectRelated(objectPtr, (yyvsp[-14].objectPtr));
                            } else {
                               /*
                                * Does this object have a SYNTAX of 'ReferenceId'
                                * and a PIB-REFERENCES clause?
                                * See RFC 3159 7.10
                                */
                               if ((thisModulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                   objectPtr->typePtr && objectPtr->typePtr->export.name &&
                                   !strcmp(objectPtr->typePtr->export.name, "ReferenceId"))
                                   smiPrintErrorAtLine(parserPtr, ERR_LACKING_PIB_REFERENCES,
                                                       objectPtr->line);
                            }
                            if ((yyvsp[-13].objectPtr)) {
                                if (objectPtr->relatedPtr)
                                    smiPrintError(thisParserPtr, ERR_OBJECTPTR_ELEMENT_IN_USE,
                                                  "relatedPtr", "PIB-TAG");
                                /*
                                 * PIB-TAG clauses are only allowed for
                                 * objects with a SYNTAX of 'TagReferenceId'.
                                 * See RFC 3159 7.11
                                 */
                                if (objectPtr->typePtr && objectPtr->typePtr->export.name &&
                                    strcmp(objectPtr->typePtr->export.name, "TagReferenceId"))
                                    smiPrintErrorAtLine(parserPtr, ERR_PIB_TAG_WRONG_TYPE,
                                                        objectPtr->line);
                                else
                                    setObjectRelated(objectPtr, (yyvsp[-13].objectPtr));
                            } else {
                                /*
                                 * Does this object have a SYNTAX of 'TagReferenceId'
                                 * and a PIB-TAG clause?
                                 * See RFC 3159 7.11
                                 */
                                if ((thisModulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                    objectPtr->typePtr && objectPtr->typePtr->export.name &&
                                    !strcmp(objectPtr->typePtr->export.name, "TagReferenceId"))
                                    smiPrintErrorAtLine(parserPtr, ERR_LACKING_PIB_TAG,
                                                        objectPtr->line);

                            }
                            if ((yyvsp[-9].listPtr)) {
                                if (objectPtr->listPtr)
                                    smiPrintError(thisParserPtr, ERR_OBJECTPTR_ELEMENT_IN_USE,
                                                  "listPtr", "INSTALL-ERRORS");
                                /*
                                 * Are INSTALL-ERRORS only used with tables?
                                 * See RFC 3159 7.4
                                 */
                                if (!((objectPtr->export.decl == SMI_DECL_OBJECTTYPE) &&
                                    (objectPtr->typePtr) &&
                                    (objectPtr->typePtr->export.decl == SMI_DECL_IMPL_SEQUENCEOF)))
                                    smiPrintErrorAtLine(parserPtr, ERR_INSTALL_ERRORS_FOR_NON_TABLE,
                                                        objectPtr->line);
                                else
                                    setObjectList(objectPtr, (yyvsp[-9].listPtr));
                            }
			    (yyval.err) = 0;
			}
#line 4951 "parser-smi.c"
    break;

  case 133: /* descriptionClause: %empty  */
#line 3121 "parser-smi.y"
                        {
			    if ((thisModulePtr->export.language == SMI_LANGUAGE_SMIV2) ||
                                (thisModulePtr->export.language == SMI_LANGUAGE_SPPI))
			    {
				smiPrintError(thisParserPtr,
					      ERR_MISSING_DESCRIPTION);
			    }
			    (yyval.text) = NULL;
			}
#line 4965 "parser-smi.c"
    break;

  case 134: /* descriptionClause: DESCRIPTION Text  */
#line 3131 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 4974 "parser-smi.c"
    break;

  case 135: /* $@16: %empty  */
#line 3138 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_TRAPTYPE;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 4988 "parser-smi.c"
    break;

  case 136: /* $@17: %empty  */
#line 3148 "parser-smi.y"
                        {
			    Import *importPtr;
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "TRAP-TYPE");
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
			        smiPrintError(thisParserPtr, ERR_TRAP_TYPE);
			    }

			    importPtr = findImportByName("TRAP-TYPE",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "TRAP-TYPE", "RFC-1215");
			    }
			}
#line 5013 "parser-smi.c"
    break;

  case 137: /* trapTypeClause: fuzzy_lowercase_identifier $@16 TRAP_TYPE $@17 ENTERPRISE objectIdentifier VarPart DescrPart ReferPart COLON_COLON_EQUAL NUMBER  */
#line 3174 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Node *nodePtr;
			    
			    objectPtr = (yyvsp[-5].objectPtr);
			    nodePtr = findNodeByParentAndSubid(
				objectPtr->nodePtr, 0);
			    if (nodePtr && nodePtr->lastObjectPtr &&
	       		        (nodePtr->lastObjectPtr->modulePtr == thisModulePtr)) {
				/*
				 * hopefully, the last defined Object for
				 * this Node is the one we expect.
				 */
				objectPtr = nodePtr->lastObjectPtr;
			    } else {
				objectPtr = addObject(NULL,
						      objectPtr->nodePtr,
						      0,
						      FLAG_INCOMPLETE,
						      thisParserPtr);
			    }
			    objectPtr = addObject(NULL,
						  objectPtr->nodePtr,
						  (yyvsp[0].unsigned32),
						  FLAG_INCOMPLETE,
						  thisParserPtr);
			    
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-10].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-10].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_TRAPTYPE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectList(objectPtr, (yyvsp[-4].listPtr));
			    setObjectStatus(objectPtr, SMI_STATUS_CURRENT); 
			    setObjectDescription(objectPtr, (yyvsp[-3].text), thisParserPtr);
			    if ((yyvsp[-2].text)) {
				setObjectReference(objectPtr, (yyvsp[-2].text), thisParserPtr);
			    }
			    (yyval.err) = 0;
			}
#line 5062 "parser-smi.c"
    break;

  case 138: /* VarPart: VARIABLES '{' VarTypes '}'  */
#line 3221 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 5070 "parser-smi.c"
    break;

  case 139: /* VarPart: %empty  */
#line 3225 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 5078 "parser-smi.c"
    break;

  case 140: /* VarTypes: VarType  */
#line 3231 "parser-smi.y"
                        {
			    if ((yyvsp[0].objectPtr)) {
				(yyval.listPtr) = smiMalloc(sizeof(List));
				(yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
				(yyval.listPtr)->nextPtr = NULL;
			    } else {
				(yyval.listPtr) = NULL;
			    }
			}
#line 5092 "parser-smi.c"
    break;

  case 141: /* VarTypes: VarTypes ',' VarType  */
#line 3241 "parser-smi.y"
                        {
			    List *p, *pp;

			    if ((yyvsp[0].objectPtr)) {
				p = smiMalloc(sizeof(List));
				p->ptr = (yyvsp[0].objectPtr);
				p->nextPtr = NULL;
				if ((yyvsp[-2].listPtr)) {
				    for (pp = (yyvsp[-2].listPtr); pp->nextPtr;
					 pp = pp->nextPtr);
				    pp->nextPtr = p;
				    (yyval.listPtr) = (yyvsp[-2].listPtr);
				} else {
				    (yyval.listPtr) = p;
				}
			    } else {
				(yyval.listPtr) = (yyvsp[-2].listPtr);
			    }
			}
#line 5116 "parser-smi.c"
    break;

  case 142: /* VarType: ObjectName  */
#line 3263 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 5124 "parser-smi.c"
    break;

  case 143: /* DescrPart: DESCRIPTION Text  */
#line 3269 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 5133 "parser-smi.c"
    break;

  case 144: /* DescrPart: %empty  */
#line 3274 "parser-smi.y"
                        { (yyval.text) = NULL; }
#line 5139 "parser-smi.c"
    break;

  case 145: /* MaxOrPIBAccessPart: MaxAccessPart  */
#line 3278 "parser-smi.y"
                        {
                            (yyval.access) = (yyvsp[0].access);
                        }
#line 5147 "parser-smi.c"
    break;

  case 146: /* MaxOrPIBAccessPart: PibAccessPart  */
#line 3282 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "MAX-ACCESS");
                            if ((yyvsp[0].access) == SMI_ACCESS_NOT_ACCESSIBLE)
                                smiPrintError(thisParserPtr, ERR_NOT_ACCESSIBLE_IN_PIB_ACCESS);
                            (yyval.access) = (yyvsp[0].access);
                        }
#line 5159 "parser-smi.c"
    break;

  case 147: /* MaxOrPIBAccessPart: %empty  */
#line 3290 "parser-smi.y"
                        { (yyval.access) = 0;  }
#line 5165 "parser-smi.c"
    break;

  case 148: /* PibAccessPart: PibAccess Access  */
#line 3294 "parser-smi.y"
                        { (yyval.access) = (yyvsp[0].access); }
#line 5171 "parser-smi.c"
    break;

  case 149: /* PibAccess: POLICY_ACCESS  */
#line 3298 "parser-smi.y"
                        { 
                            smiPrintError(thisParserPtr, ERR_POLICY_ACCESS_IN_PIB);
                        }
#line 5179 "parser-smi.c"
    break;

  case 150: /* PibAccess: PIB_ACCESS  */
#line 3302 "parser-smi.y"
                        { }
#line 5185 "parser-smi.c"
    break;

  case 151: /* $@18: %empty  */
#line 3306 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "PIB-REFERENCES");
                        }
#line 5194 "parser-smi.c"
    break;

  case 152: /* SPPIPibReferencesPart: PIB_REFERENCES $@18 '{' Entry '}'  */
#line 3311 "parser-smi.y"
                        { (yyval.objectPtr) = (yyvsp[-1].objectPtr); }
#line 5200 "parser-smi.c"
    break;

  case 153: /* SPPIPibReferencesPart: %empty  */
#line 3313 "parser-smi.y"
                        { (yyval.objectPtr) = 0; }
#line 5206 "parser-smi.c"
    break;

  case 154: /* $@19: %empty  */
#line 3317 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "PIB-TAG");
                        }
#line 5215 "parser-smi.c"
    break;

  case 155: /* SPPIPibTagPart: PIB_TAG $@19 '{' ObjectName '}'  */
#line 3322 "parser-smi.y"
                        { (yyval.objectPtr) = (yyvsp[-1].objectPtr); }
#line 5221 "parser-smi.c"
    break;

  case 156: /* SPPIPibTagPart: %empty  */
#line 3324 "parser-smi.y"
                        { (yyval.objectPtr) = 0; }
#line 5227 "parser-smi.c"
    break;

  case 157: /* $@20: %empty  */
#line 3329 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "UNIQUENESS");
                        }
#line 5236 "parser-smi.c"
    break;

  case 158: /* SPPIUniquePart: UNIQUENESS $@20 '{' UniqueTypesPart '}'  */
#line 3334 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[-1].listPtr); }
#line 5242 "parser-smi.c"
    break;

  case 159: /* SPPIUniquePart: %empty  */
#line 3336 "parser-smi.y"
                        { (yyval.listPtr) = NULL; }
#line 5248 "parser-smi.c"
    break;

  case 160: /* UniqueTypesPart: UniqueTypes  */
#line 3340 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[0].listPtr); }
#line 5254 "parser-smi.c"
    break;

  case 161: /* UniqueTypesPart: %empty  */
#line 3342 "parser-smi.y"
                        { (yyval.listPtr) = NULL; }
#line 5260 "parser-smi.c"
    break;

  case 162: /* UniqueTypes: UniqueType  */
#line 3346 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 5270 "parser-smi.c"
    break;

  case 163: /* UniqueTypes: UniqueTypes ',' UniqueType  */
#line 3353 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
                        }
#line 5285 "parser-smi.c"
    break;

  case 164: /* UniqueType: ObjectName  */
#line 3366 "parser-smi.y"
                        { (yyval.objectPtr) = (yyvsp[0].objectPtr); }
#line 5291 "parser-smi.c"
    break;

  case 165: /* $@21: %empty  */
#line 3370 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "INSTALL-ERRORS");
                        }
#line 5300 "parser-smi.c"
    break;

  case 166: /* SPPIErrorsPart: INSTALL_ERRORS $@21 '{' Errors '}'  */
#line 3375 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[-1].listPtr); }
#line 5306 "parser-smi.c"
    break;

  case 167: /* SPPIErrorsPart: %empty  */
#line 3377 "parser-smi.y"
                        { (yyval.listPtr) = NULL; }
#line 5312 "parser-smi.c"
    break;

  case 168: /* Errors: Error  */
#line 3381 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 5322 "parser-smi.c"
    break;

  case 169: /* Errors: Errors ',' Error  */
#line 3388 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
                        }
#line 5337 "parser-smi.c"
    break;

  case 170: /* Error: LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 3401 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
                            if (((yyvsp[-1].unsigned32) < 1) || ((yyvsp[-1].unsigned32) > 65536))
                                smiPrintError(thisParserPtr, ERR_ERROR_NUMBER_RANGE, (yyvsp[-1].unsigned32));
                            /*
                             * This is not a regular object that will be added vid
                             * 'addObject' as error identifier have no other
                             * meaning in PIBs. They are just used for
                             * a direct mapping to the actual protocol fields.
                             */
                            objectPtr = smiMalloc(sizeof(Object));
                            objectPtr->export.name = (yyvsp[-3].id);
                            objectPtr->export.oidlen = 1;
                            objectPtr->export.oid = (void *)(yyvsp[-1].unsigned32);
			    (yyval.objectPtr) = objectPtr;
			}
#line 5359 "parser-smi.c"
    break;

  case 171: /* $@22: %empty  */
#line 3422 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV1)
			    {
			        smiPrintError(thisParserPtr,
					      ERR_MAX_ACCESS_IN_SMIV1);
			    } else if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "MAX-ACCESS");
			}
#line 5372 "parser-smi.c"
    break;

  case 172: /* MaxAccessPart: MAX_ACCESS $@22 Access  */
#line 3431 "parser-smi.y"
                        { (yyval.access) = (yyvsp[0].access); }
#line 5378 "parser-smi.c"
    break;

  case 173: /* $@23: %empty  */
#line 3433 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
			        smiPrintError(thisParserPtr, ERR_ACCESS_IN_SMIV2);
			    } else if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "ACCESS");
			}
#line 5390 "parser-smi.c"
    break;

  case 174: /* MaxAccessPart: ACCESS $@23 Access  */
#line 3442 "parser-smi.y"
                        { (yyval.access) = (yyvsp[0].access); }
#line 5396 "parser-smi.c"
    break;

  case 175: /* $@24: %empty  */
#line 3446 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_NOTIFICATIONTYPE;

			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 5410 "parser-smi.c"
    break;

  case 176: /* $@25: %empty  */
#line 3456 "parser-smi.y"
                        {
			    Import *importPtr;

                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "NOTIFICATION-TYPE");
                                
			    importPtr = findImportByName("NOTIFICATION-TYPE",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "NOTIFICATION-TYPE",
					      "SNMPv2-SMI");
			    }
			}
#line 5432 "parser-smi.c"
    break;

  case 177: /* $@26: %empty  */
#line 3476 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 5440 "parser-smi.c"
    break;

  case 178: /* notificationTypeClause: LOWERCASE_IDENTIFIER $@24 NOTIFICATION_TYPE $@25 NotificationObjectsPart STATUS Status DESCRIPTION Text $@26 ReferPart COLON_COLON_EQUAL '{' NotificationName '}'  */
#line 3482 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-14].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-14].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_NOTIFICATIONTYPE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectList(objectPtr, (yyvsp[-10].listPtr));
			    setObjectStatus(objectPtr, (yyvsp[-8].status));
			    setObjectDescription(objectPtr, (yyvsp[-6].text), thisParserPtr);
			    if ((yyvsp[-4].text)) {
				setObjectReference(objectPtr, (yyvsp[-4].text), thisParserPtr);
			    }
			    (yyval.err) = 0;
			}
#line 5467 "parser-smi.c"
    break;

  case 179: /* $@27: %empty  */
#line 3507 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULEIDENTITY;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 5481 "parser-smi.c"
    break;

  case 180: /* $@28: %empty  */
#line 3517 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    importPtr = findImportByName("MODULE-IDENTITY",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "MODULE-IDENTITY",
					      "SNMPv2-SMI");
			    }
			    
			    if (thisParserPtr->modulePtr->numModuleIdentities > 0)
			    {
			        smiPrintError(thisParserPtr,
					      ERR_TOO_MANY_MODULE_IDENTITIES);
			    }
			    if (thisParserPtr->modulePtr->numStatements > 0) {
			        smiPrintError(thisParserPtr,
					      ERR_MODULE_IDENTITY_NOT_FIRST);
			    }
			}
#line 5510 "parser-smi.c"
    break;

  case 181: /* $@29: %empty  */
#line 3542 "parser-smi.y"
                        {
                          /* do nothing at the moment */
                        }
#line 5518 "parser-smi.c"
    break;

  case 182: /* $@30: %empty  */
#line 3546 "parser-smi.y"
                        {
			    setModuleLastUpdated(thisParserPtr->modulePtr, (yyvsp[0].date));
			}
#line 5526 "parser-smi.c"
    break;

  case 183: /* $@31: %empty  */
#line 3550 "parser-smi.y"
                        {
			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_ORGANIZATION);
			    }
			}
#line 5537 "parser-smi.c"
    break;

  case 184: /* $@32: %empty  */
#line 3557 "parser-smi.y"
                        {
			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_CONTACT);
			    }
			}
#line 5548 "parser-smi.c"
    break;

  case 185: /* $@33: %empty  */
#line 3564 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 5556 "parser-smi.c"
    break;

  case 186: /* $@34: %empty  */
#line 3568 "parser-smi.y"
                        {
			    if ((!thisModulePtr->firstRevisionPtr) ||
				(thisModulePtr->firstRevisionPtr->export.date !=
				 thisModulePtr->lastUpdated)) {
				smiPrintError(thisParserPtr,
					      ERR_REVISION_MISSING);
				addRevision(thisModulePtr->lastUpdated,
					    smiStrdup(
						"[Revision added by libsmi due to a LAST-UPDATED clause.]"),
					    thisParserPtr);
			    }
			}
#line 5573 "parser-smi.c"
    break;

  case 187: /* moduleIdentityClause: LOWERCASE_IDENTIFIER $@27 MODULE_IDENTITY $@28 SubjectCategoriesPart $@29 LAST_UPDATED ExtUTCTime $@30 ORGANIZATION Text $@31 CONTACT_INFO Text $@32 DESCRIPTION Text $@33 RevisionPart $@34 COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 3582 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-23].id), &objectPtr);

			    thisParserPtr->modulePtr->numModuleIdentities++;

			    objectPtr = setObjectName(objectPtr, (yyvsp[-23].id), thisParserPtr);
			    setObjectDecl(objectPtr, SMI_DECL_MODULEIDENTITY);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    setObjectStatus(objectPtr, SMI_STATUS_CURRENT);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setModuleIdentityObject(thisParserPtr->modulePtr,
						    objectPtr);
			    setModuleOrganization(thisParserPtr->modulePtr,
						  (yyvsp[-13].text));
			    setModuleContactInfo(thisParserPtr->modulePtr,
						 (yyvsp[-10].text));
			    setModuleDescription(thisParserPtr->modulePtr,
						 (yyvsp[-7].text), thisParserPtr);
                            if ((yyvsp[-19].subjectCategoriesPtr) != NULL) {
                                setObjectList(objectPtr, (yyvsp[-19].subjectCategoriesPtr)->categories);
                                smiFree((yyvsp[-19].subjectCategoriesPtr));
                            }
			    /* setObjectDescription(objectPtr, $15); */
			    (yyval.err) = 0;
			}
#line 5608 "parser-smi.c"
    break;

  case 188: /* SubjectCategoriesPart: SUBJECT_CATEGORIES '{' SubjectCategories '}'  */
#line 3615 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "SUBJECT-CATEGORIES");
                            (yyval.subjectCategoriesPtr) = (yyvsp[-1].subjectCategoriesPtr);
                        }
#line 5618 "parser-smi.c"
    break;

  case 189: /* SubjectCategoriesPart: %empty  */
#line 3621 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SUBJECT_CATEGORIES_MISSING);
                            (yyval.subjectCategoriesPtr) = NULL;
                        }
#line 5628 "parser-smi.c"
    break;

  case 190: /* SubjectCategories: CategoryIDs  */
#line 3629 "parser-smi.y"
                        {
                            (yyval.subjectCategoriesPtr) = smiMalloc(sizeof(SubjectCategories));
                            (yyval.subjectCategoriesPtr)->categories    = (yyvsp[0].listPtr);
                        }
#line 5637 "parser-smi.c"
    break;

  case 191: /* CategoryIDs: CategoryID  */
#line 3636 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 5647 "parser-smi.c"
    break;

  case 192: /* CategoryIDs: CategoryIDs ',' CategoryID  */
#line 3642 "parser-smi.y"
                        {
			    List *p, *pp;
			    
                            if ((yyvsp[-2].listPtr)->ptr == NULL)
                                smiPrintError(thisParserPtr, ERR_SUBJECT_CATEGORIES_ALL);
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 5664 "parser-smi.c"
    break;

  case 193: /* CategoryID: LOWERCASE_IDENTIFIER  */
#line 3657 "parser-smi.y"
                        {
                            Object *objectPtr;
                            
                            if (strcmp((yyvsp[0].id), "all"))
                                smiPrintError(thisParserPtr, ERR_SUBJECT_CATEGORIES_MISSING_SUBID);
                            else {
                                /*
                                 * This is not a regular object that will be added via
                                 * 'addObject' as subject category dentifier have no
                                 * other meaning in PIBs. They are just used for
                                 * a direct mapping to the actual protocol fields.
                                 */
                                objectPtr = smiMalloc(sizeof(Object));
                                objectPtr->export.name = "all";
                                objectPtr->export.oidlen = 0;
                                objectPtr->export.oid = 0;
                                (yyval.objectPtr) = objectPtr;
                            }
                            smiFree((yyvsp[0].id));
                        }
#line 5689 "parser-smi.c"
    break;

  case 194: /* CategoryID: LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 3678 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
                            if (!strcmp((yyvsp[-3].id), "all")) {
                                smiPrintError(thisParserPtr, ERR_SUBJECT_CATEGORIES_ALL_WITH_SUBID);
                                (yyval.objectPtr) = NULL;
                            } else {
                                /*
                                 * This is not a regular object that will be added via
                                 * 'addObject' as subject category dentifier have no
                                 * other meaning in PIBs. They are just used for
                                 * a direct mapping to the actual protocol fields.
                                 */
                                objectPtr = smiMalloc(sizeof(Object));
                                objectPtr->export.name = (yyvsp[-3].id);
                                objectPtr->export.oidlen = 1;
                                objectPtr->export.oid = (void *)(yyvsp[-1].unsigned32);
                                (yyval.objectPtr) = objectPtr;
                            }
			}
#line 5714 "parser-smi.c"
    break;

  case 195: /* ObjectSyntax: SimpleSyntax  */
#line 3701 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5722 "parser-smi.c"
    break;

  case 196: /* ObjectSyntax: typeTag SimpleSyntax  */
#line 3705 "parser-smi.y"
                        {
			    if (strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-SMI") &&
			        strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-TC") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "SNMPv2-CONF") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC-1212") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1065-SMI") &&
				strcmp(thisParserPtr->modulePtr->export.name,
				       "RFC1155-SMI") &&
                                strcmp(thisParserPtr->modulePtr->export.name,
                                       "COPS-PR-SPPI")) {
			        smiPrintError(thisParserPtr, ERR_TYPE_TAG, (yyvsp[-1].err));
			    }
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5746 "parser-smi.c"
    break;

  case 197: /* ObjectSyntax: conceptualTable  */
#line 3725 "parser-smi.y"
                        {
			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5755 "parser-smi.c"
    break;

  case 198: /* ObjectSyntax: row  */
#line 3730 "parser-smi.y"
                        {
			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5764 "parser-smi.c"
    break;

  case 199: /* ObjectSyntax: entryType  */
#line 3735 "parser-smi.y"
                        {
			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5773 "parser-smi.c"
    break;

  case 200: /* ObjectSyntax: ApplicationSyntax  */
#line 3740 "parser-smi.y"
                        {
			    Import *importPtr;

			    if ((yyvsp[0].typePtr) && (yyvsp[0].typePtr)->export.name) {
				importPtr = findImportByName((yyvsp[0].typePtr)->export.name,
							     thisModulePtr);
				if (importPtr) {
				    importPtr->use++;
				}
			    }

			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5792 "parser-smi.c"
    break;

  case 201: /* typeTag: '[' APPLICATION NUMBER ']' IMPLICIT  */
#line 3757 "parser-smi.y"
                        { (yyval.err) = 0; /* TODO: check range */ }
#line 5798 "parser-smi.c"
    break;

  case 202: /* typeTag: '[' UNIVERSAL NUMBER ']' IMPLICIT  */
#line 3759 "parser-smi.y"
                        { (yyval.err) = 0; /* TODO: check range */ }
#line 5804 "parser-smi.c"
    break;

  case 203: /* sequenceObjectSyntax: sequenceSimpleSyntax  */
#line 3767 "parser-smi.y"
                        { (yyval.typePtr) = (yyvsp[0].typePtr); }
#line 5810 "parser-smi.c"
    break;

  case 204: /* sequenceObjectSyntax: sequenceApplicationSyntax  */
#line 3772 "parser-smi.y"
                        {
			    Import *importPtr;

			    if ((yyvsp[0].typePtr) && (yyvsp[0].typePtr)->export.name) {
				importPtr = findImportByName((yyvsp[0].typePtr)->export.name,
							     thisModulePtr);
				if (importPtr) {
				    importPtr->use++;
				}
			    }

			    /* TODO */
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 5829 "parser-smi.c"
    break;

  case 205: /* valueofObjectSyntax: valueofSimpleSyntax  */
#line 3789 "parser-smi.y"
                        { (yyval.valuePtr) = (yyvsp[0].valuePtr); }
#line 5835 "parser-smi.c"
    break;

  case 206: /* SimpleSyntax: INTEGER  */
#line 3798 "parser-smi.y"
                        {
			    if ((thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				&&
				(strcmp(thisModulePtr->export.name, "SNMPv2-SMI") &&
				 strcmp(thisModulePtr->export.name, "SNMPv2-TC") &&
                                 strcmp(thisModulePtr->export.name, "COPS-PR-SPPI")))
				smiPrintError(thisParserPtr,
					      ERR_INTEGER_IN_SMIV2);

			    defaultBasetype = SMI_BASETYPE_INTEGER32;
			    (yyval.typePtr) = smiHandle->typeInteger32Ptr;
			}
#line 5852 "parser-smi.c"
    break;

  case 207: /* $@35: %empty  */
#line 3811 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_INTEGER32;
			}
#line 5860 "parser-smi.c"
    break;

  case 208: /* SimpleSyntax: INTEGER $@35 integerSubType  */
#line 3815 "parser-smi.y"
                        {
			    if ((thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				&&
				(strcmp(thisModulePtr->export.name, "SNMPv2-SMI") &&
				 strcmp(thisModulePtr->export.name, "SNMPv2-TC") &&
                                 strcmp(thisModulePtr->export.name, "COPS-PR-SPPI")))
				smiPrintError(thisParserPtr,
					      ERR_INTEGER_IN_SMIV2);

			    (yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 5879 "parser-smi.c"
    break;

  case 209: /* $@36: %empty  */
#line 3830 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_ENUM;
			}
#line 5887 "parser-smi.c"
    break;

  case 210: /* SimpleSyntax: INTEGER $@36 enumSpec  */
#line 3834 "parser-smi.y"
                        {
			    List *p;
			    
			    (yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				((NamedNumber *)p->ptr)->typePtr = (yyval.typePtr);
			    smiCheckNamedNumbersOrder(parserPtr, (yyval.typePtr));
			}
#line 5902 "parser-smi.c"
    break;

  case 211: /* SimpleSyntax: INTEGER32  */
#line 3845 "parser-smi.y"
                        {
			    Import *importPtr;

			    defaultBasetype = SMI_BASETYPE_INTEGER32;
			    importPtr = findImportByName("Integer32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				}
			    }

			    /* TODO: any need to distinguish from INTEGER? */
			    (yyval.typePtr) = smiHandle->typeInteger32Ptr;
			}
#line 5932 "parser-smi.c"
    break;

  case 212: /* $@37: %empty  */
#line 3871 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_INTEGER32;
			}
#line 5940 "parser-smi.c"
    break;

  case 213: /* SimpleSyntax: INTEGER32 $@37 integerSubType  */
#line 3875 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    importPtr = findImportByName("Integer32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				}
			    }

			    (yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 5971 "parser-smi.c"
    break;

  case 214: /* $@38: %empty  */
#line 3902 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_ENUM;
			}
#line 5979 "parser-smi.c"
    break;

  case 215: /* SimpleSyntax: UPPERCASE_IDENTIFIER $@38 enumSpec  */
#line 3906 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    List *p;
			    
			    parentPtr = findTypeByModuleAndName(
			        thisParserPtr->modulePtr, (yyvsp[-2].id));
			    if (!parentPtr) {
			        importPtr = findImportByName((yyvsp[-2].id),
							     thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module, (yyvsp[-2].id));
				}
			    }
			    if (parentPtr) {
				if ((parentPtr->export.basetype !=
				     SMI_BASETYPE_ENUM) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_BITS)) {
				    smiPrintError(thisParserPtr,
						  ERR_ILLEGAL_ENUM_FOR_PARENT_TYPE,
						  (yyvsp[-2].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
						       thisParserPtr);
				} else {
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
				smiFree((yyvsp[-2].id));
			    } else {
				/* 
				 * forward referenced type. create it,
				 * marked with FLAG_INCOMPLETE.
				 */
				parentPtr = addType((yyvsp[-2].id),
						    SMI_BASETYPE_UNKNOWN,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				((NamedNumber *)p->ptr)->typePtr = (yyval.typePtr);
			    smiCheckNamedNumbersOrder(parserPtr, (yyval.typePtr));
			}
#line 6033 "parser-smi.c"
    break;

  case 216: /* SimpleSyntax: moduleName '.' UPPERCASE_IDENTIFIER enumSpec  */
#line 3957 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    List *p;
			    
                            defaultBasetype = SMI_BASETYPE_ENUM;
                            parentPtr = findTypeByModulenameAndName((yyvsp[-3].id), (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr =
				    findImportByModulenameAndName((yyvsp[-3].id),
							  (yyvsp[-1].id), thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr =
					findTypeByModulenameAndName((yyvsp[-3].id), (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if ((parentPtr->export.basetype !=
				     SMI_BASETYPE_ENUM) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_BITS)) {
				    smiPrintError(thisParserPtr,
						  ERR_ILLEGAL_ENUM_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
						       thisParserPtr);
				} else {
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_UNKNOWN_TYPE, (yyvsp[-1].id));
				(yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
						   thisParserPtr);
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				((NamedNumber *)p->ptr)->typePtr = (yyval.typePtr);
			    smiCheckNamedNumbersOrder(parserPtr, (yyval.typePtr));
			    smiFree((yyvsp[-3].id));
			    smiFree((yyvsp[-1].id));
			}
#line 6083 "parser-smi.c"
    break;

  case 217: /* SimpleSyntax: UPPERCASE_IDENTIFIER integerSubType  */
#line 4003 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByModuleAndName(
				thisParserPtr->modulePtr, (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr = findImportByName((yyvsp[-1].id),
							     thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module, (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if ((parentPtr->export.basetype !=
				    SMI_BASETYPE_INTEGER32) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_INTEGER64) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_UNSIGNED32) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_UNSIGNED64)) {
				    smiPrintError(thisParserPtr,
					     ERR_ILLEGAL_RANGE_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
						       thisParserPtr);
				    defaultBasetype = SMI_BASETYPE_INTEGER32;
				} else {
				    defaultBasetype =
					parentPtr->export.basetype;
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
				smiFree((yyvsp[-1].id));
			    } else {
				/* 
				 * forward referenced type. create it,
				 * marked with FLAG_INCOMPLETE.
				 */
				parentPtr = addType((yyvsp[-1].id),
						    SMI_BASETYPE_UNKNOWN,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				defaultBasetype = SMI_BASETYPE_INTEGER32;
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 6142 "parser-smi.c"
    break;

  case 218: /* SimpleSyntax: moduleName '.' UPPERCASE_IDENTIFIER integerSubType  */
#line 4059 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByModulenameAndName((yyvsp[-3].id), (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr = findImportByModulenameAndName((yyvsp[-3].id),
							  (yyvsp[-1].id), thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					(yyvsp[-3].id), (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if ((parentPtr->export.basetype !=
				    SMI_BASETYPE_INTEGER32) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_INTEGER64) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_UNSIGNED32) &&
				    (parentPtr->export.basetype !=
				     SMI_BASETYPE_UNSIGNED64)) {
				    smiPrintError(thisParserPtr,
					     ERR_ILLEGAL_RANGE_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
						       thisParserPtr);
				    defaultBasetype = SMI_BASETYPE_INTEGER32;
				} else {
				    defaultBasetype =
					parentPtr->export.basetype;
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_UNKNOWN_TYPE, (yyvsp[-1].id));
				(yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
						   thisParserPtr);
				defaultBasetype = SMI_BASETYPE_INTEGER32;
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    smiFree((yyvsp[-3].id));
			    smiFree((yyvsp[-1].id));
			}
#line 6195 "parser-smi.c"
    break;

  case 219: /* SimpleSyntax: OCTET STRING  */
#line 4108 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_OCTETSTRING;
			    (yyval.typePtr) = smiHandle->typeOctetStringPtr;
			}
#line 6204 "parser-smi.c"
    break;

  case 220: /* $@39: %empty  */
#line 4113 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_OCTETSTRING;
			}
#line 6212 "parser-smi.c"
    break;

  case 221: /* SimpleSyntax: OCTET STRING $@39 octetStringSubType  */
#line 4117 "parser-smi.y"
                        {
			    
			    (yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 6224 "parser-smi.c"
    break;

  case 222: /* SimpleSyntax: UPPERCASE_IDENTIFIER octetStringSubType  */
#line 4125 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    defaultBasetype = SMI_BASETYPE_OCTETSTRING;
			    parentPtr = findTypeByModuleAndName(
				thisParserPtr->modulePtr, (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr = findImportByName((yyvsp[-1].id),
							     thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module, (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if (parentPtr->export.basetype !=
				    SMI_BASETYPE_OCTETSTRING) {
				    smiPrintError(thisParserPtr,
					      ERR_ILLEGAL_SIZE_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
						       thisParserPtr);
				} else {
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
				smiFree((yyvsp[-1].id));
			    } else {
				/* 
				 * forward referenced type. create it,
				 * marked with FLAG_INCOMPLETE.
				 */
				parentPtr = addType((yyvsp[-1].id),
						    SMI_BASETYPE_UNKNOWN,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			}
#line 6274 "parser-smi.c"
    break;

  case 223: /* SimpleSyntax: moduleName '.' UPPERCASE_IDENTIFIER octetStringSubType  */
#line 4172 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    defaultBasetype = SMI_BASETYPE_OCTETSTRING;
			    parentPtr = findTypeByModulenameAndName((yyvsp[-3].id), (yyvsp[-1].id));
			    if (!parentPtr) {
				importPtr = findImportByModulenameAndName((yyvsp[-3].id),
							  (yyvsp[-1].id), thisModulePtr);
				if (importPtr &&
				    importPtr->kind == KIND_TYPE) {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					(yyvsp[-3].id), (yyvsp[-1].id));
				}
			    }
			    if (parentPtr) {
				if (parentPtr->export.basetype !=
				    SMI_BASETYPE_OCTETSTRING) {
				    smiPrintError(thisParserPtr,
					      ERR_ILLEGAL_SIZE_FOR_PARENT_TYPE,
						  (yyvsp[-1].id));
				    (yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
						       thisParserPtr);
				} else {
				    (yyval.typePtr) = duplicateType(parentPtr, 0,
						       thisParserPtr);
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_UNKNOWN_TYPE, (yyvsp[-1].id));
				(yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
						   thisParserPtr);
			    }
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    smiFree((yyvsp[-3].id));
			    smiFree((yyvsp[-1].id));
			}
#line 6318 "parser-smi.c"
    break;

  case 224: /* SimpleSyntax: OBJECT IDENTIFIER anySubType  */
#line 4212 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_OBJECTIDENTIFIER;
			    (yyval.typePtr) = smiHandle->typeObjectIdentifierPtr;
			}
#line 6327 "parser-smi.c"
    break;

  case 225: /* valueofSimpleSyntax: NUMBER  */
#line 4220 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
			    (yyval.valuePtr)->value.unsigned32 = (yyvsp[0].unsigned32);
			}
#line 6337 "parser-smi.c"
    break;

  case 226: /* valueofSimpleSyntax: NEGATIVENUMBER  */
#line 4226 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
			    (yyval.valuePtr)->value.integer32 = (yyvsp[0].integer32);
			}
#line 6347 "parser-smi.c"
    break;

  case 227: /* valueofSimpleSyntax: NUMBER64  */
#line 4232 "parser-smi.y"
                        {   
                            /* The scanner already checks for the language */
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED64;
			    (yyval.valuePtr)->value.unsigned64 = (yyvsp[0].unsigned64);
			}
#line 6358 "parser-smi.c"
    break;

  case 228: /* valueofSimpleSyntax: NEGATIVENUMBER64  */
#line 4239 "parser-smi.y"
                        {
                            /* The scanner already checks for the language */
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER64;
			    (yyval.valuePtr)->value.integer64 = (yyvsp[0].integer64);
			}
#line 6369 "parser-smi.c"
    break;

  case 229: /* valueofSimpleSyntax: BIN_STRING  */
#line 4246 "parser-smi.y"
                        {
			    char s[9];
			    int i, len, j;
			    
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr =
				    smiMalloc((len+7)/8+1);
				for (i = 0; i < len; i += 8) {
				    strncpy(s, &(yyvsp[0].text)[i], 8);
				    for (j = 1; j < 8; j++) {
					if (!s[j]) s[j] = '0';
				    }
				    s[8] = 0;
				    (yyval.valuePtr)->value.ptr[i/8] =
					(unsigned char)strtol(s, 0, 2);
				}
				(yyval.valuePtr)->len = (len+7)/8;
			    } else {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 2);
			    }
			}
#line 6399 "parser-smi.c"
    break;

  case 230: /* valueofSimpleSyntax: HEX_STRING  */
#line 4272 "parser-smi.y"
                        {
			    char s[3];
			    int i, len;
			    
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr = smiMalloc((len+1)/2+1);
				for (i = 0; i < len; i += 2) {
				    strncpy(s, &(yyvsp[0].text)[i], 2);
				    if (!s[1]) s[1] = '0';
				    s[2] = 0;
				    (yyval.valuePtr)->value.ptr[i/2] =
					(unsigned char)strtol(s, 0, 16);
				}
				(yyval.valuePtr)->len = (len+1)/2;
			    } else {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 16);
			    }
			}
#line 6426 "parser-smi.c"
    break;

  case 231: /* valueofSimpleSyntax: LOWERCASE_IDENTIFIER  */
#line 4295 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if ((defaultBasetype != SMI_BASETYPE_ENUM) &&
				(defaultBasetype != SMI_BASETYPE_OBJECTIDENTIFIER)) {
				smiPrintError(thisParserPtr, ERR_DEFVAL_SYNTAX);
				(yyval.valuePtr)->basetype = defaultBasetype;
				if (defaultBasetype == SMI_BASETYPE_ENUM) {
				    (yyval.valuePtr)->len = 1;
				    (yyval.valuePtr)->value.unsigned32 = 0;
				} else {
				    (yyval.valuePtr)->len = 0;
				    (yyval.valuePtr)->value.ptr = NULL;
				}
			    } else {
				(yyval.valuePtr)->basetype = defaultBasetype;
				(yyval.valuePtr)->len = -1;  /* indicates unresolved ptr */
				(yyval.valuePtr)->value.ptr = (unsigned char *) (yyvsp[0].id); /* JS: needs strdup? */
			    }
			}
#line 6450 "parser-smi.c"
    break;

  case 232: /* valueofSimpleSyntax: QUOTED_STRING  */
#line 4315 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
			    (yyval.valuePtr)->value.ptr = (unsigned char *) smiStrdup((yyvsp[0].text));
			    (yyval.valuePtr)->len = strlen((yyvsp[0].text));
			}
#line 6461 "parser-smi.c"
    break;

  case 233: /* valueofSimpleSyntax: '{' objectIdentifier_defval '}'  */
#line 4338 "parser-smi.y"
                        {
			    /*
			     * SMIv1 allows something like { 0 0 } !
			     * SMIv2 does not!
			     */
			    /* TODO: make it work correctly for SMIv1 */
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2) {
				smiPrintError(thisParserPtr,
					      ERR_OID_DEFVAL_TOO_LONG_SMIV2);
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_OID_DEFVAL_TOO_LONG_SMIV1);
			    }
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_OBJECTIDENTIFIER;
			    (yyval.valuePtr)->len = 2;
			    (yyval.valuePtr)->value.oid = smiMalloc(2 * sizeof(SmiSubid));
			    (yyval.valuePtr)->value.oid[0] = 0;
			    (yyval.valuePtr)->value.oid[1] = 0;
			}
#line 6486 "parser-smi.c"
    break;

  case 234: /* sequenceSimpleSyntax: INTEGER anySubType  */
#line 4365 "parser-smi.y"
                        {
			    (yyval.typePtr) = smiHandle->typeInteger32Ptr;
			}
#line 6494 "parser-smi.c"
    break;

  case 235: /* sequenceSimpleSyntax: INTEGER32 anySubType  */
#line 4369 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    /* TODO: any need to distinguish from INTEGER? */
			    (yyval.typePtr) = smiHandle->typeInteger32Ptr;

			    importPtr = findImportByName("Integer32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Integer32");
				}
			    }
			}
#line 6523 "parser-smi.c"
    break;

  case 236: /* sequenceSimpleSyntax: OCTET STRING anySubType  */
#line 4394 "parser-smi.y"
                        {
			    (yyval.typePtr) = smiHandle->typeOctetStringPtr;
			}
#line 6531 "parser-smi.c"
    break;

  case 237: /* sequenceSimpleSyntax: OBJECT IDENTIFIER anySubType  */
#line 4398 "parser-smi.y"
                        {
			    (yyval.typePtr) = smiHandle->typeObjectIdentifierPtr;
			}
#line 6539 "parser-smi.c"
    break;

  case 238: /* ApplicationSyntax: IPADDRESS anySubType  */
#line 4404 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("IpAddress");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "IpAddress");
			    }
			    
			    importPtr = findImportByName("IpAddress",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "IpAddress");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "IpAddress");
				}
			    }
			}
#line 6571 "parser-smi.c"
    break;

  case 239: /* ApplicationSyntax: COUNTER32 anySubType  */
#line 4432 "parser-smi.y"
                        {
			    Import *importPtr;

                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "COUNTER32");
			    (yyval.typePtr) = findTypeByName("Counter32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter32");
			    }
			    
			    importPtr = findImportByName("Counter32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter32");
				}
			    }
			}
#line 6601 "parser-smi.c"
    break;

  case 240: /* ApplicationSyntax: COUNTER32 integerSubType  */
#line 4458 "parser-smi.y"
                        {
			    Import *importPtr;
			    List *listPtr, *nextListPtr;
			    
			    smiPrintError(thisParserPtr,
					  ERR_ILLEGAL_RANGE_FOR_COUNTER,
					  "Counter32");
			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree((Range *)listPtr->ptr);
				smiFree(listPtr);
			    }
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter32");
			    (yyval.typePtr) = findTypeByName("Counter32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter32");
			    }
			    
			    importPtr = findImportByName("Counter32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter32");
				}
			    }
			}
#line 6642 "parser-smi.c"
    break;

  case 241: /* ApplicationSyntax: GAUGE32  */
#line 4495 "parser-smi.y"
                        {
			    Import *importPtr;

                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Gauge32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Gauge32");
			    (yyval.typePtr) = findTypeByName("Gauge32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Gauge32");
			    }
			    
			    importPtr = findImportByName("Gauge32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Gauge32");
				}
			    }
			}
#line 6672 "parser-smi.c"
    break;

  case 242: /* ApplicationSyntax: GAUGE32 integerSubType  */
#line 4521 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Gauge32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Gauge32");
			    parentPtr = findTypeByName("Gauge32");
			    if (! parentPtr) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Gauge32");
				(yyval.typePtr) = NULL;
			    } else {
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    }
			    
			    importPtr = findImportByName("Gauge32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Gauge32");
				}
			    }
			}
#line 6709 "parser-smi.c"
    break;

  case 243: /* ApplicationSyntax: UNSIGNED32  */
#line 4554 "parser-smi.y"
                        {
			    Import *importPtr;

			    (yyval.typePtr) = smiHandle->typeUnsigned32Ptr;
			    
			    importPtr = findImportByName("Unsigned32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				}
			    }
			}
#line 6737 "parser-smi.c"
    break;

  case 244: /* $@40: %empty  */
#line 4578 "parser-smi.y"
                        {
			    defaultBasetype = SMI_BASETYPE_UNSIGNED32;
			}
#line 6745 "parser-smi.c"
    break;

  case 245: /* ApplicationSyntax: UNSIGNED32 $@40 integerSubType  */
#line 4582 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = duplicateType(smiHandle->typeUnsigned32Ptr, 0,
					       thisParserPtr);
			    setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
			    smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));

			    importPtr = findImportByName("Unsigned32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				}
			    }
			}
#line 6776 "parser-smi.c"
    break;

  case 246: /* ApplicationSyntax: TIMETICKS anySubType  */
#line 4609 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("TimeTicks");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "TimeTicks");
			    }
			    
			    importPtr = findImportByName("TimeTicks",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "TimeTicks");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "TimeTicks");
				}
			    }
			}
#line 6808 "parser-smi.c"
    break;

  case 247: /* ApplicationSyntax: OPAQUE  */
#line 4637 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("Opaque");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Opaque");
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_OPAQUE_OBSOLETE);
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_OPAQUE_OBSOLETE);
				}
			    }
			    
			    importPtr = findImportByName("Opaque",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				}
			    }
			}
#line 6850 "parser-smi.c"
    break;

  case 248: /* ApplicationSyntax: OPAQUE octetStringSubType  */
#line 4675 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByName("Opaque");
			    if (! parentPtr) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Opaque");
				(yyval.typePtr) = NULL;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_OPAQUE_OBSOLETE,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_OPAQUE_OBSOLETE,
						  "Opaque");
				}
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    }

			    importPtr = findImportByName("Opaque",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				}
			    }
			}
#line 6900 "parser-smi.c"
    break;

  case 249: /* ApplicationSyntax: COUNTER64 anySubType  */
#line 4721 "parser-smi.y"
                        {
			    Import *importPtr;

                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter64", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter64");
			    (yyval.typePtr) = findTypeByName("Counter64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter64");
			    }

			    importPtr = findImportByName("Counter64",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter64");
				}
			    }
			}
#line 6930 "parser-smi.c"
    break;

  case 250: /* ApplicationSyntax: COUNTER64 integerSubType  */
#line 4747 "parser-smi.y"
                        {
			    Import *importPtr;
			    List *listPtr, *nextListPtr;
			    
			    smiPrintError(thisParserPtr,
					  ERR_ILLEGAL_RANGE_FOR_COUNTER,
					  "Counter64");
			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree((Range *)listPtr->ptr);
				smiFree(listPtr);
			    }
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter64", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter64");
			    (yyval.typePtr) = findTypeByName("Counter64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter64");
			    }

			    importPtr = findImportByName("Counter64",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter64");
				}
			    }
			}
#line 6971 "parser-smi.c"
    break;

  case 251: /* ApplicationSyntax: INTEGER64  */
#line 4784 "parser-smi.y"
                        {
			    Import *importPtr;

			    (yyval.typePtr) = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, "Integer64");
			    if (! (yyval.typePtr)) {
				importPtr = findImportByName("Integer64",
							     thisModulePtr);
				if (!importPtr) {
				    (yyval.typePtr) = findTypeByName("Integer64");
				    if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)) {
					smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Integer64");
				    } else {
					smiPrintError(thisParserPtr,
						      ERR_SPPI_BASETYPE_NOT_IMPORTED,
						      "Integer64");
				    }
				} else {
				    importPtr->use++;
				    (yyval.typePtr) = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				}
			    }
			}
#line 7001 "parser-smi.c"
    break;

  case 252: /* ApplicationSyntax: INTEGER64 integerSubType  */
#line 4810 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, "Integer64");
			    if (! parentPtr) {
				importPtr = findImportByName("Integer64",
							     thisModulePtr);
				if (!importPtr) {
				    parentPtr = findTypeByName("Integer64");
				    if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)) {
					smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Integer64");
				    } else {
					smiPrintError(thisParserPtr,
						      ERR_SPPI_BASETYPE_NOT_IMPORTED,
						      "Integer64");
				    }
				} else {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				}
			    }
			    if (! parentPtr) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Integer64");
				(yyval.typePtr) = NULL;
			    } else {
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    }
			}
#line 7042 "parser-smi.c"
    break;

  case 253: /* ApplicationSyntax: UNSIGNED64  */
#line 4847 "parser-smi.y"
                        {
			    Import *importPtr;

			    (yyval.typePtr) = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, "Unsigned64");
			    if (! (yyval.typePtr)) {
				importPtr = findImportByName("Unsigned64",
							     thisModulePtr);
				if (!importPtr) {
				    (yyval.typePtr) = findTypeByName("Unsigned64");
				    if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)) {
					smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Unsigned64");
				    } else {
					smiPrintError(thisParserPtr,
						      ERR_SPPI_BASETYPE_NOT_IMPORTED,
						      "Unsigned64");
				    }
				} else {
				    importPtr->use++;
				    (yyval.typePtr) = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				}
			    }
			}
#line 7072 "parser-smi.c"
    break;

  case 254: /* ApplicationSyntax: UNSIGNED64 integerSubType  */
#line 4873 "parser-smi.y"
                        {
			    Type *parentPtr;
			    Import *importPtr;
			    
			    parentPtr = findTypeByModulenameAndName(
				thisParserPtr->modulePtr->export.name, "Unsigned64");
			    if (! parentPtr) {
				importPtr = findImportByName("Unsigned64",
							     thisModulePtr);
				if (!importPtr) {
				    parentPtr = findTypeByName("Unsigned64");
				    if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)) {
					smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Unsigned64");
				    } else {
					smiPrintError(thisParserPtr,
						      ERR_SPPI_BASETYPE_NOT_IMPORTED,
						      "Unsigned64");
				    }
				} else {
				    importPtr->use++;
				    parentPtr = findTypeByModulenameAndName(
					importPtr->export.module,
					importPtr->export.name);
				}
			    }
			    if (! parentPtr) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Unsigned64");
				(yyval.typePtr) = NULL;
			    } else {
				(yyval.typePtr) = duplicateType(parentPtr, 0,
						   thisParserPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				smiCheckTypeRanges(thisParserPtr, (yyval.typePtr));
			    }
			}
#line 7113 "parser-smi.c"
    break;

  case 255: /* sequenceApplicationSyntax: IPADDRESS anySubType  */
#line 4916 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("IpAddress");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "IpAddress");
			    }

			    importPtr = findImportByName("IpAddress",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "IpAddress");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "IpAddress");
				}
			    }
			}
#line 7145 "parser-smi.c"
    break;

  case 256: /* sequenceApplicationSyntax: COUNTER32 anySubType  */
#line 4944 "parser-smi.y"
                        {
			    Import *importPtr;
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter32");
			    (yyval.typePtr) = findTypeByName("Counter32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter32");
			    }

			    importPtr = findImportByName("Counter32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter32");
				}
			    }
			}
#line 7175 "parser-smi.c"
    break;

  case 257: /* sequenceApplicationSyntax: GAUGE32 anySubType  */
#line 4970 "parser-smi.y"
                        {
			    Import *importPtr;
			    
                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Gauge32", thisParserPtr->modulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Gauge32");
			    (yyval.typePtr) = findTypeByName("Gauge32");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Gauge32");
			    }

			    importPtr = findImportByName("Gauge32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Gauge32");
				}
			    }
			}
#line 7205 "parser-smi.c"
    break;

  case 258: /* sequenceApplicationSyntax: UNSIGNED32 anySubType  */
#line 4996 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = smiHandle->typeUnsigned32Ptr;

			    importPtr = findImportByName("Unsigned32",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Unsigned32");
				}
			    }
			}
#line 7233 "parser-smi.c"
    break;

  case 259: /* sequenceApplicationSyntax: TIMETICKS anySubType  */
#line 5020 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("TimeTicks");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "TimeTicks");
			    }

			    importPtr = findImportByName("TimeTicks",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "TimeTicks");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "TimeTicks");
				}
			    }
			}
#line 7265 "parser-smi.c"
    break;

  case 260: /* sequenceApplicationSyntax: OPAQUE  */
#line 5048 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    (yyval.typePtr) = findTypeByName("Opaque");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Opaque");
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_OPAQUE_OBSOLETE,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_OPAQUE_OBSOLETE,
						  "Opaque");
				}
			    }

			    importPtr = findImportByName("Opaque",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				} else if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Opaque");
				}
			    }
			}
#line 7309 "parser-smi.c"
    break;

  case 261: /* sequenceApplicationSyntax: COUNTER64 anySubType  */
#line 5088 "parser-smi.y"
                        {
			    Import *importPtr;

                            if ((thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) &&
                                !findImportByName("Counter64", thisModulePtr))
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "Counter64");
			    (yyval.typePtr) = findTypeByName("Counter64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Counter64");
			    }

			    importPtr = findImportByName("Counter64",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
				    SMI_LANGUAGE_SMIV2) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_BASETYPE_NOT_IMPORTED,
						  "Counter64");
				}
			    }
			}
#line 7339 "parser-smi.c"
    break;

  case 262: /* sequenceApplicationSyntax: INTEGER64  */
#line 5114 "parser-smi.y"
                        {
			    Import *importPtr;

                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Integer64");
			    (yyval.typePtr) = findTypeByName("Integer64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Integer64");
			    }

			    importPtr = findImportByName("Integer64",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Integer64");
				}
			    }
			}
#line 7368 "parser-smi.c"
    break;

  case 263: /* sequenceApplicationSyntax: UNSIGNED64  */
#line 5139 "parser-smi.y"
                        {
			    Import *importPtr;

			    importPtr = findImportByName("Unsigned64",
							 thisModulePtr);
                            if ((thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI) && (!importPtr))
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "Unsigned64");
			    (yyval.typePtr) = findTypeByName("Unsigned64");
			    if (! (yyval.typePtr)) {
				smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE,
					      "Unsigned64");
			    }

			    if (importPtr) {
				importPtr->use++;
			    } else {
				if (thisModulePtr->export.language ==
					   SMI_LANGUAGE_SPPI) {
				    smiPrintError(thisParserPtr,
						  ERR_SPPI_BASETYPE_NOT_IMPORTED,
						  "Unsigned64");
				}
			    }
			}
#line 7397 "parser-smi.c"
    break;

  case 264: /* anySubType: integerSubType  */
#line 5166 "parser-smi.y"
                        {
			    List *listPtr, *nextListPtr;

			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_TYPE_RESTRICTION);

			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree((Range *)(listPtr->ptr));
				smiFree(listPtr);
			    }

			    (yyval.listPtr) = NULL;
			}
#line 7418 "parser-smi.c"
    break;

  case 265: /* anySubType: octetStringSubType  */
#line 5183 "parser-smi.y"
                        {
			    List *listPtr, *nextListPtr;

			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_TYPE_RESTRICTION);

			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree((Range *)(listPtr->ptr));
				smiFree(listPtr);
			    }

			    (yyval.listPtr) = NULL;
			}
#line 7439 "parser-smi.c"
    break;

  case 266: /* anySubType: enumSpec  */
#line 5200 "parser-smi.y"
                        {
			    List *listPtr, *nextListPtr;

			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_TYPE_RESTRICTION);

			    for (listPtr = (yyvsp[0].listPtr); listPtr;
				 listPtr = nextListPtr) {
				nextListPtr = listPtr->nextPtr;
				smiFree(((NamedNumber *)(listPtr->ptr))->export.name);
				smiFree((NamedNumber *)(listPtr->ptr));
				smiFree(listPtr);
			    }

			    (yyval.listPtr) = NULL;
			}
#line 7461 "parser-smi.c"
    break;

  case 267: /* anySubType: %empty  */
#line 5218 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 7469 "parser-smi.c"
    break;

  case 268: /* integerSubType: '(' ranges ')'  */
#line 5232 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[-1].listPtr); }
#line 7475 "parser-smi.c"
    break;

  case 269: /* octetStringSubType: '(' SIZE '(' ranges ')' ')'  */
#line 5242 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 7483 "parser-smi.c"
    break;

  case 270: /* ranges: range  */
#line 5248 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].rangePtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 7493 "parser-smi.c"
    break;

  case 271: /* ranges: ranges '|' range  */
#line 5254 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].rangePtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 7509 "parser-smi.c"
    break;

  case 272: /* range: value  */
#line 5268 "parser-smi.y"
                        {
			    (yyval.rangePtr) = smiMalloc(sizeof(Range));
			    (yyval.rangePtr)->export.minValue = *(yyvsp[0].valuePtr);
			    (yyval.rangePtr)->export.maxValue = *(yyvsp[0].valuePtr);
			    smiFree((yyvsp[0].valuePtr));
			}
#line 7520 "parser-smi.c"
    break;

  case 273: /* range: value DOT_DOT value  */
#line 5275 "parser-smi.y"
                        {
			    (yyval.rangePtr) = smiMalloc(sizeof(Range));
			    (yyval.rangePtr)->export.minValue = *(yyvsp[-2].valuePtr);
			    (yyval.rangePtr)->export.maxValue = *(yyvsp[0].valuePtr);
			    smiFree((yyvsp[-2].valuePtr));
			    smiFree((yyvsp[0].valuePtr));
			}
#line 7532 "parser-smi.c"
    break;

  case 274: /* value: NEGATIVENUMBER  */
#line 5285 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
			    (yyval.valuePtr)->value.integer32 = (yyvsp[0].integer32);
			}
#line 7542 "parser-smi.c"
    break;

  case 275: /* value: NUMBER  */
#line 5291 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
			    (yyval.valuePtr)->value.unsigned32 = (yyvsp[0].unsigned32);
			}
#line 7552 "parser-smi.c"
    break;

  case 276: /* value: NEGATIVENUMBER64  */
#line 5297 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER64;
			    (yyval.valuePtr)->value.integer64 = (yyvsp[0].integer64);
			}
#line 7562 "parser-smi.c"
    break;

  case 277: /* value: NUMBER64  */
#line 5303 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED64;
			    (yyval.valuePtr)->value.unsigned64 = (yyvsp[0].unsigned64);
			}
#line 7572 "parser-smi.c"
    break;

  case 278: /* value: HEX_STRING  */
#line 5309 "parser-smi.y"
                        {
			    char s[3];
			    int i, len;
			    
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr = smiMalloc((len+1)/2+1);
				for (i = 0; i < len; i += 2) {
				    strncpy(s, &(yyvsp[0].text)[i], 2);
				    if (!s[1]) s[1] = '0';
				    s[2] = 0;
				    (yyval.valuePtr)->value.ptr[i/2] =
					(unsigned char)strtol(s, 0, 16);
				}
				(yyval.valuePtr)->len = (len+1)/2;
			    } else {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 16);
			    }
			}
#line 7599 "parser-smi.c"
    break;

  case 279: /* value: BIN_STRING  */
#line 5332 "parser-smi.y"
                        {
			    char s[9];
			    int i, len, j;
			    
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr = smiMalloc((len+7)/8+1);
				for (i = 0; i < len; i += 8) {
				    strncpy(s, &(yyvsp[0].text)[i], 8);
				    for (j = 1; j < 8; j++) {
					if (!s[j]) s[j] = '0';
				    }
				    s[8] = 0;
				    (yyval.valuePtr)->value.ptr[i/8] =
					(unsigned char)strtol(s, 0, 2);
				}
				(yyval.valuePtr)->len = (len+7)/8;
			    } else {
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 2);
			    }
			}
#line 7628 "parser-smi.c"
    break;

  case 280: /* enumSpec: '{' enumItems '}'  */
#line 5359 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 7636 "parser-smi.c"
    break;

  case 281: /* enumItems: enumItem  */
#line 5365 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].namedNumberPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 7646 "parser-smi.c"
    break;

  case 282: /* enumItems: enumItems ',' enumItem  */
#line 5371 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (void *)(yyvsp[0].namedNumberPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 7661 "parser-smi.c"
    break;

  case 283: /* $@41: %empty  */
#line 5384 "parser-smi.y"
                        {
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_ENUMNAME_32, ERR_ENUMNAME_64);
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
				if (strchr((yyvsp[0].id), '-')) {
				    smiPrintError(thisParserPtr,
					  ERR_NAMEDNUMBER_INCLUDES_HYPHEN,
						  (yyvsp[0].id));
				}
			    }
			}
#line 7678 "parser-smi.c"
    break;

  case 284: /* enumItem: LOWERCASE_IDENTIFIER $@41 '(' enumNumber ')'  */
#line 5397 "parser-smi.y"
                        {
			    (yyval.namedNumberPtr) = smiMalloc(sizeof(NamedNumber));
			    (yyval.namedNumberPtr)->export.name = (yyvsp[-4].id);
			    (yyval.namedNumberPtr)->export.value = *(yyvsp[-1].valuePtr);
			    smiFree((yyvsp[-1].valuePtr));
			}
#line 7689 "parser-smi.c"
    break;

  case 285: /* enumNumber: NUMBER  */
#line 5406 "parser-smi.y"
                        {
			    if ((yyvsp[0].unsigned32) > SMI_BASETYPE_INTEGER32_MAX) {
				smiPrintError(thisParserPtr,
					      ERR_INTEGER32_TOO_LARGE, (yyvsp[0].unsigned32));
			    }
			    if ((thisModulePtr->export.language == SMI_LANGUAGE_SMIV1) &&
				((yyvsp[0].unsigned32) == 0)) {
				smiPrintError(thisParserPtr,
					      ERR_ENUM_ZERO);
			    }
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
			    (yyval.valuePtr)->value.integer32 = (yyvsp[0].unsigned32);
			}
#line 7708 "parser-smi.c"
    break;

  case 286: /* enumNumber: NEGATIVENUMBER  */
#line 5421 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
			    (yyval.valuePtr)->value.integer32 = (yyvsp[0].integer32);
			    /* TODO: non-negative is suggested */
			}
#line 7719 "parser-smi.c"
    break;

  case 287: /* Status: LOWERCASE_IDENTIFIER  */
#line 5430 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
			        if (!strcmp((yyvsp[0].id), "current")) {
				    (yyval.status) = SMI_STATUS_CURRENT;
			        } else if (!strcmp((yyvsp[0].id), "deprecated")) {
				    (yyval.status) = SMI_STATUS_DEPRECATED;
			        } else if (!strcmp((yyvsp[0].id), "obsolete")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
			        } else {
				    smiPrintError(thisParserPtr,
					          ERR_INVALID_SMIV2_STATUS,
					          (yyvsp[0].id));
				    if (!strcmp((yyvsp[0].id), "mandatory")
				        || !strcmp((yyvsp[0].id), "optional")) {
				        /* best guess */
				        (yyval.status) = SMI_STATUS_CURRENT;
				    } else {
				        (yyval.status) = SMI_STATUS_UNKNOWN;
				    }
			        }
			    } else if (thisModulePtr->export.language != SMI_LANGUAGE_SPPI) {
			        if (!strcmp((yyvsp[0].id), "mandatory")) {
				    (yyval.status) = SMI_STATUS_MANDATORY;
			        } else if (!strcmp((yyvsp[0].id), "optional")) {
				    (yyval.status) = SMI_STATUS_OPTIONAL;
			        } else if (!strcmp((yyvsp[0].id), "obsolete")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
			        } else if (!strcmp((yyvsp[0].id), "deprecated")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
			        } else {
				    smiPrintError(thisParserPtr,
					          ERR_INVALID_SMIV1_STATUS,
					          (yyvsp[0].id));
				    if (!strcmp((yyvsp[0].id), "current")) {
				        /* best guess */
				        (yyval.status) = SMI_STATUS_MANDATORY; 
				    } else {
				        (yyval.status) = SMI_STATUS_UNKNOWN;
				    }
			        }
			    } else { /* it is SPPI */
			        if (!strcmp((yyvsp[0].id), "current")) {
				    (yyval.status) = SMI_STATUS_CURRENT;
			        } else if (!strcmp((yyvsp[0].id), "obsolete")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
			        } else if (!strcmp((yyvsp[0].id), "deprecated")) {
				    (yyval.status) = SMI_STATUS_OBSOLETE;
                                } else {
                                    smiPrintError(thisParserPtr,
                                                  ERR_INVALID_SPPI_STATUS, (yyvsp[0].id));
                                    (yyval.status) = SMI_STATUS_UNKNOWN;
                                }
                            }
			    smiFree((yyvsp[0].id));
			}
#line 7780 "parser-smi.c"
    break;

  case 288: /* Status_Capabilities: LOWERCASE_IDENTIFIER  */
#line 5489 "parser-smi.y"
                        {
			    if (!strcmp((yyvsp[0].id), "current")) {
				(yyval.status) = SMI_STATUS_CURRENT;
			    } else if (!strcmp((yyvsp[0].id), "obsolete")) {
				(yyval.status) = SMI_STATUS_OBSOLETE;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_INVALID_CAPABILITIES_STATUS,
					      (yyvsp[0].id));
				(yyval.status) = SMI_STATUS_UNKNOWN;
			    }
			    smiFree((yyvsp[0].id));
			}
#line 7798 "parser-smi.c"
    break;

  case 289: /* DisplayPart: DISPLAY_HINT Text  */
#line 5505 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			    
			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_FORMAT);
			    }
			}
#line 7811 "parser-smi.c"
    break;

  case 290: /* DisplayPart: %empty  */
#line 5514 "parser-smi.y"
                        {
			    (yyval.text) = NULL;
			}
#line 7819 "parser-smi.c"
    break;

  case 291: /* UnitsPart: UNITS Text  */
#line 5520 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			    
			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_UNITS);
			    }
			}
#line 7832 "parser-smi.c"
    break;

  case 292: /* UnitsPart: %empty  */
#line 5529 "parser-smi.y"
                        {
			    (yyval.text) = NULL;
			}
#line 7840 "parser-smi.c"
    break;

  case 293: /* Access: LOWERCASE_IDENTIFIER  */
#line 5535 "parser-smi.y"
                        {
			    if (thisModulePtr->export.language == SMI_LANGUAGE_SMIV2)
			    {
				if (!strcmp((yyvsp[0].id), "not-accessible")) {
				    (yyval.access) = SMI_ACCESS_NOT_ACCESSIBLE;
				} else if (!strcmp((yyvsp[0].id),
						   "accessible-for-notify")) {
				    (yyval.access) = SMI_ACCESS_NOTIFY;
				} else if (!strcmp((yyvsp[0].id), "read-only")) {
				    (yyval.access) = SMI_ACCESS_READ_ONLY;
				} else if (!strcmp((yyvsp[0].id), "read-write")) {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				} else if (!strcmp((yyvsp[0].id), "read-create")) {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				    thisParserPtr->flags |= FLAG_CREATABLE;
				    /* TODO:remember it's really read-create */
				} else if (!strcmp((yyvsp[0].id), "write-only")) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV2_WRITE_ONLY);
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				} else {
				    smiPrintError(thisParserPtr,
						  ERR_INVALID_SMIV2_ACCESS,
						  (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				}
			    } else if (thisModulePtr->export.language != SMI_LANGUAGE_SPPI) {
				if (!strcmp((yyvsp[0].id), "not-accessible")) {
				    (yyval.access) = SMI_ACCESS_NOT_ACCESSIBLE;
				} else if (!strcmp((yyvsp[0].id), "read-only")) {
				    (yyval.access) = SMI_ACCESS_READ_ONLY;
				} else if (!strcmp((yyvsp[0].id), "read-write")) {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				} else if (!strcmp((yyvsp[0].id), "write-only")) {
				    smiPrintError(thisParserPtr,
						  ERR_SMIV1_WRITE_ONLY);
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				} else {
				    smiPrintError(thisParserPtr,
						  ERR_INVALID_SMIV1_ACCESS,
						  (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				}
			    } else {
			        if (!strcmp((yyvsp[0].id), "install")) {
				    (yyval.access) = SMI_ACCESS_INSTALL;
			        } else if (!strcmp((yyvsp[0].id), "install-notify")) {
				    (yyval.access) = SMI_ACCESS_INSTALL_NOTIFY;
			        } else if (!strcmp((yyvsp[0].id), "notify")) {
				    (yyval.access) = SMI_ACCESS_NOTIFY;
			        } else if (!strcmp((yyvsp[0].id), "report-only")) {
				    (yyval.access) = SMI_ACCESS_REPORT_ONLY;
			        } else if (!strcmp((yyvsp[0].id), "not-accessible")) {
				    (yyval.access) = SMI_ACCESS_NOT_ACCESSIBLE;
                                } else {
				    smiPrintError(thisParserPtr,
					          ERR_INVALID_SPPI_ACCESS,
					          (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
			        }
                            }
			    smiFree((yyvsp[0].id));
			}
#line 7908 "parser-smi.c"
    break;

  case 294: /* $@42: %empty  */
#line 5601 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "PIB-INDEX");
                        }
#line 7917 "parser-smi.c"
    break;

  case 295: /* IndexPart: PIB_INDEX $@42 '{' Entry '}'  */
#line 5606 "parser-smi.y"
                        {
                            List *p = smiMalloc(sizeof(List));
                            
                            p->ptr       = (yyvsp[-1].objectPtr);
                            p->nextPtr   = NULL;
                            
			    (yyval.index).indexkind = SMI_INDEX_INDEX;
			    (yyval.index).implied   = impliedFlag;
			    (yyval.index).listPtr   = p;
			    (yyval.index).rowPtr    = NULL;
                            indexFlag    = INDEXFLAG_PIBINDEX;
			}
#line 7934 "parser-smi.c"
    break;

  case 296: /* IndexPart: AUGMENTS '{' Entry '}'  */
#line 5621 "parser-smi.y"
                        {
			    (yyval.index).indexkind    = SMI_INDEX_AUGMENT;
			    (yyval.index).implied      = 0;
			    (yyval.index).listPtr      = NULL;
			    (yyval.index).rowPtr       = (yyvsp[-1].objectPtr);
                            indexFlag       = INDEXFLAG_AUGMENTS;
			}
#line 7946 "parser-smi.c"
    break;

  case 297: /* $@43: %empty  */
#line 5629 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "EXTENDS");
                        }
#line 7955 "parser-smi.c"
    break;

  case 298: /* IndexPart: EXTENDS $@43 '{' Entry '}'  */
#line 5634 "parser-smi.y"
                        {
			    (yyval.index).indexkind    = SMI_INDEX_SPARSE;
			    (yyval.index).implied      = 0;
			    (yyval.index).listPtr      = NULL;
			    (yyval.index).rowPtr       = (yyvsp[-1].objectPtr);
                            indexFlag       = INDEXFLAG_EXTENDS;
			}
#line 7967 "parser-smi.c"
    break;

  case 299: /* IndexPart: %empty  */
#line 5642 "parser-smi.y"
                        {
			    (yyval.index).indexkind = SMI_INDEX_UNKNOWN;
			}
#line 7975 "parser-smi.c"
    break;

  case 300: /* $@44: %empty  */
#line 5648 "parser-smi.y"
                        {
                            /* 
                             * To avoid ambiguity caused by merging
                             * the SMI and SPPI parser we use a flag.
                             */
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI) {
                                /*
                                 * Only INDEX or AUGMENTS are allowed for SMI
                                 */
                                if (indexFlag != INDEXFLAG_NONE)
                                    smiPrintError(thisParserPtr, ERR_INDEX_AND_AUGMENTS_USED);
                            } else {
                                /*
                                 * INDEX may only be used if PIB_INDEX was used
                                 */
                                if (indexFlag != INDEXFLAG_PIBINDEX)
                                    smiPrintError(thisParserPtr, ERR_INDEX_WITHOUT_PIB_INDEX);
                            }
                            
			    /*
			     * Use a global variable to fetch and remember
			     * whether we have seen an IMPLIED keyword.
			     */
			    impliedFlag = 0;
			}
#line 8005 "parser-smi.c"
    break;

  case 301: /* MibIndex: INDEX $@44 '{' IndexTypes '}'  */
#line 5674 "parser-smi.y"
                        {
			    (yyval.index).indexkind = SMI_INDEX_INDEX;
			    (yyval.index).implied   = impliedFlag;
			    (yyval.index).listPtr   = (yyvsp[-1].listPtr);
			    (yyval.index).rowPtr    = NULL;
                        }
#line 8016 "parser-smi.c"
    break;

  case 302: /* MibIndex: %empty  */
#line 5681 "parser-smi.y"
                        {
			    (yyval.index).indexkind = SMI_INDEX_UNKNOWN;
			}
#line 8024 "parser-smi.c"
    break;

  case 303: /* IndexTypes: IndexType  */
#line 5687 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 8034 "parser-smi.c"
    break;

  case 304: /* IndexTypes: IndexTypes ',' IndexType  */
#line 5694 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 8049 "parser-smi.c"
    break;

  case 305: /* IndexType: IMPLIED Index  */
#line 5707 "parser-smi.y"
                        {
			    impliedFlag = 1;
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8058 "parser-smi.c"
    break;

  case 306: /* IndexType: Index  */
#line 5712 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8066 "parser-smi.c"
    break;

  case 307: /* Index: ObjectName  */
#line 5722 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8074 "parser-smi.c"
    break;

  case 308: /* Entry: ObjectName  */
#line 5728 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8082 "parser-smi.c"
    break;

  case 309: /* DefValPart: DEFVAL '{' Value '}'  */
#line 5734 "parser-smi.y"
                        {
			    /* must not be present in notification variations */
			    if (variationkind == SMI_NODEKIND_NOTIFICATION) {
				smiPrintError(thisParserPtr,
					      ERR_NOTIFICATION_VARIATION_DEFVAL);
			    }
			    (yyval.valuePtr) = (yyvsp[-1].valuePtr);
			    if ((defaultBasetype == SMI_BASETYPE_BITS) &&
				((yyval.valuePtr)->basetype != SMI_BASETYPE_BITS)) {
				smiPrintError(thisParserPtr,
					      ERR_DEFVAL_SYNTAX);
				if ((yyval.valuePtr)->basetype == SMI_BASETYPE_OCTETSTRING) {
				    smiFree((yyval.valuePtr)->value.ptr);
				}
				smiFree((yyval.valuePtr));
				(yyval.valuePtr) = NULL;
			    }
			}
#line 8105 "parser-smi.c"
    break;

  case 310: /* DefValPart: %empty  */
#line 5753 "parser-smi.y"
                        { (yyval.valuePtr) = NULL; }
#line 8111 "parser-smi.c"
    break;

  case 311: /* Value: valueofObjectSyntax  */
#line 5758 "parser-smi.y"
                        { (yyval.valuePtr) = (yyvsp[0].valuePtr); }
#line 8117 "parser-smi.c"
    break;

  case 312: /* Value: '{' BitsValue '}'  */
#line 5760 "parser-smi.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_BITS;
			    (yyval.valuePtr)->value.ptr = (void *)(yyvsp[-1].listPtr);
			}
#line 8127 "parser-smi.c"
    break;

  case 313: /* BitsValue: BitNames  */
#line 5768 "parser-smi.y"
                        { (yyval.listPtr) = (yyvsp[0].listPtr); }
#line 8133 "parser-smi.c"
    break;

  case 314: /* BitsValue: %empty  */
#line 5770 "parser-smi.y"
                        { (yyval.listPtr) = NULL; }
#line 8139 "parser-smi.c"
    break;

  case 315: /* BitNames: LOWERCASE_IDENTIFIER  */
#line 5774 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].id);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 8149 "parser-smi.c"
    break;

  case 316: /* BitNames: BitNames ',' LOWERCASE_IDENTIFIER  */
#line 5780 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].id);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 8164 "parser-smi.c"
    break;

  case 317: /* ObjectName: objectIdentifier  */
#line 5793 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8172 "parser-smi.c"
    break;

  case 318: /* NotificationName: objectIdentifier  */
#line 5799 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8180 "parser-smi.c"
    break;

  case 319: /* ReferPart: REFERENCE Text  */
#line 5805 "parser-smi.y"
                        {
			    (yyval.text) = (yyvsp[0].text);

			    if ((yyvsp[0].text) && !strlen((yyvsp[0].text))) {
				smiPrintError(thisParserPtr,
					      ERR_EMPTY_REFERENCE);
			    }
			}
#line 8193 "parser-smi.c"
    break;

  case 320: /* ReferPart: %empty  */
#line 5814 "parser-smi.y"
                        { (yyval.text) = NULL; }
#line 8199 "parser-smi.c"
    break;

  case 321: /* RevisionPart: Revisions  */
#line 5818 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8205 "parser-smi.c"
    break;

  case 322: /* RevisionPart: %empty  */
#line 5820 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8211 "parser-smi.c"
    break;

  case 323: /* Revisions: Revision  */
#line 5824 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8217 "parser-smi.c"
    break;

  case 324: /* Revisions: Revisions Revision  */
#line 5826 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8223 "parser-smi.c"
    break;

  case 325: /* $@45: %empty  */
#line 5830 "parser-smi.y"
                        {
			    thisParserPtr->firstRevisionLine = thisParserPtr->line;

			    if (thisParserPtr->modulePtr->lastRevisionPtr &&
				((yyvsp[0].date) >= thisParserPtr->modulePtr->lastRevisionPtr->export.date)) {
				smiPrintError(thisParserPtr,
					      ERR_REVISION_NOT_DESCENDING);
			    }

			    if ((yyvsp[0].date) > thisParserPtr->modulePtr->lastUpdated) {
				smiPrintError(thisParserPtr,
					      ERR_REVISION_AFTER_LAST_UPDATE);
			    }
			}
#line 8242 "parser-smi.c"
    break;

  case 326: /* Revision: REVISION ExtUTCTime $@45 DESCRIPTION Text  */
#line 5845 "parser-smi.y"
                        {
			    Revision *revisionPtr;

			    checkDescr(thisParserPtr, (yyvsp[0].text));

			    revisionPtr = addRevision((yyvsp[-3].date), (yyvsp[0].text), thisParserPtr);
			    if (revisionPtr) {
				setRevisionLine(revisionPtr,
						thisParserPtr->firstRevisionLine,
						thisParserPtr);
			    }
			    (yyval.err) = revisionPtr ? 0 : -1;
			}
#line 8260 "parser-smi.c"
    break;

  case 327: /* NotificationObjectsPart: OBJECTS '{' Objects '}'  */
#line 5861 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 8268 "parser-smi.c"
    break;

  case 328: /* NotificationObjectsPart: %empty  */
#line 5865 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 8276 "parser-smi.c"
    break;

  case 329: /* ObjectGroupObjectsPart: OBJECTS '{' Objects '}'  */
#line 5871 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 8284 "parser-smi.c"
    break;

  case 330: /* Objects: Object  */
#line 5877 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 8294 "parser-smi.c"
    break;

  case 331: /* Objects: Objects ',' Object  */
#line 5883 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 8309 "parser-smi.c"
    break;

  case 332: /* Object: ObjectName  */
#line 5896 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			    if ((thisParserPtr->currentDecl == SMI_DECL_OBJECTGROUP) &&
				(yyval.objectPtr)->modulePtr != thisParserPtr->modulePtr) {
                                smiPrintError(thisParserPtr,
					      ERR_COMPLIANCE_MEMBER_NOT_LOCAL,
					      (yyval.objectPtr)->export.name);
			    }
			}
#line 8323 "parser-smi.c"
    break;

  case 333: /* NotificationsPart: NOTIFICATIONS '{' Notifications '}'  */
#line 5908 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 8331 "parser-smi.c"
    break;

  case 334: /* Notifications: Notification  */
#line 5914 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 8341 "parser-smi.c"
    break;

  case 335: /* Notifications: Notifications ',' Notification  */
#line 5920 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 8356 "parser-smi.c"
    break;

  case 336: /* Notification: NotificationName  */
#line 5933 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			    if ((yyval.objectPtr)->modulePtr != thisParserPtr->modulePtr) {
                                smiPrintError(thisParserPtr,
					      ERR_COMPLIANCE_MEMBER_NOT_LOCAL,
					      (yyval.objectPtr)->export.name);
			    }
			}
#line 8369 "parser-smi.c"
    break;

  case 337: /* Text: QUOTED_STRING  */
#line 5944 "parser-smi.y"
                        {
			    int len;
			    (yyval.text) = smiStrdup((yyvsp[0].text));
			    len = strlen((yyval.text));
			    while (len > 0 && (yyval.text)[len-1] == '\n') {
				(yyval.text)[--len] = 0;
			    }
			}
#line 8382 "parser-smi.c"
    break;

  case 338: /* ExtUTCTime: QUOTED_STRING  */
#line 5955 "parser-smi.y"
                        {
			    (yyval.date) = checkDate(thisParserPtr, (yyvsp[0].text));
			}
#line 8390 "parser-smi.c"
    break;

  case 339: /* $@46: %empty  */
#line 5960 "parser-smi.y"
                        {
			    thisParserPtr->parentNodePtr = smiHandle->rootNodePtr;
			}
#line 8398 "parser-smi.c"
    break;

  case 340: /* objectIdentifier: $@46 subidentifiers  */
#line 5964 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			    if ((yyval.objectPtr)) {
				thisParserPtr->parentNodePtr = (yyvsp[0].objectPtr)->nodePtr;
			    } else {
				thisParserPtr->parentNodePtr = NULL;
			    }
			}
#line 8411 "parser-smi.c"
    break;

  case 341: /* subidentifiers: subidentifier  */
#line 5976 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8419 "parser-smi.c"
    break;

  case 342: /* subidentifiers: subidentifiers subidentifier  */
#line 5981 "parser-smi.y"
                        {
			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			}
#line 8427 "parser-smi.c"
    break;

  case 343: /* subidentifier: fuzzy_lowercase_identifier  */
#line 5989 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Import *importPtr;
			    
			    if (thisParserPtr->parentNodePtr != smiHandle->rootNodePtr) {
				smiPrintError(thisParserPtr,
					      ERR_OIDLABEL_NOT_FIRST, (yyvsp[0].id));
			    }
			    objectPtr = findObjectByModuleAndName(
				thisParserPtr->modulePtr, (yyvsp[0].id));
			    if (objectPtr) {
				(yyval.objectPtr) = objectPtr;
				smiFree((yyvsp[0].id));
			    } else {
				importPtr = findImportByName((yyvsp[0].id),
							     thisModulePtr);
				if (!importPtr ||
				    (importPtr->kind == KIND_NOTFOUND)) {
				    /*
				     * If we are in a MODULE-COMPLIANCE
				     * statement with a given MODULE...
				     */
				    if (thisParserPtr->complianceModulePtr) {
					objectPtr =
					    findObjectByModuleAndName(
						thisParserPtr->complianceModulePtr, (yyvsp[0].id));
					if (objectPtr) {
					    importPtr = addImport(
						(yyvsp[0].id),
						thisParserPtr);
					    setImportModulename(importPtr,
								thisParserPtr->complianceModulePtr->export.name);
					    addImportFlags(importPtr,
							   FLAG_INCOMPLIANCE);
					    importPtr->use++;
					} else {
					    objectPtr = addObject((yyvsp[0].id),
								  thisParserPtr->pendingNodePtr, 0,
								  FLAG_INCOMPLETE,
								  thisParserPtr);
					    smiPrintError(thisParserPtr,
							  ERR_IDENTIFIER_NOT_IN_MODULE, (yyvsp[0].id),
							  thisParserPtr->complianceModulePtr->export.name);
					}
				    } else if (thisParserPtr->capabilitiesModulePtr) {
					objectPtr =
					    findObjectByModuleAndName(
						thisParserPtr->capabilitiesModulePtr, (yyvsp[0].id));
					if (objectPtr) {
					    importPtr = addImport(
						(yyvsp[0].id),
						thisParserPtr);
					    setImportModulename(importPtr,
								thisParserPtr->capabilitiesModulePtr->
								export.name);
					    addImportFlags(importPtr,
							   FLAG_INCOMPLIANCE);
					    importPtr->use++;
					} else {
					    objectPtr = addObject((yyvsp[0].id),
								  thisParserPtr->pendingNodePtr, 0,
								  FLAG_INCOMPLETE,
								  thisParserPtr);
					    smiPrintError(thisParserPtr,
							  ERR_IDENTIFIER_NOT_IN_MODULE, (yyvsp[0].id),
							  thisParserPtr->capabilitiesModulePtr->export.name);
					}
				    } else {
					/* 
					 * forward referenced node.
					 * create it,
					 * marked with FLAG_INCOMPLETE.
					 */
					objectPtr = addObject((yyvsp[0].id),
							      thisParserPtr->pendingNodePtr,
							      0,
							      FLAG_INCOMPLETE,
							      thisParserPtr);
				    }
				    (yyval.objectPtr) = objectPtr;
				} else {
				    /*
				     * imported object.
				     */
				    importPtr->use++;
				    (yyval.objectPtr) = findObjectByModulenameAndName(
					importPtr->export.module, (yyvsp[0].id));
				    smiFree((yyvsp[0].id));
				}
			    }
			    if ((yyval.objectPtr))
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			}
#line 8525 "parser-smi.c"
    break;

  case 344: /* subidentifier: moduleName '.' LOWERCASE_IDENTIFIER  */
#line 6083 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Import *importPtr;
			    char *md;
			    
			    if (thisParserPtr->parentNodePtr != smiHandle->rootNodePtr) {
				md = smiMalloc(sizeof(char) *
					       (strlen((yyvsp[-2].id)) + strlen((yyvsp[0].id)) + 2));
				sprintf(md, "%s.%s", (yyvsp[-2].id), (yyvsp[0].id));
				smiPrintError(thisParserPtr,
					      ERR_OIDLABEL_NOT_FIRST, md);
				smiFree(md);
			    } else {
				objectPtr = findObjectByModulenameAndName(
				    (yyvsp[-2].id), (yyvsp[0].id));
				if (objectPtr) {
				    (yyval.objectPtr) = objectPtr;
				    smiFree((yyvsp[-2].id));
				    smiFree((yyvsp[0].id));
				} else {
				    importPtr = findImportByModulenameAndName(
					(yyvsp[-2].id), (yyvsp[0].id), thisModulePtr);
				    if (!importPtr ||
					(importPtr->kind == KIND_NOTFOUND)) {
					/* TODO: check: $1 == thisModule ? */
					/*
					 * If we are in a MODULE-COMPLIANCE
					 * statement with a given MODULE...
					 */
					if (thisParserPtr->complianceModulePtr) {
					    objectPtr =
						findObjectByModuleAndName(
						    thisParserPtr->complianceModulePtr, (yyvsp[-2].id));
					    if (objectPtr) {
						importPtr = addImport(
						    (yyvsp[-2].id),
						    thisParserPtr);
						setImportModulename(importPtr,
						    thisParserPtr->complianceModulePtr->export.name);
						addImportFlags(importPtr,
							       FLAG_INCOMPLIANCE);
						importPtr->use++;
					    } else {
						objectPtr = addObject((yyvsp[-2].id),
						    thisParserPtr->pendingNodePtr, 0,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
						smiPrintError(thisParserPtr,
					      ERR_IDENTIFIER_NOT_IN_MODULE, (yyvsp[-2].id),
					     thisParserPtr->complianceModulePtr->export.name);
					    }
					} else if (thisParserPtr->capabilitiesModulePtr) {
					    objectPtr =
						findObjectByModuleAndName(
						    thisParserPtr->capabilitiesModulePtr, (yyvsp[-2].id));
					    if (objectPtr) {
						importPtr = addImport(
						    (yyvsp[-2].id),
						    thisParserPtr);
						setImportModulename(importPtr,
						        thisParserPtr->capabilitiesModulePtr->
								  export.name);
						addImportFlags(importPtr,
							       FLAG_INCOMPLIANCE);
						importPtr->use++;
					    } else {
						objectPtr = addObject((yyvsp[-2].id),
						    thisParserPtr->pendingNodePtr, 0,
						    FLAG_INCOMPLETE,
						    thisParserPtr);
						smiPrintError(thisParserPtr,
					      ERR_IDENTIFIER_NOT_IN_MODULE, (yyvsp[-2].id),
					   thisParserPtr->capabilitiesModulePtr->export.name);
					    }
					} else {
					    /* 
					     * forward referenced node.
					     * create it,
					     * marked with FLAG_INCOMPLETE.
					     */
					    objectPtr = addObject((yyvsp[0].id),
							    thisParserPtr->pendingNodePtr,
							      0,
							      FLAG_INCOMPLETE,
							      thisParserPtr);
					    smiFree((yyvsp[-2].id));
					}
					(yyval.objectPtr) = objectPtr;
				    } else {
					/*
					 * imported object.
					 */
					importPtr->use++;
					(yyval.objectPtr) = findObjectByModulenameAndName(
					    importPtr->export.module, (yyvsp[0].id));
					smiFree((yyvsp[-2].id));
					smiFree((yyvsp[0].id));
				    }
				}
				if ((yyval.objectPtr))
				    thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    }
			}
#line 8633 "parser-smi.c"
    break;

  case 345: /* subidentifier: NUMBER  */
#line 6187 "parser-smi.y"
                        {
			    Node *nodePtr;
			    Object *objectPtr;

			    nodePtr = findNodeByParentAndSubid(thisParserPtr->parentNodePtr,
							       (yyvsp[0].unsigned32));
			    if (nodePtr && nodePtr->lastObjectPtr &&
	       		(nodePtr->lastObjectPtr->modulePtr == thisModulePtr)) {
				/*
				 * hopefully, the last defined Object for
				 * this Node is the one we expect.
				 */
				(yyval.objectPtr) = nodePtr->lastObjectPtr;
			    } else {
				objectPtr = addObject(NULL,
						      thisParserPtr->parentNodePtr,
						      (yyvsp[0].unsigned32),
						      FLAG_INCOMPLETE,
						      thisParserPtr);
				(yyval.objectPtr) = objectPtr;
			    }
			    thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			}
#line 8661 "parser-smi.c"
    break;

  case 346: /* subidentifier: LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 6211 "parser-smi.y"
                        {
			    Object *objectPtr = NULL;
			    Object *oldObjectPtr = NULL;
			    Node *oldNodePtr = NULL;
			    
			    /* TODO: search in local module and
			     *       in imported modules
			     */

			    oldNodePtr = findNodeByParentAndSubid(
				thisParserPtr->parentNodePtr, (yyvsp[-1].unsigned32));
			    oldObjectPtr = findObjectByModuleAndName(
                                thisParserPtr->modulePtr, (yyvsp[-3].id));

			    if (oldObjectPtr &&
				((oldObjectPtr->nodePtr->subid != (yyvsp[-1].unsigned32)) ||
				 (oldObjectPtr->nodePtr->parentPtr != thisParserPtr->parentNodePtr))) {
				smiPrintError(thisParserPtr,
					      ERR_IDENTIFIER_OID_CHANGED,
					      (yyvsp[-3].id));
				smiPrintErrorAtLine(thisParserPtr,
						    ERR_PREVIOUS_DEFINITION,
						    oldObjectPtr->line,
						    oldObjectPtr->export.name);
				objectPtr = addObject((yyvsp[-3].id),
						      thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0, thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    } else if (oldNodePtr &&
				       oldNodePtr->lastObjectPtr &&
				       oldNodePtr->lastObjectPtr->export.name &&
				       strcmp(oldNodePtr->lastObjectPtr->export.name, (yyvsp[-3].id))) {
				smiPrintError(thisParserPtr,
					      ERR_OIDLABEL_CHANGED,
					      (yyvsp[-3].id), oldNodePtr->lastObjectPtr->export.name);
				smiPrintErrorAtLine(thisParserPtr,
						    ERR_PREVIOUS_DEFINITION,
						    oldNodePtr->lastObjectPtr->line,
						    oldNodePtr->lastObjectPtr->export.name);
				objectPtr = addObject((yyvsp[-3].id),
						      thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0, thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    } else {
				objectPtr = addObject((yyvsp[-3].id), thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0,
						      thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    }
			}
#line 8725 "parser-smi.c"
    break;

  case 347: /* subidentifier: moduleName '.' LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 6271 "parser-smi.y"
                        {
			    Object *objectPtr = NULL;
			    Object *oldObjectPtr = NULL;
			    Node *oldNodePtr = NULL;
			    char *md;

			    md = smiMalloc(sizeof(char) *
					   (strlen((yyvsp[-5].id)) + strlen((yyvsp[-3].id)) + 2));
			    sprintf(md, "%s.%s", (yyvsp[-5].id), (yyvsp[-3].id));

			    oldNodePtr = findNodeByParentAndSubid(
				thisParserPtr->parentNodePtr, (yyvsp[-1].unsigned32));
			    oldObjectPtr = findObjectByModulenameAndName(
                                (yyvsp[-5].id), (yyvsp[-3].id));

			    if (oldObjectPtr &&
				((oldObjectPtr->nodePtr->subid != (yyvsp[-1].unsigned32)) ||
				 (oldObjectPtr->nodePtr->parentPtr != thisParserPtr->parentNodePtr))) {
				smiPrintError(thisParserPtr,
					      ERR_ILLEGALLY_QUALIFIED, md);
				smiPrintError(thisParserPtr,
					      ERR_IDENTIFIER_OID_CHANGED,
					      (yyvsp[-3].id));
				smiPrintErrorAtLine(thisParserPtr,
						    ERR_PREVIOUS_DEFINITION,
						    oldObjectPtr->line,
						    oldObjectPtr->export.name);
				objectPtr = addObject((yyvsp[-3].id),
						      thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0, thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    } else if (oldNodePtr &&
				       oldNodePtr->lastObjectPtr &&
				       strcmp(oldNodePtr->lastObjectPtr->export.name, (yyvsp[-3].id))) {
				smiPrintError(thisParserPtr,
					      ERR_ILLEGALLY_QUALIFIED, md);
				smiPrintError(thisParserPtr,
					      ERR_OIDLABEL_CHANGED,
					      (yyvsp[-3].id), oldNodePtr->lastObjectPtr->export.name);
				smiPrintErrorAtLine(thisParserPtr,
						    ERR_PREVIOUS_DEFINITION,
						    oldNodePtr->lastObjectPtr->line,
						    oldNodePtr->lastObjectPtr->export.name);
				objectPtr = addObject((yyvsp[-3].id),
						      thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0, thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_ILLEGALLY_QUALIFIED, md);
				objectPtr = addObject((yyvsp[-3].id), thisParserPtr->parentNodePtr,
						      (yyvsp[-1].unsigned32), 0,
						      thisParserPtr);
				setObjectDecl(objectPtr,
					      SMI_DECL_IMPL_OBJECT);
				(yyval.objectPtr) = objectPtr;
				thisParserPtr->parentNodePtr = (yyval.objectPtr)->nodePtr;
			    }
			    smiFree(md);
			}
#line 8796 "parser-smi.c"
    break;

  case 348: /* objectIdentifier_defval: subidentifiers_defval  */
#line 6340 "parser-smi.y"
                        { (yyval.text) = NULL; }
#line 8802 "parser-smi.c"
    break;

  case 349: /* subidentifiers_defval: subidentifier_defval  */
#line 6344 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8808 "parser-smi.c"
    break;

  case 350: /* subidentifiers_defval: subidentifiers_defval subidentifier_defval  */
#line 6346 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8814 "parser-smi.c"
    break;

  case 351: /* subidentifier_defval: LOWERCASE_IDENTIFIER '(' NUMBER ')'  */
#line 6350 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8820 "parser-smi.c"
    break;

  case 352: /* subidentifier_defval: NUMBER  */
#line 6352 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 8826 "parser-smi.c"
    break;

  case 353: /* $@47: %empty  */
#line 6356 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_OBJECTGROUP;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 8840 "parser-smi.c"
    break;

  case 354: /* $@48: %empty  */
#line 6366 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;

			    importPtr = findImportByName("OBJECT-GROUP",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "OBJECT-GROUP", "SNMPv2-CONF");
			    }
			}
#line 8861 "parser-smi.c"
    break;

  case 355: /* $@49: %empty  */
#line 6385 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 8869 "parser-smi.c"
    break;

  case 356: /* objectGroupClause: LOWERCASE_IDENTIFIER $@47 OBJECT_GROUP $@48 ObjectGroupObjectsPart STATUS Status DESCRIPTION Text $@49 ReferPart COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 6390 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-14].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-14].id), thisParserPtr);
			    setObjectDecl(objectPtr, SMI_DECL_OBJECTGROUP);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectStatus(objectPtr, (yyvsp[-8].status));
			    setObjectDescription(objectPtr, (yyvsp[-6].text), thisParserPtr);
			    if ((yyvsp[-4].text)) {
				setObjectReference(objectPtr, (yyvsp[-4].text), thisParserPtr);
			    }
			    setObjectAccess(objectPtr,
					    SMI_ACCESS_NOT_ACCESSIBLE);
			    setObjectList(objectPtr, (yyvsp[-10].listPtr));
			    (yyval.err) = 0;
			}
#line 8897 "parser-smi.c"
    break;

  case 357: /* $@50: %empty  */
#line 6416 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_NOTIFICATIONGROUP;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 8911 "parser-smi.c"
    break;

  case 358: /* $@51: %empty  */
#line 6426 "parser-smi.y"
                        {
			    Import *importPtr;
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "NOTIFICATION-GROUP");
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;

			    importPtr = findImportByName("NOTIFICATION-GROUP",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "NOTIFICATION-GROUP",
					      "SNMPv2-CONF");
			    }
			}
#line 8935 "parser-smi.c"
    break;

  case 359: /* $@52: %empty  */
#line 6448 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 8943 "parser-smi.c"
    break;

  case 360: /* notificationGroupClause: LOWERCASE_IDENTIFIER $@50 NOTIFICATION_GROUP $@51 NotificationsPart STATUS Status DESCRIPTION Text $@52 ReferPart COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 6453 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-14].id), &objectPtr);

			    objectPtr = setObjectName(objectPtr, (yyvsp[-14].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_NOTIFICATIONGROUP);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectStatus(objectPtr, (yyvsp[-8].status));
			    setObjectDescription(objectPtr, (yyvsp[-6].text), thisParserPtr);
			    if ((yyvsp[-4].text)) {
				setObjectReference(objectPtr, (yyvsp[-4].text), thisParserPtr);
			    }
			    setObjectAccess(objectPtr,
					    SMI_ACCESS_NOT_ACCESSIBLE);
			    setObjectList(objectPtr, (yyvsp[-10].listPtr));
			    (yyval.err) = 0;
			}
#line 8972 "parser-smi.c"
    break;

  case 361: /* $@53: %empty  */
#line 6480 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_MODULECOMPLIANCE;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 8986 "parser-smi.c"
    break;

  case 362: /* $@54: %empty  */
#line 6490 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;
			    importPtr = findImportByName("MODULE-COMPLIANCE",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "MODULE-COMPLIANCE",
					      "SNMPv2-CONF");
			    }
			}
#line 9007 "parser-smi.c"
    break;

  case 363: /* $@55: %empty  */
#line 6508 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 9015 "parser-smi.c"
    break;

  case 364: /* moduleComplianceClause: LOWERCASE_IDENTIFIER $@53 MODULE_COMPLIANCE $@54 STATUS Status DESCRIPTION Text $@55 ReferPart ComplianceModulePart COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 6514 "parser-smi.y"
                        {
			    Object *objectPtr;
			    Option *optionPtr;
			    Refinement *refinementPtr;
			    List *listPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);

			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-14].id), &objectPtr);

			    setObjectName(objectPtr, (yyvsp[-14].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_MODULECOMPLIANCE);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectStatus(objectPtr, (yyvsp[-9].status));
			    setObjectDescription(objectPtr, (yyvsp[-7].text), thisParserPtr);
			    if ((yyvsp[-5].text)) {
				setObjectReference(objectPtr, (yyvsp[-5].text), thisParserPtr);
			    }
			    setObjectAccess(objectPtr,
					    SMI_ACCESS_NOT_ACCESSIBLE);
			    setObjectList(objectPtr, (yyvsp[-4].compl).mandatorylistPtr);
			    objectPtr->optionlistPtr = (yyvsp[-4].compl).optionlistPtr;
			    objectPtr->refinementlistPtr =
				                          (yyvsp[-4].compl).refinementlistPtr;

			    if ((yyvsp[-4].compl).optionlistPtr) {
				for (listPtr = (yyvsp[-4].compl).optionlistPtr;
				     listPtr;
				     listPtr = listPtr->nextPtr) {
				    optionPtr = ((Option *)(listPtr->ptr));
				    optionPtr->compliancePtr = objectPtr;
				}
			    }

			    /*
			     * Dirty: Fake the types' names in the
			     * refinement list:
			     * ``<compliancename>+<objecttypename>+type''
			     * ``<compliancename>+<objecttypename>+writetype''
			     */
			    if ((yyvsp[-4].compl).refinementlistPtr) {
				for (listPtr = (yyvsp[-4].compl).refinementlistPtr;
				     listPtr;
				     listPtr = listPtr->nextPtr) {
				    refinementPtr =
					((Refinement *)(listPtr->ptr));
				    refinementPtr->compliancePtr = objectPtr;
				}
			    }

			    (yyval.err) = 0;
			}
#line 9076 "parser-smi.c"
    break;

  case 365: /* ComplianceModulePart: ComplianceModules  */
#line 6573 "parser-smi.y"
                        {
			    (yyval.compl) = (yyvsp[0].compl);
			}
#line 9084 "parser-smi.c"
    break;

  case 366: /* ComplianceModules: ComplianceModule  */
#line 6579 "parser-smi.y"
                        {
			    (yyval.compl) = (yyvsp[0].compl);
			}
#line 9092 "parser-smi.c"
    break;

  case 367: /* ComplianceModules: ComplianceModules ComplianceModule  */
#line 6583 "parser-smi.y"
                        {
			    List *listPtr;
			    
			    /* concatenate lists in $1 and $2 */
			    if ((yyvsp[-1].compl).mandatorylistPtr) {
				for (listPtr = (yyvsp[-1].compl).mandatorylistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				listPtr->nextPtr = (yyvsp[0].compl).mandatorylistPtr;
				(yyval.compl).mandatorylistPtr = (yyvsp[-1].compl).mandatorylistPtr;
			    } else {
				(yyval.compl).mandatorylistPtr = (yyvsp[0].compl).mandatorylistPtr;
			    }
			    if ((yyvsp[-1].compl).optionlistPtr) {
				for (listPtr = (yyvsp[-1].compl).optionlistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				listPtr->nextPtr = (yyvsp[0].compl).optionlistPtr;
				(yyval.compl).optionlistPtr = (yyvsp[-1].compl).optionlistPtr;
			    } else {
				(yyval.compl).optionlistPtr = (yyvsp[0].compl).optionlistPtr;
			    }
			    if ((yyvsp[-1].compl).refinementlistPtr) {
				for (listPtr = (yyvsp[-1].compl).refinementlistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				listPtr->nextPtr = (yyvsp[0].compl).refinementlistPtr;
				(yyval.compl).refinementlistPtr = (yyvsp[-1].compl).refinementlistPtr;
			    } else {
				(yyval.compl).refinementlistPtr = (yyvsp[0].compl).refinementlistPtr;
			    }
			}
#line 9129 "parser-smi.c"
    break;

  case 368: /* $@56: %empty  */
#line 6618 "parser-smi.y"
                        {
			    /*
			     * Remember the module. SMIv2 is broken by
			     * design to allow subsequent clauses to
			     * refer identifiers that are not
			     * imported.  Although, SMIv2 does not
			     * require, we will fake it by inserting
			     * appropriate imports.
			     */
			    if ((yyvsp[0].modulePtr) == thisModulePtr)
				thisParserPtr->complianceModulePtr = NULL;
			    else
				thisParserPtr->complianceModulePtr = (yyvsp[0].modulePtr);
			}
#line 9148 "parser-smi.c"
    break;

  case 369: /* ComplianceModule: MODULE ComplianceModuleName $@56 MandatoryPart CompliancePart  */
#line 6634 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = (yyvsp[-1].listPtr);
			    (yyval.compl).optionlistPtr = (yyvsp[0].compl).optionlistPtr;
			    (yyval.compl).refinementlistPtr = (yyvsp[0].compl).refinementlistPtr;
			    if (thisParserPtr->complianceModulePtr) {
				checkImports(thisParserPtr->complianceModulePtr,
					     thisParserPtr);
				thisParserPtr->complianceModulePtr = NULL;
			    }
			}
#line 9163 "parser-smi.c"
    break;

  case 370: /* ComplianceModuleName: UPPERCASE_IDENTIFIER objectIdentifier  */
#line 6647 "parser-smi.y"
                        {
			    (yyval.modulePtr) = findModuleByName((yyvsp[-1].id));
			    /* TODO: handle objectIdentifier */
			    if (!(yyval.modulePtr)) {
				(yyval.modulePtr) = loadModule((yyvsp[-1].id), thisParserPtr);
			    }
			    smiFree((yyvsp[-1].id));
			}
#line 9176 "parser-smi.c"
    break;

  case 371: /* ComplianceModuleName: UPPERCASE_IDENTIFIER  */
#line 6656 "parser-smi.y"
                        {
			    (yyval.modulePtr) = findModuleByName((yyvsp[0].id));
			    if (!(yyval.modulePtr)) {
				(yyval.modulePtr) = loadModule((yyvsp[0].id), thisParserPtr);
			    }
			    smiFree((yyvsp[0].id));
			}
#line 9188 "parser-smi.c"
    break;

  case 372: /* ComplianceModuleName: %empty  */
#line 6665 "parser-smi.y"
                        {
			    (yyval.modulePtr) = thisModulePtr;
			}
#line 9196 "parser-smi.c"
    break;

  case 373: /* MandatoryPart: MANDATORY_GROUPS '{' MandatoryGroups '}'  */
#line 6671 "parser-smi.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 9204 "parser-smi.c"
    break;

  case 374: /* MandatoryPart: %empty  */
#line 6675 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 9212 "parser-smi.c"
    break;

  case 375: /* MandatoryGroups: MandatoryGroup  */
#line 6681 "parser-smi.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].objectPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 9222 "parser-smi.c"
    break;

  case 376: /* MandatoryGroups: MandatoryGroups ',' MandatoryGroup  */
#line 6687 "parser-smi.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].objectPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 9237 "parser-smi.c"
    break;

  case 377: /* MandatoryGroup: objectIdentifier  */
#line 6700 "parser-smi.y"
                        {
			    /* TODO: check that objectIdentifier is
			       found, is defined in thisParserPtr->complianceModulePtr,
			       and is a group node. */
			    Import *importPtr;

			    (yyval.objectPtr) = (yyvsp[0].objectPtr);
			    if (thisParserPtr->complianceModulePtr) {
				(yyval.objectPtr) = findObjectByModuleAndName(
				                           thisParserPtr->complianceModulePtr,
							   (yyvsp[0].objectPtr)->export.name);
			    }
			    if (thisParserPtr->complianceModulePtr && (yyvsp[0].objectPtr)->export.name) {
				importPtr = findImportByModulenameAndName(
				    thisParserPtr->complianceModulePtr->export.name,
				    (yyvsp[0].objectPtr)->export.name, thisModulePtr);
				if (importPtr)
				    importPtr->use++;
			    }
			}
#line 9262 "parser-smi.c"
    break;

  case 378: /* CompliancePart: Compliances  */
#line 6723 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = NULL;
			    (yyval.compl).optionlistPtr = (yyvsp[0].compl).optionlistPtr;
			    (yyval.compl).refinementlistPtr = (yyvsp[0].compl).refinementlistPtr;
			}
#line 9272 "parser-smi.c"
    break;

  case 379: /* CompliancePart: %empty  */
#line 6729 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = NULL;
			    (yyval.compl).optionlistPtr = NULL;
			    (yyval.compl).refinementlistPtr = NULL;
			}
#line 9282 "parser-smi.c"
    break;

  case 380: /* Compliances: Compliance  */
#line 6737 "parser-smi.y"
                        {
			    (yyval.compl) = (yyvsp[0].compl);
			}
#line 9290 "parser-smi.c"
    break;

  case 381: /* Compliances: Compliances Compliance  */
#line 6741 "parser-smi.y"
                        {
			    List *listPtr;
			    int stop;
			    
			    (yyval.compl).mandatorylistPtr = NULL;

			    /* check for duplicates in optionlist */
			    stop = 0;
			    if ((yyvsp[0].compl).optionlistPtr) {
				for (listPtr = (yyvsp[-1].compl).optionlistPtr; listPtr;
				     listPtr = listPtr->nextPtr) {
				    if (((Option *)listPtr->ptr)->objectPtr ==
					((Option *)(yyvsp[0].compl).optionlistPtr->ptr)->objectPtr) {
					smiPrintError(thisParserPtr,
						      ERR_OPTIONALGROUP_ALREADY_EXISTS,
						      ((Option *)(yyvsp[0].compl).optionlistPtr->ptr)->objectPtr->export.name);
					stop = 1;
					(yyval.compl).optionlistPtr = (yyvsp[-1].compl).optionlistPtr;
				    }
				}
			    }
	
                            /* concatenate optionlists */
			    if ((yyvsp[-1].compl).optionlistPtr) {
				for (listPtr = (yyvsp[-1].compl).optionlistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				if (!stop) {
				    listPtr->nextPtr = (yyvsp[0].compl).optionlistPtr;
				}
				(yyval.compl).optionlistPtr = (yyvsp[-1].compl).optionlistPtr;
			    } else {
				(yyval.compl).optionlistPtr = (yyvsp[0].compl).optionlistPtr;
			    }

			    /* check for duplicates in refinementlist */
			    stop = 0;
			    if ((yyvsp[0].compl).refinementlistPtr) {
				for (listPtr = (yyvsp[-1].compl).refinementlistPtr; listPtr;
				     listPtr = listPtr->nextPtr) {
				    if (((Refinement *)listPtr->ptr)->objectPtr ==
					((Refinement *)(yyvsp[0].compl).refinementlistPtr->ptr)->objectPtr) {
					smiPrintError(thisParserPtr,
						      ERR_REFINEMENT_ALREADY_EXISTS,
						      ((Refinement *)(yyvsp[0].compl).refinementlistPtr->ptr)->objectPtr->export.name);
					stop = 1;
					(yyval.compl).refinementlistPtr = (yyvsp[-1].compl).refinementlistPtr;
				    }
				}
			    }
			    
                            /* concatenate refinementlists */
			    if ((yyvsp[-1].compl).refinementlistPtr) {
				for (listPtr = (yyvsp[-1].compl).refinementlistPtr;
				     listPtr->nextPtr;
				     listPtr = listPtr->nextPtr);
				if (!stop) {
				    listPtr->nextPtr = (yyvsp[0].compl).refinementlistPtr;
				}
				(yyval.compl).refinementlistPtr = (yyvsp[-1].compl).refinementlistPtr;
			    } else {
				(yyval.compl).refinementlistPtr = (yyvsp[0].compl).refinementlistPtr;
			    }
			}
#line 9359 "parser-smi.c"
    break;

  case 382: /* Compliance: ComplianceGroup  */
#line 6808 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = NULL;
			    (yyval.compl).optionlistPtr = (yyvsp[0].listPtr);
			    (yyval.compl).refinementlistPtr = NULL;
			}
#line 9369 "parser-smi.c"
    break;

  case 383: /* Compliance: ComplianceObject  */
#line 6814 "parser-smi.y"
                        {
			    (yyval.compl).mandatorylistPtr = NULL;
			    (yyval.compl).optionlistPtr = NULL;
			    (yyval.compl).refinementlistPtr = (yyvsp[0].listPtr);
			}
#line 9379 "parser-smi.c"
    break;

  case 384: /* $@57: %empty  */
#line 6822 "parser-smi.y"
                        {
			    thisParserPtr->firstNestedStatementLine = thisParserPtr->line;
			}
#line 9387 "parser-smi.c"
    break;

  case 385: /* ComplianceGroup: GROUP $@57 objectIdentifier DESCRIPTION Text  */
#line 6827 "parser-smi.y"
                        {
			    Import *importPtr;
			    
			    if (thisParserPtr->complianceModulePtr && (yyvsp[-2].objectPtr)->export.name) {
				importPtr = findImportByModulenameAndName(
						    thisParserPtr->complianceModulePtr->export.name,
						    (yyvsp[-2].objectPtr)->export.name,
						    thisModulePtr);
				if (importPtr)
				    importPtr->use++;
			    }

			    checkDescr(thisParserPtr, (yyvsp[0].text));
			    
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->nextPtr = NULL;
			    (yyval.listPtr)->ptr = smiMalloc(sizeof(Option));
			    ((Option *)((yyval.listPtr)->ptr))->line = thisParserPtr->firstNestedStatementLine;
			    ((Option *)((yyval.listPtr)->ptr))->objectPtr = (yyvsp[-2].objectPtr);
			    if (! (thisModulePtr->flags & SMI_FLAG_NODESCR)) {
				((Option *)((yyval.listPtr)->ptr))->export.description = (yyvsp[0].text);
			    } else {
				smiFree((yyvsp[0].text));
			    }
			}
#line 9417 "parser-smi.c"
    break;

  case 386: /* $@58: %empty  */
#line 6855 "parser-smi.y"
                        {
			    thisParserPtr->firstNestedStatementLine = thisParserPtr->line;
			    variationkind = SMI_NODEKIND_UNKNOWN;
			}
#line 9426 "parser-smi.c"
    break;

  case 387: /* ComplianceObject: OBJECT $@58 ObjectName SyntaxPart WriteSyntaxPart AccessPart DESCRIPTION Text  */
#line 6864 "parser-smi.y"
                        {
			    Import *importPtr;

			    if (thisParserPtr->complianceModulePtr && (yyvsp[-5].objectPtr)->export.name) {
				importPtr = findImportByModulenameAndName(
						    thisParserPtr->complianceModulePtr->export.name,
						    (yyvsp[-5].objectPtr)->export.name,
						    thisModulePtr);
				if (importPtr) 
				    importPtr->use++;
			    }

			    checkDescr(thisParserPtr, (yyvsp[0].text));
			    
			    thisParserPtr->flags &= ~FLAG_CREATABLE;
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->nextPtr = NULL;
			    (yyval.listPtr)->ptr = smiMalloc(sizeof(Refinement));
			    ((Refinement *)((yyval.listPtr)->ptr))->line =
				thisParserPtr->firstNestedStatementLine;
			    ((Refinement *)((yyval.listPtr)->ptr))->objectPtr = (yyvsp[-5].objectPtr);
			    ((Refinement *)((yyval.listPtr)->ptr))->typePtr = (yyvsp[-4].typePtr);
			    if ((yyvsp[-4].typePtr)) {
				(yyvsp[-4].typePtr)->parentPtr = (yyvsp[-5].objectPtr)->typePtr;
			    }
			    ((Refinement *)((yyval.listPtr)->ptr))->writetypePtr = (yyvsp[-3].typePtr);
			    if ((yyvsp[-3].typePtr)) {
				(yyvsp[-3].typePtr)->parentPtr = (yyvsp[-5].objectPtr)->typePtr;
			    }
			    ((Refinement *)((yyval.listPtr)->ptr))->export.access = (yyvsp[-2].access);
			    if (! (thisParserPtr->flags & SMI_FLAG_NODESCR)) {
				((Refinement *)((yyval.listPtr)->ptr))->export.description = (yyvsp[0].text);
			    } else {
				smiFree((yyvsp[0].text));
			    }
			}
#line 9467 "parser-smi.c"
    break;

  case 388: /* SyntaxPart: SYNTAX Syntax  */
#line 6903 "parser-smi.y"
                        {
			    /* must not be present in notification variations */
			    if (variationkind == SMI_NODEKIND_NOTIFICATION) {
				smiPrintError(thisParserPtr,
				      ERR_NOTIFICATION_VARIATION_SYNTAX);
			    }
			    if ((yyvsp[0].typePtr)->export.name) {
				(yyval.typePtr) = duplicateType((yyvsp[0].typePtr), 0, thisParserPtr);
			    } else {
				(yyval.typePtr) = (yyvsp[0].typePtr);
			    }
			}
#line 9484 "parser-smi.c"
    break;

  case 389: /* SyntaxPart: %empty  */
#line 6916 "parser-smi.y"
                        {
			    (yyval.typePtr) = NULL;
			}
#line 9492 "parser-smi.c"
    break;

  case 390: /* WriteSyntaxPart: WRITE_SYNTAX WriteSyntax  */
#line 6922 "parser-smi.y"
                        {
                            /* must not be present in PIBs */
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI) {
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "WRITE-SYNTAX");
			    }
			    /* must not be present in notification variations */
			    if (variationkind == SMI_NODEKIND_NOTIFICATION) {
				smiPrintError(thisParserPtr,
				      ERR_NOTIFICATION_VARIATION_WRITESYNTAX);
			    }
			    if ((yyvsp[0].typePtr)->export.name) {
				(yyval.typePtr) = duplicateType((yyvsp[0].typePtr), 0, thisParserPtr);
			    } else {
				(yyval.typePtr) = (yyvsp[0].typePtr);
			    }
			}
#line 9513 "parser-smi.c"
    break;

  case 391: /* WriteSyntaxPart: %empty  */
#line 6939 "parser-smi.y"
                        {
			    (yyval.typePtr) = NULL;
			}
#line 9521 "parser-smi.c"
    break;

  case 392: /* WriteSyntax: Syntax  */
#line 6945 "parser-smi.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 9529 "parser-smi.c"
    break;

  case 393: /* AccessPart: MIN_ACCESS Access  */
#line 6951 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "MIN-ACCESS");
			    (yyval.access) = (yyvsp[0].access);
			}
#line 9539 "parser-smi.c"
    break;

  case 394: /* AccessPart: PIB_MIN_ACCESS Access  */
#line 6957 "parser-smi.y"
                        {
                            if (thisParserPtr->modulePtr->export.language != SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SPPI_CONSTRUCT_IN_MIB, "PIB-MIN-ACCESS");
                            if ((yyvsp[0].access) == SMI_ACCESS_REPORT_ONLY)
                                smiPrintError(thisParserPtr, ERR_REPORT_ONLY_IN_PIB_MIN_ACCESS);
                            (yyval.access) = (yyvsp[0].access);
                        }
#line 9551 "parser-smi.c"
    break;

  case 395: /* AccessPart: %empty  */
#line 6965 "parser-smi.y"
                        {
			    (yyval.access) = SMI_ACCESS_UNKNOWN;
			}
#line 9559 "parser-smi.c"
    break;

  case 396: /* $@59: %empty  */
#line 6971 "parser-smi.y"
                        {
			    thisParserPtr->firstStatementLine = thisParserPtr->line;
			    thisParserPtr->currentDecl = SMI_DECL_AGENTCAPABILITIES;
			    
			    checkNameLen(thisParserPtr, (yyvsp[0].id),
					 ERR_OIDNAME_32, ERR_OIDNAME_64);
			    smiCheckObjectName(thisParserPtr,
					       thisModulePtr, (yyvsp[0].id));
			}
#line 9573 "parser-smi.c"
    break;

  case 397: /* $@60: %empty  */
#line 6981 "parser-smi.y"
                        {
			    Import *importPtr;
                            if (thisParserPtr->modulePtr->export.language == SMI_LANGUAGE_SPPI)
                                smiPrintError(thisParserPtr, ERR_SMI_CONSTRUCT_IN_PIB, "AGENT-CAAPABILITIES");
			    
			    if (thisModulePtr->export.language == SMI_LANGUAGE_UNKNOWN)
				thisModulePtr->export.language = SMI_LANGUAGE_SMIV2;

			    importPtr = findImportByName("AGENT-CAPABILITIES",
							 thisModulePtr);
			    if (importPtr) {
				importPtr->use++;
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_MACRO_NOT_IMPORTED,
					      "AGENT-CAPABILITIES",
					      "SNMPv2-CONF");
			    }
			}
#line 9597 "parser-smi.c"
    break;

  case 398: /* $@61: %empty  */
#line 7003 "parser-smi.y"
                        {
			    checkDescr(thisParserPtr, (yyvsp[0].text));
			}
#line 9605 "parser-smi.c"
    break;

  case 399: /* agentCapabilitiesClause: LOWERCASE_IDENTIFIER $@59 AGENT_CAPABILITIES $@60 PRODUCT_RELEASE Text STATUS Status_Capabilities DESCRIPTION Text $@61 ReferPart ModulePart_Capabilities COLON_COLON_EQUAL '{' objectIdentifier '}'  */
#line 7009 "parser-smi.y"
                        {
			    Object *objectPtr;
			    
			    objectPtr = (yyvsp[-1].objectPtr);
			    
			    smiCheckObjectReuse(thisParserPtr, (yyvsp[-16].id), &objectPtr);

			    setObjectName(objectPtr, (yyvsp[-16].id), thisParserPtr);
			    setObjectDecl(objectPtr,
					  SMI_DECL_AGENTCAPABILITIES);
			    setObjectLine(objectPtr, thisParserPtr->firstStatementLine,
					  thisParserPtr);
			    addObjectFlags(objectPtr, FLAG_REGISTERED);
			    deleteObjectFlags(objectPtr, FLAG_INCOMPLETE);
			    setObjectStatus(objectPtr, (yyvsp[-9].status));
			    setObjectDescription(objectPtr, (yyvsp[-7].text), thisParserPtr);
			    if ((yyvsp[-5].text)) {
				setObjectReference(objectPtr, (yyvsp[-5].text), thisParserPtr);
			    }
			    setObjectAccess(objectPtr,
					    SMI_ACCESS_NOT_ACCESSIBLE);
				/*
				 * TODO: PRODUCT_RELEASE Text
				 * TODO: ModulePart_Capabilities
				 */
			    (yyval.err) = 0;
			}
#line 9637 "parser-smi.c"
    break;

  case 400: /* ModulePart_Capabilities: Modules_Capabilities  */
#line 7039 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9643 "parser-smi.c"
    break;

  case 401: /* ModulePart_Capabilities: %empty  */
#line 7041 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9649 "parser-smi.c"
    break;

  case 402: /* Modules_Capabilities: Module_Capabilities  */
#line 7045 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9655 "parser-smi.c"
    break;

  case 403: /* Modules_Capabilities: Modules_Capabilities Module_Capabilities  */
#line 7047 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9661 "parser-smi.c"
    break;

  case 404: /* $@62: %empty  */
#line 7051 "parser-smi.y"
                        {
			    /*
			     * Remember the module. SMIv2 is broken by
			     * design to allow subsequent clauses to
			     * refer identifiers that are not
			     * imported.  Although, SMIv2 does not
			     * require, we will fake it by inserting
			     * appropriate imports.
			     */
			    if ((yyvsp[0].modulePtr) == thisModulePtr)
				thisParserPtr->capabilitiesModulePtr = NULL;
			    else
				thisParserPtr->capabilitiesModulePtr = (yyvsp[0].modulePtr);
			}
#line 9680 "parser-smi.c"
    break;

  case 405: /* Module_Capabilities: SUPPORTS ModuleName_Capabilities $@62 INCLUDES '{' CapabilitiesGroups '}' VariationPart  */
#line 7067 "parser-smi.y"
                        {
			    if (thisParserPtr->capabilitiesModulePtr) {
				checkImports(thisParserPtr->capabilitiesModulePtr,
					     thisParserPtr);
				thisParserPtr->capabilitiesModulePtr = NULL;
			    }
			    (yyval.err) = 0;
			}
#line 9693 "parser-smi.c"
    break;

  case 406: /* CapabilitiesGroups: CapabilitiesGroup  */
#line 7078 "parser-smi.y"
                        {
#if 0
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].listPtr);
			    (yyval.listPtr)->nextPtr = NULL;
#else
			    (yyval.listPtr) = NULL;
#endif
			}
#line 9707 "parser-smi.c"
    break;

  case 407: /* CapabilitiesGroups: CapabilitiesGroups ',' CapabilitiesGroup  */
#line 7088 "parser-smi.y"
                        {
#if 0
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].listPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-2].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
#else
			    (yyval.listPtr) = NULL;
#endif
			}
#line 9726 "parser-smi.c"
    break;

  case 408: /* CapabilitiesGroup: objectIdentifier  */
#line 7105 "parser-smi.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 9734 "parser-smi.c"
    break;

  case 409: /* ModuleName_Capabilities: UPPERCASE_IDENTIFIER objectIdentifier  */
#line 7111 "parser-smi.y"
                        {
			    (yyval.modulePtr) = findModuleByName((yyvsp[-1].id));
			    /* TODO: handle objectIdentifier */
			    if (!(yyval.modulePtr)) {
				(yyval.modulePtr) = loadModule((yyvsp[-1].id), thisParserPtr);
			    }
			    smiFree((yyvsp[-1].id));
			}
#line 9747 "parser-smi.c"
    break;

  case 410: /* ModuleName_Capabilities: UPPERCASE_IDENTIFIER  */
#line 7120 "parser-smi.y"
                        {
			    (yyval.modulePtr) = findModuleByName((yyvsp[0].id));
			    if (!(yyval.modulePtr)) {
				(yyval.modulePtr) = loadModule((yyvsp[0].id), thisParserPtr);
			    }
			    smiFree((yyvsp[0].id));
			}
#line 9759 "parser-smi.c"
    break;

  case 411: /* VariationPart: Variations  */
#line 7130 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9765 "parser-smi.c"
    break;

  case 412: /* VariationPart: %empty  */
#line 7132 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9771 "parser-smi.c"
    break;

  case 413: /* Variations: Variation  */
#line 7136 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9777 "parser-smi.c"
    break;

  case 414: /* Variations: Variations Variation  */
#line 7138 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9783 "parser-smi.c"
    break;

  case 415: /* $@63: %empty  */
#line 7142 "parser-smi.y"
                        {
			    if ((yyvsp[0].objectPtr)) {
				variationkind = (yyvsp[0].objectPtr)->export.nodekind;
			    } else {
				variationkind = SMI_NODEKIND_UNKNOWN;
			    }
			}
#line 9795 "parser-smi.c"
    break;

  case 416: /* $@64: %empty  */
#line 7154 "parser-smi.y"
                        {
			    if ((yyvsp[0].valuePtr)) {
				adjustDefval(thisParserPtr,
					     (yyvsp[0].valuePtr), (yyvsp[-6].objectPtr)->typePtr,
					     thisParserPtr->line);
				smiCheckValueType(thisParserPtr,
						  (yyvsp[0].valuePtr), (yyvsp[-6].objectPtr)->typePtr,
						  thisParserPtr->line);
			    }
			}
#line 9810 "parser-smi.c"
    break;

  case 417: /* Variation: VARIATION ObjectName $@63 SyntaxPart WriteSyntaxPart VariationAccessPart CreationPart DefValPart $@64 DESCRIPTION Text  */
#line 7165 "parser-smi.y"
                        {
			    thisParserPtr->flags &= ~FLAG_CREATABLE;
			    (yyval.err) = 0;
			    variationkind = SMI_NODEKIND_UNKNOWN;

			    checkDescr(thisParserPtr, (yyvsp[-1].id));
			}
#line 9822 "parser-smi.c"
    break;

  case 418: /* VariationAccessPart: ACCESS VariationAccess  */
#line 7175 "parser-smi.y"
                        { (yyval.access) = (yyvsp[0].access); }
#line 9828 "parser-smi.c"
    break;

  case 419: /* VariationAccessPart: %empty  */
#line 7177 "parser-smi.y"
                        { (yyval.access) = 0; }
#line 9834 "parser-smi.c"
    break;

  case 420: /* VariationAccess: LOWERCASE_IDENTIFIER  */
#line 7181 "parser-smi.y"
                        {
			    if (!strcmp((yyvsp[0].id), "not-implemented")) {
				(yyval.access) = SMI_ACCESS_NOT_IMPLEMENTED;
			    } else if (!strcmp((yyvsp[0].id), "accessible-for-notify")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_NOTIFY;
				}
			    } else if (!strcmp((yyvsp[0].id), "read-only")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_READ_ONLY;
				}
			    } else if (!strcmp((yyvsp[0].id), "read-write")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				}
			    } else if (!strcmp((yyvsp[0].id), "read-create")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_READ_WRITE;
				}
			    } else if (!strcmp((yyvsp[0].id), "write-only")) {
				if (variationkind ==
				    SMI_NODEKIND_NOTIFICATION) {
				    smiPrintError(thisParserPtr,
				     ERR_INVALID_NOTIFICATION_VARIATION_ACCESS,
					       (yyvsp[0].id));
				    (yyval.access) = SMI_ACCESS_UNKNOWN;
				} else {
				    (yyval.access) = SMI_ACCESS_READ_WRITE; /* TODO */
				    smiPrintError(thisParserPtr,
					       ERR_SMIV2_WRITE_ONLY);
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_INVALID_VARIATION_ACCESS,
					      (yyvsp[0].id));
				(yyval.access) = SMI_ACCESS_UNKNOWN;
			    }
			}
#line 9901 "parser-smi.c"
    break;

  case 421: /* CreationPart: CREATION_REQUIRES '{' Cells '}'  */
#line 7246 "parser-smi.y"
                        {
			    /* must not be present in notification variations */
			    if (variationkind == SMI_NODEKIND_NOTIFICATION) {
				smiPrintError(thisParserPtr,
				      ERR_NOTIFICATION_VARIATION_CREATION);
			    }
			    (yyval.err) = 0;
			}
#line 9914 "parser-smi.c"
    break;

  case 422: /* CreationPart: %empty  */
#line 7255 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9920 "parser-smi.c"
    break;

  case 423: /* Cells: Cell  */
#line 7259 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9926 "parser-smi.c"
    break;

  case 424: /* Cells: Cells ',' Cell  */
#line 7261 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9932 "parser-smi.c"
    break;

  case 425: /* Cell: ObjectName  */
#line 7265 "parser-smi.y"
                        { (yyval.err) = 0; }
#line 9938 "parser-smi.c"
    break;


#line 9942 "parser-smi.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (parserPtr, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parserPtr);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, parserPtr);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (parserPtr, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parserPtr);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, parserPtr);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 7268 "parser-smi.y"


#endif
